/* ================================================================= */
/* ======= LANSA GENERATED OAM (OBJECT ACCESS MODULE) ============== */
/* ================================================================= */
/* OS/Dependencies     : No                                          */
/* End User Modifiable : Not Recommended                             */
/* Description         : LANSA OAM for table %tablexxxx              */
/*                       defined in library %fulllibxx               */
/* Collection          : %libraryxx                                  */
/* Created by user     : %userids                                    */
/* Date/Time created   : %datexxxxxxxxxxxxxxxxxxx                    */
/* Generated by        : LANSA                                       */
/*                                                                   */
/* Amendment History   :                                             */
/*                                                                   */
/* Task Id  Date    Description                                      */
/* =======  ====    ===========                                      */
/*        %DDMMYY   Generation by LANSA (the rest of this line is not output by the generator)
*/
/*                                                                   */
/* ================================================================= */
/* Definition of internal function types by type of compiler         */
/*===================================================================*/

#if !defined(X_ALLOW_10_0_STRUCTURES)
#define X_ALLOW_10_0_STRUCTURES
#endif

#if defined(X_16BIT_COMPILER)
   #define O_VOID_FUNCTION       X_VOID_FUNCTION
   #define O_CHAR_FUNCTION       X_CHAR_FUNCTION
   #define O_BOOL_FUNCTION       X_BOOL_FUNCTION
   #if defined(X_MODULE_COMPONENT_MAIN)
      #define O_GLOBAL_VARIABLE
      #define O_GLOBAL_POINTER_INIT = pX_NULL
      #define O_GLOBAL_COUNT_INIT   = 0
   #else
      #define O_GLOBAL_VARIABLE       extern
      #define O_GLOBAL_POINTER_INIT
      #define O_GLOBAL_COUNT_INIT
   #endif
#else
   #define O_VOID_FUNCTION       static X_VOID_INTERNAL_FUNCTION
   #define O_CHAR_FUNCTION       static X_CHAR_INTERNAL_FUNCTION
   #define O_BOOL_FUNCTION       static X_BOOL_INTERNAL_FUNCTION
   #define O_SHORT_FUNCTION      static X_SHORT_INTERNAL_FUNCTION
   #define O_GLOBAL_VARIABLE     static
   #define O_GLOBAL_POINTER_INIT = pX_NULL
   #define O_GLOBAL_COUNT_INIT = 0
#endif

#define COMMIT_LEVEL 150

/* Macros to support turning off commitment control when executing */
/* certain statements against DB2 for iSeries.                     */

#define AVOID_JOURNALING(_STMT) \
   if ( X_DBMS_INFO_USE_NATIVE_CMTCTL ) \
      strcat(_STMT," WITH NC");

#define AVOID_LOCKING_ON_READ(_STMT) \
   if ( X_DBMS_INFO_USE_NATIVE_CMTCTL ) \
      strcat(_STMT," WITH NC");

#define AVOID_COMMIT X_DBMS_INFO_USE_NATIVE_CMTCTL

/* Macro to support turning off triggers when executing */
/* LOAD_FILE_DATA and UNLOAD_FILE_DATA BIFS             */

#define X_DBM_EXEC_TRIGGER(_REQUEST) \
   (( _REQUEST == X_DBM_LOAD_DATA && pX_DBM->chTrigger == YES ) || \
    ( _REQUEST != X_DBM_LOAD_DATA && _REQUEST != X_DBM_UNLOAD_DATA ))

/* ================================================================= */
/* Standard #include area                                            */
/* ================================================================= */

#include <string.h>
#include <stdio.h>

#if defined(X_OPERATING_SYSTEM_ISERIES)
#include <stdlib.h>
#endif

#include "x_glodef.h"
#include "x_glousr.h"
#include "x_dbmstr.h"
#include "x_funstr.h"
#include "x_funpro.h"
#include "x_dbmpro.h"
#include "x_pdfpro.h"
#include "x_oidstr.h"
#include "x_comstr.h"
#include "x_varstr.h"
#include "x_varpro.h"

#ifdef X_WARNINGS
/* 4101: unreferenced local variable */
/* 4102: unreferenced label          */
#pragma warning (disable : 4101 4102)
#endif

X_VOID_FUNCTION X_BuiltIn_010 (struct X_IDS *,
                               struct X_PRO *,
                               struct X_FUN *,
                               struct X_BIF *,
                               struct X_FLD [],
                               struct X_LIST[],
                               X_SHORT,
                               X_SHORT [],
                               X_SHORT,
                               X_SHORT []);

#if defined(X_OPERATING_SYSTEM_ISERIES)
#pragma map(GetPermFilOvriSeries, "M@PEROVR")
#pragma linkage(GetPermFilOvriSeries, OS, nowiden)
void GetPermFilOvriSeries(struct X_IDS_RPG *,
                          struct X_EDS_RPG *,
                          X_PFCHAR,
                          X_PFCHAR);
#endif


#include %utext
#include %hspec

/* ================================================================= */
/* Field indexing structure and variables                            */
/* ================================================================= */

typedef struct X_DBM_FLDINDEX
{

   struct X_FUN          * pX_FunCaller;
   X_SHORT                 sSequence;
   X_CHAR                  X_DBM_FldsUsed[X_TOTAL_FIELDS];
   X_SHORT                 X_DBM_FldsIndex[X_TOTAL_FIELDS];
   X_CHAR                * X_DBM_WhereFldsUsed;
   X_SHORT               * X_DBM_WhereFldsIndex;
   X_PYES_NO               X_DBM_UsedGrpFlds; /* Size is pX_DBM->scGrpFlds */
   struct X_DBM_FLDINDEX * pNextFldIndex;
};

O_GLOBAL_VARIABLE struct X_DBM_FLDINDEX *pFirstFldIndex O_GLOBAL_POINTER_INIT;

typedef struct X_DBM_UPDATED_STATEMENT
{
   X_BOOL      fAllocated;
   X_PVCHAR    pvchSelect;
   X_PVCHAR    pvchOrder;
   X_PVCHAR    pvchBckOrd;
   X_PVCHAR    pvchRRN;
};

#define GET_STMNT_SELECT   1
#define GET_STMNT_ORDER    2
#define GET_STMNT_BCKORD   3
#define GET_STMNT_RRN      4

#define AUTHORITY_READ_CHECK     0x0001
#define AUTHORISED_READ          0x0002
#define AUTHORITY_INSERT_CHECK   0x0004
#define AUTHORISED_INSERT        0x0008
#define AUTHORITY_UPDATE_CHECK   0x0010
#define AUTHORISED_UPDATE        0x0020
#define AUTHORITY_DELETE_CHECK   0x0040
#define AUTHORISED_DELETE        0x0080

typedef struct 
{
   X_SQLDA     *pSqlda;
   X_TYPE_FLAG  chType;
} SQLDA_INFO;

%pjfstruct

/* ================================================================= */
/* Global Information variables                                      */
/* ================================================================= */

#if !defined(X_DBM_NO_PKEY) && defined(X_DBM_NO_RRNO_COLUMN)
#define X_OAM_REPLACE_RRN_WITH_PKEY_REQUIRED 
#endif

#if !defined(X_DBM_NO_RRNO_COLUMN) || !defined(X_DBM_ISERIESOTHER)
#define X_OAM_UPID_REQUIRED
#endif

#if defined(X_DBM_NO_RRNO_COLUMN) || defined(X_DBM_ISERIESOTHER)
#define X_OAM_SAVE_CURR_RECORD_REQUIRED
#endif

struct GLOBAL_INFO
{
   SQLDA_INFO aSqlda[X_MAX_SQLDA];
   X_USHORT     usMaxSqlda;
   %BchSQLDA
   struct X_FUN * pFunctionOpening;
   struct X_PRO * pProcessOpening;
   X_YES_NO chFirstCall;
   X_SHORT  sSaveRequest;
   X_VCHAR  vchSqlStmnt[65535 + (X_TOTAL_COLUMN_NAME_LEN * 3)];
   X_YES_NO chAuthorised;
   X_YES_NO chReadAuthChecked;
   X_YES_NO chInsertAuthChecked;
   X_YES_NO chUpdateAuthChecked;
   X_YES_NO chDeleteAuthChecked;
   struct   X_TRIGGER X_Trigger;                                  %ifatrg
   struct   X_PARM T_Parm[1];                                     %ifatrg
   X_SHORT  sLastRequest;                                         %ifatrg
   X_YES_NO chAllKeys;
   X_SHORT  sLang;
   X_LONG   lFetchCode;
   X_LONG   lReturnCode;
   X_SHORT  sFileNo;
   X_DOUBLE dLastRRNO[X_DBM_FILE_NAME_NUMBER]; /* Always needed if iSeries DB */
#ifdef X_OAM_UPID_REQUIRED
   X_DOUBLE dLastUPID[X_DBM_FILE_NAME_NUMBER];
   X_DOUBLE dThisUPID;
#endif
   struct X_BIF X_Bif;                                            %ifvc
   struct X_BIF *pX_Bif;                                          %ifvc
   struct X_LIST X_List;                                          %ifvc
   struct X_LIST *pX_List;                                        %ifvc
   struct X_FLD  *pX_Fld;
   struct X_DBM_FLDMAP *pX_Curr;
   struct X_FLD  *pX_FldPrev;                                     %ifprev
   struct X_DBM_FLDMAP *pX_Prev;                                  %ifprev
   X_DICTIONARY_PACKED *pX_RRNO;
   %BchPtr
   struct X_DBM_FLDINDEX *pCurrFldIndex;
   %PJFPtr
   X_VCHAR vchFirstDBMSType[X_CTD_VALUE_LENGTH + 1];
   struct X_DBM_FLDINDEX *pWhereFldIndex;
#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   X_BOOL   fLastSaved[X_DBM_FILE_NAME_NUMBER];   /* Flags data & pkey saved */
   struct X_DBM_FLDMAP * pLastRec[X_DBM_FILE_NAME_NUMBER]; /* Equiv dLastRRNO, dLastUPID */
   struct X_DBM_SAVED_X_VAR * pLastRecX_VAR[X_DBM_FILE_NAME_NUMBER]; %ifxvar
#endif
   struct   X_DBM_UPDATED_STATEMENT UpdatedStmnt[X_DBM_FILE_NAME_NUMBER];
   %NtvPtr
#if defined(X_OPERATING_SYSTEM_ISERIES)
   X_BOOL   fUseNativeIO_Save;
#endif
   X_PVCHAR pvchTable;                                            %iflob
   X_VCHAR  vchLOBSqlStmnt[2000];                                 %iflob
   %lobglobals
   X_VCHAR  vchLOBFile[X_OBJECT_NAME_LEN + 1];                    %iflob
};

O_GLOBAL_VARIABLE struct GLOBAL_INFO Global_Info;

O_GLOBAL_VARIABLE X_ULONG lEntryCount O_GLOBAL_COUNT_INIT;

#if defined(X_OPERATING_SYSTEM_WIN31)
O_GLOBAL_VARIABLE struct X_GENERIC_INSTANCE *pRootGI O_GLOBAL_POINTER_INIT;
#endif

#ifdef X_DBM_IDENTITY_COLUMN
O_GLOBAL_VARIABLE X_BOOL fIdentity = TRUE;
#else
O_GLOBAL_VARIABLE X_BOOL fIdentity O_GLOBAL_COUNT_INIT;
#endif

#ifdef X_DBM_AUTO_RRNO
O_GLOBAL_VARIABLE X_BOOL fAutoRRN = TRUE;
#else
O_GLOBAL_VARIABLE X_BOOL fAutoRRN O_GLOBAL_COUNT_INIT;
#endif

O_GLOBAL_VARIABLE X_BOOL fInternalNames O_GLOBAL_COUNT_INIT;

O_GLOBAL_VARIABLE X_LONG lDummyRetcode O_GLOBAL_COUNT_INIT;

O_GLOBAL_VARIABLE struct _X_DBM_INSERT_RRN_PARMS InsertRRNParms; /* Always needed if iSeries DB */

O_GLOBAL_VARIABLE X_FLD_CHAR  VarCharTemp;

O_GLOBAL_VARIABLE X_BOOL fDateTime = FALSE;                           %ifdtts

O_GLOBAL_VARIABLE X_VCHAR vchBaseLOBDir[X_MAX_SIZE_LOB_FILE_NAME + 1] = "";            %iflob
O_GLOBAL_VARIABLE X_SHORT X_DBM_Select_LOBColumns[] = { 2 };                           %iflob

O_GLOBAL_VARIABLE X_BOOL fHasRRNO = TRUE;
O_GLOBAL_VARIABLE X_BOOL fHasUPID = TRUE;

#define X_OAM_UNLOAD_LOBS(_PXDBM) (_PXDBM->chWithRRNO == YES)

#define X_OAM_LOAD_CLEANUP(_PXDBM) (_PXDBM->chWhereRDML == YES)

#define X_OAM_MISSING_LOB_HANDLING(_PXDBM) (_PXDBM->chWithRRNO)

#define X_OAM_ADD_WHERE(_FROMSTMT,_TOSTMT) \
{ \
   X_PVCHAR pvchTemp = strstr( _FROMSTMT, " WHERE" ); \
   if ( !pvchTemp ) pvchTemp = strstr( _FROMSTMT, " ORDER BY" ); \
   if ( pvchTemp ) \
   { \
      if ( strlen(pvchTemp) > (sizeof(_TOSTMT) - 1) ) \
      { \
         X_Fatal_Error(pX_Ids, \
                       pX_Pro, \
                       pX_Fun, \
                       "OAM for table %tablexxxx", \
                       X_TEXT(273)); \
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR); \
      } \
      else \
      { \
         strcat(_TOSTMT,pvchTemp); \
      } \
   } \
}

#if defined(X_OAM_HAS_LOB_SUPPORT)

#define X_OAM_UNLOAD_SET_PATH(_FIELD) sprintf(vchLOBDir,"%s%s_%s_",vchBaseLOBDir,pG->vchLOBFile,_FIELD);

#define X_OAM_HANDLE_LOW_CURSORID(_CURSORID,_MAXCURSORVAL,_FIELD) \
      if ( _CURSORID < _MAXCURSORVAL ) \
      { \
         X_Fatal_Error(pX_Ids, \
                       pX_Pro, \
                       pX_Fun, \
                       "OAM for table OTHERLOBF ", \
                       "Unable to retrieve LOB cursor for field %s. Return code %d", \
                       _FIELD, \
                       _CURSORID); \
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR); \
\
         if ( (pX_DBM->sDBMRequest != X_DBM_UNLOAD_DATA) && (pX_DBM->chWhereRDML == NO)) \
         { \
            X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS); \
         } \
         return; \
      }


#define X_OAM_SET_LOB_CURSOR_ID_TREE(_FIELD,_CURSORID,_CURR_ENTRY,_TREE_ENTRY,_MAXCURSORVAL) \
      _CURSORID = X_RetrieveLOBCursorDetails( pX_Ids,pX_Pro,pX_Fun,pX_DBM,X_File_Header.vchTable,_FIELD,_CURR_ENTRY,&(_TREE_ENTRY) ); \
      X_OAM_HANDLE_LOW_CURSORID(_CURSORID,_MAXCURSORVAL,_FIELD)

#define X_OAM_SET_LOB_CURSOR_ID(_FIELD,_CURSORID,_CURR_ENTRY,_MAXCURSORVAL) \
      _CURSORID = X_RetrieveLOBCursorDetails( pX_Ids,pX_Pro,pX_Fun,pX_DBM,X_File_Header.vchTable,_FIELD,_CURR_ENTRY,pX_NULL ); \
      X_OAM_HANDLE_LOW_CURSORID(_CURSORID,_MAXCURSORVAL,_FIELD)


/* SelectFlds_##_LOBFLDNAME must be copied into */
/* pG->vchLOBSqlStmnt before calling this macro.*/
#define X_OAM_ALLOCATE_LOB_SQLDA(_LOBFLDNAME) \
   { \
      if ( !(pG->pSqlda##_LOBFLDNAME) ) \
      { \
         X_DBM_ALLOC_SQLDA_2_PARMS AllocSqldaParms; \
         AllocSqldaParms.pvchSqlStmnt = pG->vchLOBSqlStmnt; \
         AllocSqldaParms.ppSqlda      = &(pG->pSqlda##_LOBFLDNAME); \
         AllocSqldaParms.fRDMLXFile   = TRUE; /* Always true if LOB fields */ \
         AllocSqldaParms.scLOBColumns = 1; /* Always only 1 LOB column per SELECT */ \
         AllocSqldaParms.psLOBColumns = X_DBM_Select_LOBColumns; \
         X_DBM_OP( pG->lReturnCode, X_DBM_ALLOCATE_SQLDA_2, pX_NULL, 0, &AllocSqldaParms ); \
         if (pG->lReturnCode != X_DBMS_INFO_OKAY) \
         { \
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR); \
            pX_Ids->lLastErrorCode = pG->lReturnCode; \
            return; \
         } \
      } \
   }

#define X_OAM_LOB_FETCH_INITIAL(_LOBFLDNAME,_FIELD,_CURRENT) \
   if ( pCurr->X_DBM_FldsUsed[X_V_##_LOBFLDNAME] == YES )  \
   { \
      X_SHORT  sCursorID; \
      X_PVOID  pTreeEntry; \
\
      /* Sets pG->vchLOBSqlStmnt */ \
      strcpy( pG->vchLOBSqlStmnt, X_DBM_SelectFlds_##_LOBFLDNAME ); \
      if ( _CURRENT ) X_OAM_Add_Where_for_Current(X_OAM_STANDARD_PARMS, pG->vchLOBSqlStmnt, FALSE); \
      else            X_OAM_ADD_WHERE(pG->vchSqlStmnt,pG->vchLOBSqlStmnt) \
      if ( strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0 ) return; \
      X_OAM_ALLOCATE_LOB_SQLDA(_LOBFLDNAME) \
\
      /* ------------------------------------- */ \
      /* Prepare the required SELECT statement */ \
      /* ------------------------------------- */ \
      if ( fHasRRNO ) \
      { \
         pX_Ids->chOAMRqsType = X_INVARIANT_SELECT; \
         pX_Ids->fX_DBM_PrepareParams = TRUE; /* Because RRN in SQL */ \
      } \
      else \
      { \
         pX_Ids->chOAMRqsType = X_VARIANT_SELECT; \
         pX_Ids->fX_DBM_PrepareParams = FALSE; /* Because RRN not in SQL */ \
      } \
\
      X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchLOBSqlStmnt, 0, &(sCursorID) ) \
\
      if (pG->lReturnCode != X_DBMS_INFO_OKAY) \
      { \
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR); \
         pX_Ids->lLastErrorCode = pG->lReturnCode; \
         return; \
      } \
\
      /* --------------- */ \
      /* Save the cursor */ \
      /* --------------- */ \
      X_CreateLOBCursorDetails( pX_Ids,pX_Pro,pX_Fun,pX_DBM,X_File_Header.vchTable,_FIELD,sCursorID,&(pTreeEntry) ); \
\
      /* --------------------------------------------------- */ \
      /* Open the cursor associated with the prepared SELECT */ \
      /* --------------------------------------------------- */ \
      X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, sCursorID, pG->pSqlda##_LOBFLDNAME ) \
\
      if (pG->lReturnCode != X_DBMS_INFO_OKAY) \
      { \
         X_RemoveLOBCursorDetails( pX_Ids,pX_Pro,pX_Fun,pX_DBM,X_File_Header.vchTable,_FIELD, FALSE, (pTreeEntry) ); \
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR); \
         pX_Ids->lLastErrorCode = pG->lReturnCode; \
         return; \
      } \
   }

#define X_OAM_LOB_FETCH_FETCH(_LOBFLDNAME,_FIELD2) \
   if ( pCurr->X_DBM_FldsUsed[X_V_##_LOBFLDNAME] == YES )  \
   { \
      X_LONG lFetchCode; \
      X_SHORT  sCursorID; \
\
      X_OAM_SET_LOB_CURSOR_ID(_FIELD2,sCursorID,pX_NULL,0) \
\
      X_DBM_OP( lFetchCode, X_DBM_FETCH_ROW, pX_NULL, sCursorID, pG->pSqlda##_LOBFLDNAME ) \
\
      /* ------------------------------- */ \
      /* Set the appropriate return code */ \
      /* ------------------------------- */ \
\
      if (lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND) \
      { \
         /* Row must have been deleted since our read via other cursor(s) */ \
         strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD); \
         if (pX_DBM->chMsgReqd == YES) \
         { \
            X_Issue_Message_Vec(pX_Ids, \
                                pX_Pro, \
                                pX_Fun, \
                                pX_Ids->vchStandardMessageFile, \
                                "IOM0005", \
                                pX_Fld, \
                                2, \
                                X_DBM_FilLibVecs); \
         } \
\
         /* ---------------------------------------------------- */ \
         /* Close the cursor associated with the prepared SELECT */ \
         /* ---------------------------------------------------- */ \
\
         if ( (pX_DBM->sDBMRequest != X_DBM_UNLOAD_DATA) && (pX_DBM->chWhereRDML == NO)) \
         { \
            X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS); \
         } \
\
         return; \
      } \
   }

#define X_OAM_SET_LOB_BASE_DIR(_SUCCESS) \
   { \
      X_VCHAR vchTemp[132 + 1]; \
      X_USHORT sMaxLOBPath; \
      X_PVCHAR pvchTemp = strrchr(pX_DBM->pvchFile,X_PATH_SEPARATOR); \
\
      _SUCCESS = TRUE; \
      if ( !pvchTemp ) \
      { \
         sprintf( vchTemp, X_TEXT_NOID(983), pX_DBM->pvchFile ); \
         X_Issue_Message_VChar( pX_Ids, \
                                pX_Pro, \
                                pX_Fun, \
                                pX_Ids->vchStandardMessageFile, \
                                "DCM9899", \
                                vchTemp); \
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR); \
         _SUCCESS = FALSE; \
      } \
      else \
      { \
         /* Ensure there will be enough room to put full path in field */ \
         /* ...\fileffffff_fieldfffff_vchDiskFile                      */ \
         pvchTemp++; \
         sMaxLOBPath  = (pvchTemp - pX_DBM->pvchFile) + \
                        (X_OBJECT_NAME_LEN * 2) + (2 + X_LOB_DISK_FILE_LEN); \
\
         if ( sMaxLOBPath > X_MAX_SIZE_LOB_FILE_NAME ) \
         { \
            sprintf( vchTemp, \
                     X_TEXT_NOID(971), \
                     "UNLOAD", \
                     "", \
                     sMaxLOBPath - X_MAX_SIZE_LOB_FILE_NAME ); \
\
            X_Issue_Message_VChar( pX_Ids, \
                                   pX_Pro, \
                                   pX_Fun, \
                                   pX_Ids->vchStandardMessageFile, \
                                   "DCM9899", \
                                   vchTemp); \
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR); \
            _SUCCESS = FALSE; \
         } \
         else \
         { \
            /* Setup directory path as per .DAT file */ \
            memset(vchBaseLOBDir,END_OF_STRING,sizeof(vchBaseLOBDir)); \
            strncpy(vchBaseLOBDir, \
                    pX_DBM->pvchFile, \
                    (pvchTemp - pX_DBM->pvchFile)); \
         } \
      } \
   }

#define X_OAM_LOB_UPDATE(_LOBFLDNAME,_FIELD,_REQ) \
   if ( pCurr->X_DBM_FldsUsed[X_V_##_LOBFLDNAME] == YES )  \
   { \
      if ( !(pG->pSqlda##_LOBFLDNAME) ) \
      { \
         strcpy( pG->vchLOBSqlStmnt, X_DBM_SelectFlds_##_LOBFLDNAME ); \
         X_OAM_ALLOCATE_LOB_SQLDA(_LOBFLDNAME) \
      } \
      X_OAM_Update_LOB_Field(X_OAM_STANDARD_PARMS, \
                             X_DBM_UpdateFlds_##_LOBFLDNAME, \
                             X_V_##_LOBFLDNAME, \
                             _FIELD, \
                             X_FCN_##_LOBFLDNAME, \
                             pX_NULL, \
                             pG->pSqlda##_LOBFLDNAME, \
                             _REQ); \
      if ( strcmp(pX_DBM->vchReturnCode,X_DBM_OKAY) != 0 ) return; \
   }

#endif /* X_OAM_HAS_LOB_SUPPORT */

#define PAD_STRING_TO_LENGTH(_S, _L) \
{ \
   X_SHORT s; \
   if (strlen(_S) < _L) \
   { \
      for (s = strlen(_S); s < _L; s++) \
      { \
         _S[s]= BLANK; \
      } \
   } \
   _S[_L] = END_OF_STRING; \
}

/* ================================================================= */
/* Forward declaration of local function prototypes                  */
/* ================================================================= */

#define X_OAM_STANDARD_DEFNS  \
   struct X_IDS *, \
   struct X_PRO *, \
   struct X_FUN *, \
   struct X_FLD *, \
%ifprev   struct X_FLD *, \
   struct X_DBM *, \
   struct GLOBAL_INFO *

#define X_OAM_STANDARD_ARGS  \
   struct X_IDS * pX_Ids, \
   struct X_PRO * pX_Pro, \
   struct X_FUN * pX_Fun, \
   struct X_FLD * pX_Fld, \
%ifprev   struct X_FLD * pX_FldPrev, \
   struct X_DBM * pX_DBM, \
   struct GLOBAL_INFO *pG

#define X_OAM_STANDARD_PARMS  \
   pX_Ids, pX_Pro, pX_Fun, pX_Fld, \
%ifprev                    pX_FldPrev, \
   pX_DBM, pG

O_VOID_FUNCTION X_OAM_Check_For_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Close_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Force_Close_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Close_Request_Common(X_OAM_STANDARD_DEFNS);

O_BOOL_FUNCTION X_OAM_Perform_Commit(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Delete_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Delete_Next_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Cursor_Close_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Fetch_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Fetch_Next_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Filecheck_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Insert_Request(X_OAM_STANDARD_DEFNS);

O_CHAR_FUNCTION X_OAM_Open_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Select_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Select_Next_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Unload_Data(X_OAM_STANDARD_DEFNS);

O_BOOL_FUNCTION X_OAM_Output_record_To_File(X_OAM_STANDARD_DEFNS, FILE *);

O_VOID_FUNCTION X_OAM_Load_Data(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Update_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Update_Next_Request(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Validation_Checks(X_OAM_STANDARD_DEFNS,
                                        X_TYPE_FLAG);

O_VOID_FUNCTION X_OAM_Test_Trigger_Return(X_OAM_STANDARD_DEFNS,    %ifatrg
                                          X_PVCHAR);               %ifatrg
                                                                   %ifatrg
O_VOID_FUNCTION X_OAM_Read_Triggers(X_OAM_STANDARD_DEFNS);         %rdtrig
                                                                   %rdtrig
O_VOID_FUNCTION X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_DEFNS);  %ifvcpjf
                                                                      %ifvcpjf
O_VOID_FUNCTION X_OAM_Virtual_Code_Before_Write(X_OAM_STANDARD_DEFNS);%ifvc
                                                                      %ifvc
O_VOID_FUNCTION X_OAM_Stamp_Attributes(X_OAM_STANDARD_DEFNS,          %ifstmp
                                       X_TYPE_FLAG);                  %ifstmp
                                                                       %ifstmp
O_VOID_FUNCTION X_OAM_Update_Batch_Control(X_OAM_STANDARD_DEFNS,       %ifbch
                                           X_TYPE_FLAG);               %ifbch
                                                                       %ifbch
O_VOID_FUNCTION X_OAM_Initialisation(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Set_Defaults(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Build_Where(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_OAM_Add_Table_Name(X_OAM_STANDARD_DEFNS);

X_PVCHAR_FUNCTION X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_DEFNS, X_SHORT);

O_VOID_FUNCTION X_OAM_Build_Start_Key(X_OAM_STANDARD_DEFNS);

O_BOOL_FUNCTION X_OAM_Add_Value_To_Stmnt(X_OAM_STANDARD_DEFNS, X_SHORT, X_SHORT);

#ifdef X_OAM_REPLACE_RRN_WITH_PKEY_REQUIRED
O_VOID_FUNCTION X_OAM_Build_Primary_Key_Where(X_OAM_STANDARD_DEFNS, X_BOOL, X_BOOL, X_BOOL);
#endif
#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
O_BOOL_FUNCTION X_OAM_Save_Current_Record(X_OAM_STANDARD_DEFNS);
O_BOOL_FUNCTION X_OAM_Deallocate_X_Var(X_OAM_STANDARD_DEFNS);
O_BOOL_FUNCTION X_OAM_Compare_Current_Record(X_OAM_STANDARD_DEFNS);
#endif

O_VOID_FUNCTION X_Create_OAM_Field_Instance(struct X_IDS *,
                                            struct GLOBAL_INFO *);

O_VOID_FUNCTION X_Destroy_OAM_Field_Instance(struct X_IDS *,
                                             struct GLOBAL_INFO *);

O_VOID_FUNCTION X_Create_Batch_Field_Instance(struct X_IDS *,         %ifbch
                                              struct GLOBAL_INFO *);  %ifbch

O_VOID_FUNCTION X_Destroy_Batch_Field_Instance(struct X_IDS *,        %ifbch
                                              struct GLOBAL_INFO *);  %ifbch

O_VOID_FUNCTION X_Search_FldIndex(X_OAM_STANDARD_DEFNS);

O_VOID_FUNCTION X_Deallocate_FldIndex(struct X_IDS *, struct X_FUN *);

O_VOID_FUNCTION X_Search_Where_FldIndex( X_OAM_STANDARD_DEFNS, X_SHORT * );

O_VOID_FUNCTION X_Deallocate_WhereFldIndex( struct X_IDS *, struct GLOBAL_INFO  *, struct X_FUN * );

O_SHORT_FUNCTION X_OAM_Setup_Sqlda(X_OAM_STANDARD_ARGS,
                                  X_SQLDA **ppSqlda,
                                  X_TYPE_FLAG chType,
                                  X_BOOL fAllowMain);

O_VOID_FUNCTION X_OAM_Replace_RRNO( X_OAM_STANDARD_DEFNS,
                                    X_PVCHAR *  ppvchCopy,
                                    X_PVCHAR    pvchSource,
                                    X_PVCHAR    pvchRealName,
                                    X_PVCHAR    pvchObject );

#if defined(X_OAM_HAS_LOB_SUPPORT)
O_VOID_FUNCTION X_OAM_Update_LOB_Field(X_OAM_STANDARD_ARGS,
                                       X_PVCHAR pvchUpdateStmnt, 
                                       X_SHORT  sVec,
                                       X_PVCHAR pvchField,
                                       X_PVCHAR pvchFileCol,
                                       X_PVCHAR pvchTstampCol,
                                       X_SQLDA *pSqlda,
                                       X_SHORT  sDBMRequest);

#endif

O_VOID_FUNCTION X_OAM_Add_Where_for_Current(X_OAM_STANDARD_ARGS,
                                            X_PVCHAR pvchBuffer,
                                            X_BOOL fLast);


#if defined(X_OPERATING_SYSTEM_ISERIES)
X_SHORT_FUNCTION X_Zap_DLL(struct X_IDS *pX_Ids);
O_VOID_FUNCTION X_OAM_Native_Fetch_RRN(X_OAM_STANDARD_DEFNS);    %ifntv
O_VOID_FUNCTION X_OAM_Native_Fetch_First(X_OAM_STANDARD_DEFNS);  %ifntv
O_VOID_FUNCTION X_OAM_Native_Fetch_Next(X_OAM_STANDARD_DEFNS);   %ifntv
O_VOID_FUNCTION X_OAM_Native_Locate(X_OAM_STANDARD_DEFNS);       %ifntv
X_SHORT_FUNCTION X_OAM_Compare_Generic(struct X_IDS *pX_Ids,          %ifntv
                                       struct X_PRO *pX_Pro,          %ifntv
                                       struct X_FUN *pX_Fun,          %ifntv
                                       struct X_FLD *pX_Fld_Rec,      %ifntv
                                       X_SHORT sVector_Rec,           %ifntv
                                       struct X_FLD *pX_Fld_Gen,      %ifntv
                                       X_SHORT sVector_Gen );         %ifntv
#endif

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_EXECUTE)))
%vcisp

#endif

%pcode_proto

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))


X_HEAPDLLMAIN_GENERATED( "File %tableentx", 1 )

/* ================================================================= */
/*                                                                   */
/* Function     : %tableentx                                         */
/* Description  : Main entry point for OAM (Object Access Module)    */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_DBM       - standard DBM defn. structure        */
/*                                                                   */
/* ================================================================= */

X_VOID_FUNCTION X_Access_Table_%tableentx(struct X_IDS *pX_Ids,
                                          struct X_PRO *pX_Pro,
                                          struct X_FUN *pX_Fun,
                                          struct X_DBM *pX_DBM)
{
   static X_ULONG ulOAMInUse = 0;
   X_SHORT i;
   X_CHAR  chValid;
   X_VAR_FRAME                        frame = { X_VAR_HEADER_KIND_FRAME, NULL };    /* TODO */
   X_VAR_FRAME                     *  pFrame = &frame;                              /* TODO */
 
#if defined(X_OPERATING_SYSTEM_WIN31)
   struct X_GENERIC_INSTANCE * pGI = pX_NULL;
#endif
   struct GLOBAL_INFO * pG = pX_NULL;
   struct X_FLD * pX_Fld = pX_NULL;
   struct X_FLD * pX_FldPrev = pX_NULL;                                %ifprev


   /* -------------------------------------------------------- */
   /* Ignore close requests if somethings already in progress  */
   /* Force close is the real McCoy. X_DBM_CLOSE is really     */
   /* more like, 'close if you want to '                       */
   /* -------------------------------------------------------- */

   if ( pX_DBM->sDBMRequest == X_DBM_CLOSE && ulOAMInUse && !pX_Ids->fSystemShutDownMode)
   {
      strcpy( pX_DBM->vchReturnCode, X_DBM_OKAY );
      return;
   }

   /* --------------------------------- */
   /* Set the update connection type    */
   /* (this value is stacked by X_PDF4) */
   /* --------------------------------- */

   if (X_DBMS_INFO_MIXED_MODE)                                                    %ifcmt
      pX_Ids->chActiveIOMUpdateConnection = X_ODBC_UPDATE_CONNECTION_MIXED_MODE;  %ifcmt
   else                                                                           %ifcmt
      pX_Ids->chActiveIOMUpdateConnection = X_ODBC_DEFAULT_UPDATE_CONNECTION;

   /* ---------------------------------------------------------- */
   /* Handle initial template area initialisation,etc            */
   /* ---------------------------------------------------------- */

   /* Unset vchReturnCode, as otherwise it may affect OAM operation */
   pX_DBM->vchReturnCode[0] = END_OF_STRING;

#define IS_CLOSE_REQUEST (pX_DBM->sDBMRequest == X_DBM_CLOSE || pX_DBM->sDBMRequest == X_DBM_FORCE_CLOSE)
   /* ------------------------------------------- */
   /* Make sure redirection to an SSN is handled  */
   /* Must be done before X_DBMS_INFO macros used */
   /* ------------------------------------------- */
   if ( !(IS_CLOSE_REQUEST && (lEntryCount == 0 || !X_DBM_V5_OR_LATER) ) )
   {
#if defined(X_DBM_PCOTHER)
      X_Check_Database_SSN(pX_Ids,pX_Pro,pX_Fun,pX_DBM,TRUE,&X_ConnectDB);
#else
      X_Check_Database_SSN(pX_Ids,pX_Pro,pX_Fun,pX_DBM,FALSE,pX_NULL);
#endif
      if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)
      {
         return;
      }

      /* Check that pDBMSInfo has been setup */
      if ( X_DBM_V3_OR_LATER &&
           pX_DBM->pDatabase &&
           !pX_DBM->pDatabase->pDBMSInfo )
      {
         X_Fatal_Error(pX_Ids,
                       pX_Pro,
                       pX_Fun,
                       "OAM for table %tablexxxx",
                       "pX_DBM->pDatabase->pDBMSInfo not set. Aborting");
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }
   }

   if (lEntryCount == 0)
   {
#ifdef X_DBM_ISERIESOTHER
      /* On iSeries, Other files always have RRNO and never have UPID */
      if ( !X_DBMS_INFO_IGNORE_NATIVE_SUPPORT )
      {
         fHasUPID = FALSE;
      }
#elif defined(X_DBM_NO_RRNO_COLUMN)
      /* On iSeries, LANSA files always have RRNO and UPID */
      if ( X_DBMS_INFO_IGNORE_NATIVE_SUPPORT )
      {
         fHasRRNO = FALSE;
         fHasUPID = FALSE;
      }
#endif

      if ( X_DBMS_INFO_USE_INTERNAL_NAMES )
      {
         fInternalNames          = TRUE;
         X_DBM_SqlTableName      = X_DBM_SqlTableName_R;
         X_DBM_SqlCollectionName = X_DBM_SqlCollectionName_R;
         X_DBM_SelectFlds        = X_DBM_SelectFlds_R;
         X_DBM_InsertFlds        = X_DBM_InsertFlds_R;
         X_DBM_UpdateFlds        = X_DBM_UpdateFlds_R;
         X_DBM_DeleteFlds        = X_DBM_DeleteFlds_R;
         pX_Columns              = X_Columns_R;
         X_DBM_InsertSelectFlds  = X_DBM_InsertSelectFlds_R;
         X_DBM_UpdateSelectFlds  = X_DBM_UpdateSelectFlds_R;      %iflob

         if ( !X_DBMS_INFO_IGNORE_NATIVE_SUPPORT )
         {
#if !defined(X_DBM_NO_RRNO_COLUMN) /* 113882: review for 11.0 GA */
            /* Treat as if AUTO_RRNO was defined */
            fAutoRRN          = TRUE;
#endif
            X_DBM_SelectFlds        = X_DBM_SelectFlds_RN;
            X_DBM_InsertFlds        = X_DBM_InsertFlds_RN;
            X_DBM_UpdateFlds        = X_DBM_UpdateFlds_RN;
            X_DBM_InsertSelectFlds  = X_DBM_InsertSelectFlds_RN;
            X_DBM_UpdateSelectFlds  = X_DBM_UpdateSelectFlds_RN;  %iflob
         }
      }
      else
      {
         X_DBM_SqlTableName      = X_DBM_SqlTableName_S;
         X_DBM_SqlCollectionName = X_DBM_SqlCollectionName_S;
         X_DBM_SelectFlds        = X_DBM_SelectFlds_S;
         X_DBM_InsertFlds        = X_DBM_InsertFlds_S;
         X_DBM_UpdateFlds        = X_DBM_UpdateFlds_S;
         X_DBM_DeleteFlds        = X_DBM_DeleteFlds_S;
         pX_Columns              = X_Columns_S;
         X_DBM_InsertSelectFlds  = X_DBM_InsertSelectFlds_S;
         X_DBM_UpdateSelectFlds  = X_DBM_UpdateSelectFlds_S;      %iflob

         if ( !X_DBMS_INFO_IGNORE_NATIVE_SUPPORT )
         {
#if !defined(X_DBM_NO_RRNO_COLUMN) /* 113882: review for 11.0 GA */
            /* Treat as if AUTO_RRNO was defined */
            fAutoRRN          = TRUE;
#endif
            X_DBM_SelectFlds        = X_DBM_SelectFlds_SN;
            X_DBM_InsertFlds        = X_DBM_InsertFlds_SN;
            X_DBM_UpdateFlds        = X_DBM_UpdateFlds_SN;
            X_DBM_InsertSelectFlds  = X_DBM_InsertSelectFlds_SN;
            X_DBM_UpdateSelectFlds  = X_DBM_UpdateSelectFlds_SN;  %iflob
         }
      }

      memset(&(Global_Info),LOVAL,sizeof(struct GLOBAL_INFO));
      Global_Info.chFirstCall = YES;
      Global_Info.usMaxSqlda = X_MAX_SQLDA;
      Global_Info.chReadAuthChecked = NO;
      Global_Info.chInsertAuthChecked = NO;
      Global_Info.chUpdateAuthChecked = NO;
      Global_Info.chDeleteAuthChecked = NO;
      Global_Info.sLang = 0;
      Global_Info.T_Parm[0].sType = X_PARM_TRIGGER_STRUCTURE;          %ifatrg
      Global_Info.T_Parm[0].vchName[0] = END_OF_STRING;                %ifatrg
      Global_Info.T_Parm[0].sNumberOf = 1;                             %ifatrg
      Global_Info.T_Parm[0].pValue = (X_PVOID)&(Global_Info.X_Trigger);%ifatrg
      Global_Info.sLastRequest = 0;                                    %ifatrg
      Global_Info.pX_Bif = &(Global_Info.X_Bif);                       %ifvc
      Global_Info.pX_List = &(Global_Info.X_List);                     %ifvc
      Global_Info.pX_Fld = pX_NULL;
      Global_Info.pX_Curr = &X_DBM_Current;
      Global_Info.pX_FldPrev = &X_FldPrev[0];                         %ifprev
      Global_Info.pX_Prev = &X_DBM_Previous;                          %ifprev

#if defined(X_DBM_IDENTITY_COLUMN) || defined(X_DBM_AUTO_RRNO)
      Global_Info.pX_RRNO = pX_NULL;
#else
      Global_Info.pX_RRNO = &X_RRNO[0];
#endif

      %BchSetPtr
      Global_Info.pCurrFldIndex = pX_NULL;
      %PJFSetPtr

      /* Do not modify collections if PC Other File  */
      /* unless this is also a Repository table, in  */
      /* which case we allow removing the collection */
      {                                                                                    %iflob
         /* LOB initialisation must be here as X_DBM_SqlCollectionName */                  %iflob
         /* may get truncated below, so we need to access it now.      */                  %iflob
         X_SHORT   sLength = strlen( X_DBM_SqlCollectionName );                            %iflob
         char * pTemp;                                                                     %iflob
         %lobinit
         #ifdef X_OAM_UPID_REQUIRED                                                        %iflob
         if ( !fHasUPID ) X_DBM_Select_LOBColumns[0]--;                                    %iflob
         #else                                                                             %iflob
         X_DBM_Select_LOBColumns[0]--;                                                     %iflob
         #endif                                                                            %iflob
                                                                                           %iflob
      }                                                                                    %iflob
                                                                                           %iflob
#if defined(X_DBM_REPOSITORY) || !defined(X_DBM_PCOTHER)
      if (!X_DBMS_INFO_COLLECTIONS)
      {
        char * pTemp;

        /* Never emulate collections for a Repository table */
#ifndef X_DBM_REPOSITORY
        if (X_DBMS_INFO_EMULATE_COLLECTIONS)
        {
           X_SHORT   sLength = strlen( X_DBM_SqlTableName );

           memcpy( X_DBM_SqlTableName, X_DBM_SqlTableName + 1, sLength - 1 );
           X_DBM_SqlTableName[sLength - 1] = LOVAL;

           pTemp = strrchr(X_DBM_SelectFlds,'.');
           *(pTemp - 1) = X_NON_LEADING_REPLACE;
           *pTemp = LOVAL;

           pTemp = strchr(X_DBM_InsertFlds,'.');
           *(pTemp - 1) = X_NON_LEADING_REPLACE;
           memcpy( pTemp, X_DBM_SqlTableName, sLength - 1 );
           memset( pTemp + sLength - 1, BLANK, 2 );

           pTemp = strchr(X_DBM_InsertSelectFlds,'.');
           *(pTemp - 1) = X_NON_LEADING_REPLACE;
           strcpy( pTemp, X_DBM_SqlTableName );

           pTemp = strchr(X_DBM_UpdateSelectFlds,'.');         %iflob
           *(pTemp - 1) = X_NON_LEADING_REPLACE;               %iflob
           strcpy( pTemp, X_DBM_SqlTableName );                %iflob

           pTemp = strchr(X_DBM_UpdateFlds,'.');
           *(pTemp - 1) = X_NON_LEADING_REPLACE;
           memcpy( pTemp, X_DBM_SqlTableName, sLength - 1 );
           memset( pTemp + sLength - 1, BLANK, 2 );

           pTemp = strchr(X_DBM_DeleteFlds,'.');
           *(pTemp - 1) = X_NON_LEADING_REPLACE;
           strcpy( pTemp, X_DBM_SqlTableName );
        }
        else
#endif /* X_DBM_REPOSITORY */
        {
           X_SHORT   sLength = strlen( X_DBM_SqlCollectionName );

           pTemp = strrchr(X_DBM_SelectFlds,'.');
           memset((pTemp - sLength),BLANK,(sLength + 1));
           pTemp = strchr(X_DBM_InsertFlds,'.');
           memset((pTemp - sLength),BLANK,(sLength + 1));

           pTemp = strchr(X_DBM_InsertSelectFlds,'.');
           memset((pTemp - sLength),BLANK,(sLength + 1));

           pTemp = strchr(X_DBM_UpdateSelectFlds,'.');         %iflob
           memset((pTemp - sLength),BLANK,(sLength + 1));      %iflob

           pTemp = strchr(X_DBM_UpdateFlds,'.');
           memset((pTemp - sLength),BLANK,(sLength + 1));
           pTemp = strchr(X_DBM_DeleteFlds,'.');
           memset((pTemp - sLength),BLANK,(sLength + 1));
           
           /* Set X_DBM_SqlCollectionName to an empty string */
           X_DBM_SqlCollectionName[0] = END_OF_STRING;
        }
        %BchColl
        %PJFColl
      }
#endif /* defined(X_DBM_REPOSITORY) || !defined(X_DBM_PCOTHER) */

      if (X_DBM_V3_OR_LATER && pX_DBM->pDatabase)
      {
         strcpy(Global_Info.vchFirstDBMSType,pX_DBM->pDatabase->vchDatabaseType);
      }
      else
      {
         strcpy(Global_Info.vchFirstDBMSType,pX_Ids->pUserDBMSInfo->vchDBMSType);
      }

      Global_Info.pWhereFldIndex = pX_NULL;

      X_Replace_Chars( pX_Ids, pX_Pro, pX_Fun, HIVAL, X_DBMS_INFO_QUOTE_CHAR, X_DBM_SqlTableName );
      X_Replace_Chars( pX_Ids, pX_Pro, pX_Fun, HIVAL, X_DBMS_INFO_QUOTE_CHAR, X_DBM_SqlCollectionName );
      X_Replace_Chars( pX_Ids, pX_Pro, pX_Fun, HIVAL, X_DBMS_INFO_QUOTE_CHAR, X_DBM_SelectFlds );
      X_Replace_Chars( pX_Ids, pX_Pro, pX_Fun, HIVAL, X_DBMS_INFO_QUOTE_CHAR, X_DBM_InsertFlds );
      X_Replace_Chars( pX_Ids, pX_Pro, pX_Fun, HIVAL, X_DBMS_INFO_QUOTE_CHAR, X_DBM_UpdateFlds );
      X_Replace_Chars( pX_Ids, pX_Pro, pX_Fun, HIVAL, X_DBMS_INFO_QUOTE_CHAR, X_DBM_DeleteFlds );

      if ( fHasRRNO )
      {
         if ( !X_DBMS_INFO_IGNORE_NATIVE_SUPPORT )
         {
            X_DBM_RRNONativeName = X_DBM_RRNONativeName_SRN;
         }
         else if ( X_DBMS_INFO_USE_INTERNAL_NAMES )
         {
            X_DBM_RRNONativeName = X_DBM_RRNONativeName_R;
         }
         else
         {
            X_DBM_RRNONativeName = X_DBM_RRNONativeName_S;
         }

         X_Replace_Chars( pX_Ids, pX_Pro, pX_Fun, HIVAL, X_DBMS_INFO_QUOTE_CHAR, X_DBM_RRNONativeName );
      }

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID )
      {
         if ( X_DBMS_INFO_USE_INTERNAL_NAMES )
         {
            X_DBM_UPIDNativeName = X_DBM_UPIDNativeName_R;
         }
         else
         {
            X_DBM_UPIDNativeName = X_DBM_UPIDNativeName_S;
         }

         X_Replace_Chars( pX_Ids, pX_Pro, pX_Fun, HIVAL, X_DBMS_INFO_QUOTE_CHAR, X_DBM_UPIDNativeName );
      }
#endif

      if ( fIdentity || fAutoRRN )                                %ifnlob
      {
         X_Replace_Chars( pX_Ids, pX_Pro, pX_Fun, HIVAL, X_DBMS_INFO_QUOTE_CHAR, X_DBM_InsertSelectFlds );
      }

      if ( fIdentity || fAutoRRN )                                %iflob
      {                                                           %iflob
         X_Replace_Chars( pX_Ids, pX_Pro, pX_Fun, HIVAL, X_DBMS_INFO_QUOTE_CHAR, X_DBM_UpdateSelectFlds ); %iflob
      }                                                           %iflob

      %replacechars_keyaod
      %replacechars_keys
      %replacechars_orders
      %replacechars_bckord

      for ( i = 0; i < X_DBM_FLDMAP_COLUMNS; i++ )
      {
         X_Replace_Chars( pX_Ids, pX_Pro, pX_Fun, HIVAL, X_DBMS_INFO_QUOTE_CHAR, pX_Columns[i].vchColumn );
      }

      %NtvSetPtr

      /* Decrement LOB column numbers if fAutoRRN */                                       %iflob
      if ( fAutoRRN || fIdentity )                                                         %iflob
      {                                                                                    %iflob
         for ( i = 0; i < X_TOTAL_REAL_FIELDS - X_TOTAL_REAL_NON_LOB_FIELDS; i++ )         %iflob
         {                                                                                 %iflob
            X_DBM_InsertLOBColumns[i]--;                                                   %iflob
         }                                                                                 %iflob
      }                                                                                    %iflob
                                                                                           %iflob
      /* Determine Collection + Table for LOBs */                                          %iflob
      {                                                                                    %iflob
         X_SHORT sLen = strlen(X_DBM_SqlCollectionName) + strlen(X_DBM_SqlTableName) + 2;  %iflob
         Global_Info.pvchTable = X_PDF_Allocate_Memory(pX_Ids,pX_Pro,pX_Fun,sLen);         %iflob
         if ( !Global_Info.pvchTable )                                                     %iflob
         {                                                                                 %iflob
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);                               %iflob
            return;                                                                        %iflob
         }                                                                                 %iflob
         memset(Global_Info.pvchTable,LOVAL,sLen);                                         %iflob
         if ( strlen(X_DBM_SqlCollectionName) )                                            %iflob
         {                                                                                 %iflob
            strcpy(Global_Info.pvchTable,X_DBM_SqlCollectionName);                         %iflob
            if ( !(X_DBMS_INFO_COLLECTIONS) && X_DBMS_INFO_EMULATE_COLLECTIONS )           %iflob
            {                                                                              %iflob
               Global_Info.pvchTable[strlen(Global_Info.pvchTable) - 1] = END_OF_STRING;   %iflob
               strcat(Global_Info.pvchTable,"_");                                          %iflob
            }                                                                              %iflob
            else                                                                           %iflob
            {                                                                              %iflob
               strcat(Global_Info.pvchTable,".");                                          %iflob
            }                                                                              %iflob
         }                                                                                 %iflob
         strcat(Global_Info.pvchTable,X_DBM_SqlTableName);                                 %iflob
      }                                                                                    %iflob
   }

   lEntryCount++;

   /* ---------------------------------- */
   /* Set the instance details correctly */
   /* ---------------------------------- */

#if defined(X_OPERATING_SYSTEM_WIN31)

   pGI = X_Create_Generic_Instance (pX_Ids,
                                    &(pRootGI),
                                    (X_ULONG) sizeof(struct GLOBAL_INFO),
                                    (X_PVOID) &(Global_Info));

   if (pX_Ids->chFatalError == YES)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      return;
   }

   pG = (struct GLOBAL_INFO *) pGI->pInstanceData;
   pG->T_Parm[0].pValue = (X_PVOID)&(pG->X_Trigger);               %ifatrg
   pG->pX_Bif = &(pG->X_Bif);                                      %ifvc
   pG->pX_List = &(pG->X_List);                                    %ifvc


   /* ---------------------------------------- */
   /* Allocate and set the field mapping areas */
   /* ---------------------------------------- */

   if (pG->pX_Fld == pX_NULL)
   {
      pG->pX_Fld = &X_Fld[0];
      X_Create_OAM_Field_Instance(pX_Ids, pG);
      if (pX_Ids->chFatalError == YES)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }

      X_Create_Batch_Field_Instance(pX_Ids, pG);                   %ifbch
      if (pX_Ids->chFatalError == YES)                             %ifbch
      {                                                            %ifbch
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);          %ifbch
         return;                                                   %ifbch
      }                                                            %ifbch
                                                                   %ifbch
   }

#else

   pG = &(Global_Info);
   pG->pX_Fld = &X_Fld[0];

#endif

   /* On second and subsequent calls, check db type hasn't changed */
   if (lEntryCount > 1 && X_DBM_V3_OR_LATER && pX_DBM->pDatabase)
   {
      if (strcmp(pG->vchFirstDBMSType,pX_DBM->pDatabase->vchDatabaseType))
      {
         X_PVCHAR pvchText;
         X_VCHAR  vchSubsVar[150 + 1];

         pvchText = X_TEXT_NOID(826);

         sprintf(vchSubsVar,
                 pvchText,
                 pG->vchFirstDBMSType,
                 pX_DBM->pDatabase->vchDatabaseType);

         X_Issue_Message_VChar( pX_Ids,
                                pX_Pro,
                                pX_Fun,
                                pX_Ids->vchStandardMessageFile,
                                "DCM9899",
                                vchSubsVar);

         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }
   }

   pX_Fld = pG->pX_Fld;
   pX_FldPrev = pG->pX_FldPrev;                                    %ifprev

   strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

   /* 111371: Only initialise if not first entry AND not Check For */
   if ( fHasRRNO && lEntryCount > 1 && pX_DBM->sDBMRequest != X_DBM_CHECK_FOR )
   {
      X_Vec_Init(pX_Ids,
                 pX_Pro,
                 pX_Fun,
                 pX_Fld,
                 X_V_%@RRNOxxxx);
   }

   /* -------------------------------------------- */
   /* Make sure the file name is known to this OAM */
   /* -------------------------------------------- */

   X_PDF_ReplaceSpecialChars(pX_Ids, pX_DBM->vchTableName);
   chValid = 'N';
   for (i = 0; i < X_DBM_NumberFileNames; i++)
   {
      if (memcmp(pX_DBM->vchTableName,
                 &X_DBM_ValidFilenames[i * X_TABLE_NAME_LEN],
                 X_TABLE_NAME_LEN) == 0)
      {
         chValid = 'Y';
         pG->sFileNo = i;
         break;
      }
   }

   if (chValid == 'N')
   {
      /* Copy table name to MsgTxt vector */
      X_Vec_Set_from_Vchar(pX_Ids,
                           pX_Pro,
                           pX_Fun,
                           pX_Fld,
                           X_V_MsgTxt,
                           pX_DBM->vchTableName);

      X_Issue_Message_Vec(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Ids->vchStandardMessageFile,
                          "IOM0001",
                          pX_Fld,
                          3,
                          X_DBM_FilLibIOMVecs);
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      return;
   }

#if defined(X_OPERATING_SYSTEM_ISERIES)
   pG->fUseNativeIO_Save = pX_DBM->fUseNativeIO;
   pX_DBM->fUseNativeIO = FALSE;                                    %ifnntv
   if ( ( pG->sFileNo == 0 )                                        %ifntv %iflob
       || ( pX_DBM->sDBMRequest == X_DBM_DELETE )                   %ifntv %iflob
       || ( pX_DBM->sDBMRequest == X_DBM_DELETE_NEXT )              %ifntv %iflob
       || ( pX_DBM->sDBMRequest == X_DBM_INSERT )                   %ifntv %iflob
       || ( pX_DBM->sDBMRequest == X_DBM_UPDATE )                   %ifntv %iflob
       || ( pX_DBM->sDBMRequest == X_DBM_UPDATE_NEXT )              %ifntv %iflob
       || ( ( pX_DBM->sDBMRequest == X_DBM_FETCH )                  %ifntv %iflob
           && (pX_DBM->chWithRRNO == YES ) ) )                      %ifntv %iflob
   {                                                                %ifntv %iflob
      pX_DBM->fUseNativeIO = FALSE;                                 %ifntv %iflob
   }                                                                %ifntv %iflob

#endif
   /* ---------------------------------------------- */
   /* Skip the open on first call if a CLOSE request */
   /* ---------------------------------------------- */

   if (!IS_CLOSE_REQUEST)
   {
      /* -------------------------------------------------- */
      /* Make sure the SQLDA is allocated if the first call */
      /* -------------------------------------------------- */

      pG->sSaveRequest = pX_DBM->sDBMRequest;
      if (pG->chFirstCall == YES)
      {
         X_OAM_Initialisation(X_OAM_STANDARD_PARMS);
         pX_DBM->sDBMRequest = X_DBM_OPEN;
      }

   }
#if defined(X_OPERATING_SYSTEM_ISERIES)
   if ( pX_DBM->fUseNativeIO )                                      %ifntv
   {                                                                %ifntv
      /* ---------------------------- */                            %ifntv
      /* Use Native I/O               */                            %ifntv
      /* ---------------------------- */                            %ifntv
      pG->pX_Native_Curr = pG->pX_Native_Input[pG->sFileNo];        %ifntv
      if (!IS_CLOSE_REQUEST)                                        %ifntv
      {                                                             %ifntv
         if (pG->chFirstCall != YES)                                %ifntv
         {                                                          %ifntv
            if ( pG->pX_Native_Curr->pFile == pX_NULL )             %ifntv
            {                                                       %ifntv
               X_LONG lRetCode;                                     %ifntv
                                                                    %ifntv
               X_DBM_OP_NATIVE_CONTROL(lRetCode, X_DBM_NATIVE_OPEN_2, pG->pX_Native_Curr)  %ifntv
               if ((lRetCode < X_DBMS_INFO_OKAY)                    %ifntv
                   || (pX_Ids->chFatalError == YES))                %ifntv
               {                                                    %ifntv
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);  %ifntv
                  pX_Ids->lLastErrorCode = lRetCode;                %ifntv
                  return;                                           %ifntv
               }                                                    %ifntv
            }                                                       %ifntv
         }                                                          %ifntv
      }                                                             %ifntv
   }                                                                %ifntv
#endif

   /* ------------------------------------ */
   /* Action the request according to type */
   /* ------------------------------------ */

   ulOAMInUse++;

   /* -------------------------------------------- */
   /* TODO:                                        */
   /* Temporary code to the frame is set correctly */
   /* Also required for RDML Files as all numbers  */
   /* now use the Decimal Library                  */
   /* Needs to be more specific                    */
   /* -------------------------------------------- */
   /* ---------------------- */                                
   /* Initialize X_VAR Frame */                                
   /* ---------------------- */                                
 
   X_VAR_InitializeOAMFrame( X_OAM_STANDARD_PARMS, pFrame );         %ifnprev
   X_VAR_InitializeOAMPreviousFrame( X_OAM_STANDARD_PARMS, pFrame ); %ifprev

   /* End temporary code */
    
X_Next :
   switch (pX_DBM->sDBMRequest)
   {

   /* CHECK_FOR row request */

      case(X_DBM_CHECK_FOR):
         X_OAM_Check_For_Request(X_OAM_STANDARD_PARMS);
         break;

   /* CLOSE database file request */

      case(X_DBM_CLOSE):
         X_OAM_Close_Request(X_OAM_STANDARD_PARMS);
         break;

   /* FORCE CLOSE database file request */

      case(X_DBM_FORCE_CLOSE):
         X_OAM_Force_Close_Request(X_OAM_STANDARD_PARMS);
         break;

   /* DELETE row(s) request */

      case(X_DBM_DELETE):
         X_OAM_Delete_Request(X_OAM_STANDARD_PARMS);
         break;

   /* DELETE_NEXT row request */

      case(X_DBM_DELETE_NEXT):
         X_OAM_Delete_Next_Request(X_OAM_STANDARD_PARMS);
         break;

   /* FETCH row request */

      case(X_DBM_FETCH):
         X_OAM_Fetch_Request(X_OAM_STANDARD_PARMS);
         break;

   /* FETCH_NEXT row request */

      case(X_DBM_FETCH_NEXT):
         X_OAM_Fetch_Next_Request(X_OAM_STANDARD_PARMS);
         break;

   /* CURSOR_CLOSE row request */

      case(X_DBM_CURSOR_CLOSE):
         X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS);
         break;

   /* FILECHECK request */

      case(X_DBM_FILECHECK):
         X_OAM_Filecheck_Request(X_OAM_STANDARD_PARMS);
         break;

   /* INSERT row request */

      case(X_DBM_INSERT):
         X_OAM_Insert_Request(X_OAM_STANDARD_PARMS);
         break;

   /* OPEN database file request */
   /* If this was a "forced" open request, process the actual       */
   /* request that was made next .....                              */

      case(X_DBM_OPEN):
         if (X_OAM_Open_Request(X_OAM_STANDARD_PARMS) == YES)
            goto X_Next;
         break;

   /* SELECT rows request */

      case(X_DBM_SELECT):
         X_OAM_Select_Request(X_OAM_STANDARD_PARMS);
         break;

   /* SELECT_NEXT row request */

      case(X_DBM_SELECT_NEXT):
         X_OAM_Select_Next_Request(X_OAM_STANDARD_PARMS);
         break;

   /* UPDATE row(s) request */

      case(X_DBM_UPDATE):
         X_OAM_Update_Request(X_OAM_STANDARD_PARMS);
         break;

   /* UPDATE_NEXT row request */

      case(X_DBM_UPDATE_NEXT):
         X_OAM_Update_Next_Request(X_OAM_STANDARD_PARMS);
         break;

   /* UNLOAD_DATA request */

      case(X_DBM_UNLOAD_DATA):
         X_OAM_Unload_Data(X_OAM_STANDARD_PARMS);
         break;

   /* LOAD_DATA request */

      case(X_DBM_LOAD_DATA):
         X_OAM_Load_Data(X_OAM_STANDARD_PARMS);
         break;

   /* Invalid request */

      default:
         ulOAMInUse--;
         X_Fatal_Error(pX_Ids,
                       pX_Pro,
                       pX_Fun,
                       "OAM for table %tablexxxx",
                       X_TEXT(131));
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
   }

   /* TODO: Beginning of temporary code */
   /* --------------------- */
   /* Terminate X_VAR Frame */
   /* --------------------- */
 
   X_VAR_TerminateFrame( pFrame );

   /* End temporary code */

   ulOAMInUse--;
                                                                  %ifatrg
   /* ----------------------------------------------- */          %ifatrg
   /* Track last request so we can avoid executing    */          %ifatrg
   /* Before/After Open & Before/After Close triggers */          %ifatrg
   /* when unloading and loading data.                */          %ifatrg
   /* Ignore cursor close requests in tracking        */          %ifatrg
   /* ----------------------------------------------- */          %ifatrg
   if ( !(pG->sLastRequest == X_DBM_UNLOAD_DATA &&                %ifatrg
          pX_DBM->sDBMRequest == X_DBM_CURSOR_CLOSE) )            %ifatrg
      pG->sLastRequest = pX_DBM->sDBMRequest;                     %ifatrg

   /* -------------------------------------------- */
   /* Now if an error occured and an RRN is to be  */
   /* returned then zap the return value to zero   */
   /* -------------------------------------------- */

   if ( ( fHasRRNO ) && 
        ( pX_DBM->chRetRRNO == YES) && 
        ( strcmp(pX_DBM->vchReturnCode,X_DBM_OKAY) != 0 ) )
   {
      X_Vec_Init(pX_Ids,pX_Pro,pX_Fun,pX_DBM->pX_Fld,pX_DBM->sRetRRNO);
   }

   /* ---------------- */
   /* Finally Finished */
   /* ---------------- */

   return;
}

#endif

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))

/*===================================================================*/
/* Function     : X_GetIdentificationPtr                             */
/* Description  : Returns the Modules Identification Table Pointer   */
/*                No standard parameters are declared so that this   */
/*                entry point can be declared in any DLL.            */
/* Arguments    :                                                    */
/*===================================================================*/
X_PVOID_FUNCTION X_GetIdentificationPtr ( void )
{
   %ident

   return &IdentificationTable;
}

#endif

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))

/*===================================================================*/
/* Function     : X_GetSQLName                                       */
/* Description  : Returns the correct table/view name to SELECT from */
/* Arguments    : pvchFileName  - Filename to convert                */
/*===================================================================*/
X_PVCHAR_FUNCTION X_GetSQLName( X_PVCHAR pvchFileName )
{
   %sqlname

   return (pX_NULL);
}

#endif

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Check_For_Request                            */
/* Description  : CHECK_FOR row request                              */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Check_For_Request(X_OAM_STANDARD_ARGS)
{

   X_SHORT  sStringLength;
   X_SHORT  i;
   X_SQLDA *pSqlda;
   X_SHORT  sSqlda;

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */

      /* ----------------------------------- */
      /* Build the required SELECT statement */
      /* ----------------------------------- */

      strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
      X_OAM_Add_Table_Name(X_OAM_STANDARD_PARMS);

      /* Build WHERE according to keys passed in key field vectors */

      strcat(pG->vchSqlStmnt," WHERE ");
      for (i = 0; i < pX_DBM->scKeyFlds; i++)
      {
         X_SHORT j;

         if (i > 0) strcat(pG->vchSqlStmnt," AND ");

         %where

         strcat(pG->vchSqlStmnt," = ");

         j = pX_DBM->psKeyFlds[i];

         if ( !X_OAM_Add_Value_To_Stmnt(X_OAM_STANDARD_PARMS, j, i) )
         {
            return;
         }
      }

      /* Build ORDER BY according to table/index keys .....            */

      %orderby

      /* ------------------------------------- */
      /* Prepare the required SELECT statement */
      /* ------------------------------------- */

      pX_Ids->chOAMRqsType = X_VARIANT_SELECT;
      pX_Ids->fX_DBM_PrepareParams = FALSE; /* Because RRN not in SQL */

      X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }

      /* --------------------- */
      /* Get appropriate SQLDA */
      /* --------------------- */
      sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
      if ( sSqlda < 0 ) return;

      /* --------------------------------------------------- */
      /* Open the cursor associated with the prepared SELECT */
      /* --------------------------------------------------- */

      X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, pX_DBM->sCursorID, pSqlda )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }

      /* ------------------------------- */
      /* Attempt to fetch a matching row */
      /* ------------------------------- */

      X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                 %ifntv
   else                                                 %ifntv
   {                                                    %ifntv
      /* ---------------------------- */                %ifntv
      /* Use Native I/O               */                %ifntv
      /* ---------------------------- */                %ifntv
      /* Locate a record */                             %ifntv
      X_OAM_Native_Locate( X_OAM_STANDARD_PARMS );      %ifntv
   }                                                    %ifntv
#endif                                                  %ifntv

   if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
    || (pX_Ids->chFatalError == YES))
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lFetchCode;
   }

   /* ------------------------------- */
   /* Set the appropriate return code */
   /* ------------------------------- */

   else if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_NOT_EQUAL_KEY);
      if (pX_DBM->chMsgReqd == YES)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0014",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
      }
   }

   else
      strcpy(pX_DBM->vchReturnCode,X_DBM_EQUAL_KEY);

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */

      /* ---------------------------------------------------- */
      /* Close the cursor associated with the prepared SELECT */
      /* ---------------------------------------------------- */

      X_DBM_OP( pG->lReturnCode, X_DBM_CLOSE_CURSOR, pX_NULL, pX_DBM->sCursorID, pX_NULL )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
	  {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
      }
   }

   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Close_Request                                */
/* Description  : CLOSE database file request                        */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Close_Request(X_OAM_STANDARD_ARGS)
{
   X_SHORT i;
   X_BOOL fCloseRequestCommon;

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      fCloseRequestCommon = ( ( pG->pFunctionOpening == pX_Fun ) && ( pG->pProcessOpening == pX_Pro ) );
   }
                                                                      %ifntv
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
      fCloseRequestCommon = FALSE;                                    %ifntv
      if ( pG->pX_Native_Curr->pFile != pX_NULL )                     %ifntv
      {                                                               %ifntv
         if ( ( pG->pX_Native_Curr->pFunctionOpening == pX_Fun )      %ifntv
              && ( pG->pX_Native_Curr->pProcessOpening == pX_Pro ) )  %ifntv
         {                                                            %ifntv
            X_LONG lRetCode;                                          %ifntv
                                                                      %ifntv
            /* Close the file requested     */                        %ifntv
            X_DBM_OP_NATIVE_CONTROL(lRetCode, X_DBM_NATIVE_CLOSE, pG->pX_Native_Curr)   %ifntv
            if ((lRetCode < X_DBMS_INFO_OKAY)                         %ifntv
             || (pX_Ids->chFatalError == YES))                        %ifntv
            {                                                         %ifntv
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);       %ifntv
               pX_Ids->lLastErrorCode = lRetCode;                     %ifntv
               return;                                                %ifntv
            }                                                         %ifntv
                                                                      %ifntv
            /* Are any input files still open? */                     %ifntv
            fCloseRequestCommon = TRUE;                               %ifntv
            for (i = 0; i < X_DBM_FILE_NAME_NUMBER; i++)              %ifntv
            {                                                         %ifntv
               if ( (pG->pX_Native_Input[i])->pFile != pX_NULL )      %ifntv
               {                                                      %ifntv
                  fCloseRequestCommon = FALSE;                        %ifntv
                  break;                                              %ifntv
               }                                                      %ifntv
            }                                                         %ifntv
         }                                                            %ifntv
      }                                                               %ifntv
   }                                                                  %ifntv
                                                                      %ifntv
#endif                                                                %ifntv

   /* ------------------------------------------------------------ */
   /* When shutting down the system, the DLL will be unloaded, so  */
   /* we must free the memory to stop leak reports.                */
   /* If this is the same process & function that first opened the */
   /* table then the OAM should be shutdown .....                  */
   /* ------------------------------------------------------------ */

   if ( pX_Ids->fSystemShutDownMode || fCloseRequestCommon )
   {
      X_OAM_Close_Request_Common(X_OAM_STANDARD_PARMS);
   }
   else
   {
      if (pFirstFldIndex) X_Deallocate_FldIndex(pX_Ids, pX_Fun);

      X_Deallocate_WhereFldIndex( pX_Ids, pG, pX_Fun );
   }

   strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);
   return;
}

/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Force_Close_Request                          */
/* Description  : FORCE CLOSE database file request                  */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Force_Close_Request(X_OAM_STANDARD_ARGS)
{
   /* -------------------------------------------------------------- */
   /* This function is only called when a fatal error has occurred   */
   /* -------------------------------------------------------------- */

   X_OAM_Close_Request_Common(X_OAM_STANDARD_PARMS);

   /* Indicate this OAM MUST be unloaded */

   pX_Ids->chShutDown = X_FORCE_UNLOAD;

   /* -------------------------------------------------------------- */
   /* Set the fatal error flag back on                               */
   /* -------------------------------------------------------------- */

   strcpy( pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR );

   return;
}

/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Close_Request_Common                         */
/* Description  : CLOSE or FORCE_CLOSE database file request         */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Close_Request_Common(X_OAM_STANDARD_ARGS)
{
   static X_BOOL  fClosing = FALSE;
   X_SHORT i;

   /* When closing, OAMs can call other OAMS that have code file lookups */
   /* to this OAM, which will cause this Close to be called, and hence   */
   /* recursion.                                                         */
   if (fClosing)
   {
      pX_Ids->chShutDown = X_ALWAYS_SKIP_UNLOAD; /* The DLL is in use so NEVER unload it */
      return;
   }

   fClosing = TRUE;

   /* Indicate this OAM can be unloaded */

   pX_Ids->chShutDown = YES;

   if ( X_DBM_EXEC_TRIGGER(pG->sLastRequest) )                     %cltrig
   {                                                               %cltrig
      /* Run before close trigger ..... */                         %cltrig
      strcpy(pG->X_Trigger.vchOper,"BEFCLS");                      %cltrig
      %RUNFT *BEFCLS0
   }                                                               %cltrig

   /* ---------------------------- */                                             %iflob
   /* LOB Cleanup                  */                                             %iflob
   /* ---------------------------- */                                             %iflob
                                                                                  %iflob
   X_RemoveLOBCursorDetails( pX_Ids,pX_Pro,pX_Fun,pX_DBM,X_File_Header.vchTable,pX_NULL,TRUE,pX_NULL ); %iflob
   %lobcleanup
                                                                                  %iflob
   /* Free memory for pvchTable */                                                %iflob
   X_PDF_Free_Memory( pX_Ids, pX_Pro, pX_Fun, (X_PVOID) (pG->pvchTable) );        %iflob
                                                                                  %iflob
   /* Cleanup any secure LOBs for this file */                                    %iflob
   X_Cleanup_LOB_Files( pX_Ids,pX_Pro,pX_Fun,pG->vchLOBFile,pX_NULL );            %iflob
                                                                                  %iflob
   /* Free any SQLDA that are allocated */
   for ( i = 0; i < pG->usMaxSqlda; i++ )
   {
      if ( pG->aSqlda[i].pSqlda )
      {
         X_DBM_OP( pG->lReturnCode, X_DBM_DEALLOCATE_SQLDA, pX_NULL, 0, &(pG->aSqlda[i].pSqlda) )
         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }
      }
   }

#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   if ( X_DBM_IS_USING_NATIVE_IO )                                    %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
                                                                      %ifntv
      /* Close all open input files   */                              %ifntv
                                                                      %ifntv
      for (i = 0; i < X_DBM_FILE_NAME_NUMBER; i++)                    %ifntv
      {                                                               %ifntv
         if ( (pG->pX_Native_Input[i])->pFile != pX_NULL )            %ifntv
         {                                                            %ifntv
            X_LONG lRetCode;                                          %ifntv
                                                                      %ifntv
            X_DBM_OP_NATIVE_CONTROL(lRetCode, X_DBM_NATIVE_CLOSE, pG->pX_Native_Input[i])  %ifntv
            if ((lRetCode < X_DBMS_INFO_OKAY)                         %ifntv
             || (pX_Ids->chFatalError == YES))                        %ifntv
            {                                                         %ifntv
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);       %ifntv
               pX_Ids->lLastErrorCode = lRetCode;                     %ifntv
               return;                                                %ifntv
            }                                                         %ifntv
         }                                                            %ifntv
      }                                                               %ifntv
                                                                      %ifntv
      /* Close the update file if open        */                      %ifntv
      if ( pG->pX_Native_Update->pFile != pX_NULL )                   %ifntv
      {                                                               %ifntv
         X_LONG lRetCode;                                             %ifntv
                                                                      %ifntv
         X_DBM_OP_NATIVE_CONTROL(lRetCode, X_DBM_NATIVE_CLOSE, pG->pX_Native_Update)  %ifntv
         if ((lRetCode < X_DBMS_INFO_OKAY)                            %ifntv
          || (pX_Ids->chFatalError == YES))                           %ifntv
         {                                                            %ifntv
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);          %ifntv
            pX_Ids->lLastErrorCode = lRetCode;                        %ifntv
            return;                                                   %ifntv
         }                                                            %ifntv
      }                                                               %ifntv
   }                                                                  %ifntv
                                                                      %ifntv
#endif                                                                %ifntv


   pG->chFirstCall      = YES;
   pG->pFunctionOpening = pX_NULL;
   pG->pProcessOpening  = pX_NULL;

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   X_OAM_Deallocate_X_Var(X_OAM_STANDARD_PARMS);
#endif

   if ( X_DBM_EXEC_TRIGGER(pG->sLastRequest) )                     %cltrig
   {                                                               %cltrig
      /* Run after close trigger ..... */                          %cltrig
      strcpy(pG->X_Trigger.vchOper,"AFTCLS");                      %cltrig
      %RUNFT *AFTCLS0
   }                                                               %cltrig

   /* If batch control logic, deallocate the additional SQLDA's */ %ifbch
   %BchDal

   %PJFFree

	%NtvClose

   /* if code file lookups, close the files */
   %ChkDal

   /* Deallocate the FldIndex chain */

   if (pFirstFldIndex) X_Deallocate_FldIndex(pX_Ids, pX_NULL);

   X_Deallocate_WhereFldIndex( pX_Ids, pG, pX_NULL );

   X_VAR_VarChar_Release( pX_Ids, pX_Pro, pX_Fun, &VarCharTemp );
   %ll2free

   for ( i = 0; i < X_DBM_FILE_NAME_NUMBER; i++ )
   {
      if ( pG->UpdatedStmnt[i].fAllocated )
      {
         X_PDF_Free_Memory( pX_Ids, pX_NULL, pX_NULL, (X_PVOID)pG->UpdatedStmnt[i].pvchSelect );
         pG->UpdatedStmnt[i].pvchSelect = pX_NULL;
         X_PDF_Free_Memory( pX_Ids, pX_NULL, pX_NULL, (X_PVOID)pG->UpdatedStmnt[i].pvchOrder  );
         pG->UpdatedStmnt[i].pvchOrder = pX_NULL;
         X_PDF_Free_Memory( pX_Ids, pX_NULL, pX_NULL, (X_PVOID)pG->UpdatedStmnt[i].pvchBckOrd );
         pG->UpdatedStmnt[i].pvchBckOrd = pX_NULL;
         X_PDF_Free_Memory( pX_Ids, pX_NULL, pX_NULL, (X_PVOID)pG->UpdatedStmnt[i].pvchRRN    );
         pG->UpdatedStmnt[i].pvchRRN = pX_NULL;
         pG->UpdatedStmnt[i].fAllocated = FALSE;
      }
   }

   fClosing = FALSE;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Perform_Commit                               */
/* Description  : COMMIT database changes request                    */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_BOOL_FUNCTION X_OAM_Perform_Commit(X_OAM_STANDARD_ARGS)
{
   X_BOOL fDoCommit               = TRUE;
   X_CHAR chCommitRollbackChannel = X_COMMIT_ROLLBACK_UPDATE_CHANNEL_1;

   fDoCommit                     = FALSE;                                    %ifcmt
   chCommitRollbackChannel       = X_COMMIT_ROLLBACK_ALL_UPDATE_CHANNELS;    %ifcmt

   if (pX_DBM->chAutoCommit == X_DBM_COMMIT_YES)  fDoCommit = TRUE;         %ifcmt

   if (pX_DBM->chAutoCommit == X_DBM_COMMIT_FILE) fDoCommit = TRUE;         %ifacmt

   if (pX_Ids->fHeavyTransaction)                 fDoCommit = FALSE;

   if ( !AVOID_COMMIT )                                                     %ifncmt
   {                                                                        %ifncmt
      if (fDoCommit)
      {
         pX_Ids->chCommitRollbackChannel = chCommitRollbackChannel;

         pG->lReturnCode = X_Commit_DBMS(pX_Ids,pX_Pro,pX_Fun,pX_DBM);

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return(FALSE);
         }
      }
   }                                                                        %ifncmt

   return(TRUE);
}


/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Delete_Request                               */
/* Description  : DELETE row request                                 */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Delete_Request(X_OAM_STANDARD_ARGS)
{

   X_SHORT  sStringLength;
   X_SHORT  i;
   X_VCHAR  vchString[(X_MAX_UPID_FIELD_LEN * 2) + 2 + 1];
   X_LONG   lRowCount;
   X_SQLDA *pSqlda;
   X_SHORT  sSqlda;
   X_PVCHAR pvchRRNO = X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_RRN );
   X_BOOL   fError;
   X_BOOL  fCrossedUpdateCheck = TRUE;

   /* Abort if read-only file */                                       %ifrdonly
   {                                                                   %ifrdonly
      X_PVCHAR avchParms[3];                                           %ifrdonly
                                                                       %ifrdonly
      avchParms[0] = "DELETE";                                         %ifrdonly
      avchParms[1] = ErrTxt1;                                          %ifrdonly
      avchParms[2] = ErrTxt2;                                          %ifrdonly
                                                                       %ifrdonly
      X_Issue_Message_VChar_Ptrs( pX_Ids, pX_Pro, pX_Fun,              %ifrdonly
                                  pX_Ids->vchStandardMessageFile,      %ifrdonly
                                  "IOM0052", 3, avchParms );           %ifrdonly
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);                 %ifrdonly
      return;                                                          %ifrdonly
   }                                                                   %ifrdonly
                                                                       %ifrdonly
/* Delete always requires primary key or RRNO column */
#if defined(X_DBM_NO_PKEY)
   if ( !fHasRRNO )
   {
      X_Fatal_Error(pX_Ids,
                    pX_Pro,
                    pX_Fun,
                    "OAM for table %tablexxxx",
                    X_TEXT(842));
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      return;
   }
#endif

   /* ------------------------------- */
   /* Search for field index pointer  */
   /* ------------------------------- */

   X_Search_FldIndex (X_OAM_STANDARD_PARMS);

   /* -------------------------------- */
   /* Check if allowed to delete first */
   /* -------------------------------- */

   if (pG->chDeleteAuthChecked != YES)
   {
      pG->chAuthorised = X_Check_Authority(pX_Ids,
                                           pX_Pro,
                                           pX_Fun,
                                           "%tablexxxx",
                                           "%fulllibxx",
                                           X_OBJECT_TYPE_FILE,
                                           X_OBJECT_AUTH_DELETE_DATA);
      if (pG->chAuthorised == NO)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0012",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }
      else
         pG->chDeleteAuthChecked = YES;
   }

   /* ------------------------------------------------------------- */
   /* If no keys or where condition specified, then delete last row */
   /* read using @@RRNO from previous read or WITH_RRN vector       */
   /* ------------------------------------------------------------- */

   if ((pX_DBM->scKeyFlds == 0) && (pX_DBM->scWhere == 0)
    && (pX_DBM->chWhereRDML == NO))
   {
      /* If WITH_RRN specified use this vector as the delete key */
      /* Otherwise use the last RRNO from a previous FETCH       */

      if (pX_DBM->chWithRRNO == YES)
      {
         if ( !fHasRRNO )
         {
            X_Fatal_Error(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          "OAM for table %tablexxxx",
                          X_TEXT(842));
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            return;
         }
         else
         {
            X_Vec_Get_as_Double(pX_Ids,
                                pX_Pro,
                                pX_Fun,
                                pX_DBM->pX_Fld,
                                pX_DBM->sWithRRNO,
                                &(pG->dLastRRNO[pG->sFileNo]));
#ifdef X_OAM_UPID_REQUIRED
            if ( fHasUPID ) pG->dLastUPID[pG->sFileNo] = 0.0;
#endif
         }
         fCrossedUpdateCheck = FALSE;
      }

      /* Check that a previous record has been read */

      fError = FALSE;

      if ( fHasRRNO ) 
      {
         if ( pG->dLastRRNO[pG->sFileNo] == 0.0) fError = TRUE;
      }
#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
      if ( !fHasUPID )
      {
         if (pG->fLastSaved[pG->sFileNo] == FALSE) fError = TRUE;
      }
#endif

      if ( fError )
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0018",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
         return;
      }

      if ( !X_DBM_IS_USING_NATIVE_IO )
      {
         /* ---------------------------- */
         /* Use ODBC / ORACLE / SQLCLI   */
         /* ---------------------------- */

         /* Build the required SELECT statement using the RRNO (or PKEY) */

         strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );

         if ( fHasRRNO )
         {
#ifdef X_DATABASE_ORACLE
            sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = :0", X_DBM_SqlTableName, pvchRRNO );
#else
            sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = ?", X_DBM_SqlTableName, pvchRRNO );
#endif
            pX_Ids->chOAMRqsType = X_INVARIANT_SELECT;
         }
#ifdef X_OAM_REPLACE_RRN_WITH_PKEY_REQUIRED 
         else
         {
            /* Append table name and where clause of primary key from last record read */

            X_OAM_Add_Table_Name(X_OAM_STANDARD_PARMS);
            X_OAM_Build_Primary_Key_Where(X_OAM_STANDARD_PARMS,TRUE,FALSE,TRUE);
            if (pX_Ids->chFatalError == YES)
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
               return;
            }

            pX_Ids->chOAMRqsType = X_VARIANT_SELECT;
            pX_Ids->fX_DBM_PrepareParams = FALSE; /* Because RRN not in SQL */
         }
#endif

         /* Prepare the required SELECT statement */

         X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }

         /* --------------------- */
         /* Get appropriate SQLDA */
         /* --------------------- */
         sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
         if ( sSqlda < 0 ) return;

         /* Open the cursor associated with the prepared SELECT */

         if ( fHasRRNO )
         {
            /* Only one column to be processed (RRNO) */
            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) 1, 0, pSqlda )

            InsertRRNParms.xdVal  = pG->dLastRRNO[pG->sFileNo];
            InsertRRNParms.pSqlda = pSqlda;
            InsertRRNParms.pX_Fld = pX_Fld;
            X_DBM_OP( lDummyRetcode, X_DBM_INSERT_RRN, pX_NULL, 0, &InsertRRNParms )
         }

#ifdef X_DATABASE_ODBC
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )
#endif
         X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, pX_DBM->sCursorID, pSqlda )

         /* Always set SQLDANo back to default for fetch */
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }

         /* Attempt to fetch a matching row */

         X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )
      }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
      else                                                            %ifntv
      {                                                               %ifntv
         /* ---------------------------- */                           %ifntv
         /* Use iSeries Native IO        */                           %ifntv
         /* ---------------------------- */                           %ifntv
         /* Read by relative record number */                         %ifntv
         pG->pX_Native_Update->fLock        = TRUE;                   %ifntv
         X_OAM_Native_Fetch_RRN( X_OAM_STANDARD_PARMS );              %ifntv
      }                                                               %ifntv
#endif                                                                %ifntv

      if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
       || (pX_Ids->chFatalError == YES))
      {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lFetchCode;
      }


      /* If the record is no longer present */

      else if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0019",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
      }

      if ( !X_DBM_IS_USING_NATIVE_IO )
      {
         /* ---------------------------- */
         /* Use ODBC / ORACLE / SQLCLI   */
         /* ---------------------------- */
         /* Close the cursor associated with the prepared SELECT */

         X_DBM_OP( pG->lReturnCode, X_DBM_CLOSE_CURSOR, pX_NULL, pX_DBM->sCursorID, pX_NULL )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
		 {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
         }
      }

      if ((strcmp(pX_DBM->vchReturnCode,X_DBM_NO_RECORD) == 0)
       || (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0))
      {
         return;
      }

      if ( !X_DBM_IS_USING_NATIVE_IO )
      {
         /* ---------------------------- */
         /* Use ODBC / ORACLE / SQLCLI   */
         /* ---------------------------- */
         /* Map fields from the Sqlda structure */

         X_DBM_OP( lDummyRetcode, X_DBM_MAP_FROM_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSqlda )

       }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
      else                                                            %ifntv
      {                                                               %ifntv
         /* ---------------------------- */                           %ifntv
         /* Use iSeries Native IO        */                           %ifntv
         /* ---------------------------- */                           %ifntv
         /* Map from record buffer to OAM */                          %ifntv
         X_DBM_OP_NATIVE_MAP(lDummyRetcode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Update, pG->pX_Fld, &sX_Zero)  %ifntv
      }                                                               %ifntv
#endif                                                                %ifntv

      /* Execute virtual code */                                     %ifvcpjf
                                                                     %ifvcpjf
      X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_PARMS);           %ifvcpjf
      if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)      %ifvcpjf
      {                                                              %ifvcpjf
#if defined(X_OPERATING_SYSTEM_ISERIES)                       %ifntv %ifvcpjf
         if ( X_DBM_IS_USING_NATIVE_IO )                      %ifntv %ifvcpjf
         {                                                    %ifntv %ifvcpjf
            /* ---------------------------- */                %ifntv %ifvcpjf
            /* Use iSeries Native IO        */                %ifntv %ifvcpjf
            /* ---------------------------- */                %ifntv %ifvcpjf
            /* Unlock the record */                           %ifntv %ifvcpjf
            X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update) %ifntv %ifvcpjf
         }                                                    %ifntv %ifvcpjf
#endif                                                        %ifntv %ifvcpjf
         return;                                                     %ifvcpjf
      }                                                              %ifvcpjf

      fError = FALSE;

#ifdef X_OAM_UPID_REQUIRED
   if ( fHasUPID )
   {
      /* Determine if the @@UPID field has changed */

      X_Vec_Get_as_Double(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Fld,
                          X_V_%@UPID,
                          &(pG->dThisUPID));
      if (fCrossedUpdateCheck
       && (pG->dThisUPID != pG->dLastUPID[pG->sFileNo])) fError = TRUE;
   }
#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   else
   {
#endif
#endif
#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( fCrossedUpdateCheck )
   {
      /* Compare fields to see if any have changed */
      if (X_OAM_Compare_Current_Record(X_OAM_STANDARD_PARMS))  fError = TRUE;
   }
#ifdef X_OAM_UPID_REQUIRED
   } /* else */
#endif
#endif

      if ( fError )
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0020",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
         if ( X_DBM_IS_USING_NATIVE_IO )                              %ifntv
         {                                                            %ifntv
            /* ---------------------------- */                        %ifntv
            /* Use iSeries Native IO        */                        %ifntv
            /* ---------------------------- */                        %ifntv
            /* Unlock the record */                                   %ifntv
            X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update)  %ifntv
         }                                                            %ifntv
#endif                                                                %ifntv
         return;
      }

      /* Save the before delete field details */                     %ifbch
      *(pG->pX_Prev) = *(pG->pX_Curr);                               %ifbch

      /* Perform all deletion validation checks */

      X_OAM_Validation_Checks(X_OAM_STANDARD_PARMS,
                              X_DBM_DELETE_OPERATION);
      if (strcmp(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR) == 0)
      {
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
         if ( pX_DBM->fUseNativeIO )                                  %ifntv
         {                                                            %ifntv
            /* ---------------------------- */                        %ifntv
            /* Use iSeries Native IO        */                        %ifntv
            /* ---------------------------- */                        %ifntv
            /* Unlock the record */                                   %ifntv
            X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update) %ifntv
         }                                                            %ifntv
#endif                                                                %ifntv
         return;
      }

      /* Run before delete trigger */                                %dltrig
      strcpy(pG->X_Trigger.vchOper,"BEFDLT");                        %dltrig
      %RUNFT *BEFDLT1

      /* If only validation checks are to be performed then return */

      if (pX_DBM->chValOnly == YES)
      {
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
         if ( pX_DBM->fUseNativeIO )                                  %ifntv
         {                                                            %ifntv
            /* ---------------------------- */                        %ifntv
            /* Use iSeries Native IO        */                        %ifntv
            /* ---------------------------- */                        %ifntv
            /* Unlock the record */                                   %ifntv
            X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update)         %ifntv
         }                                                            %ifntv
#endif                                                                %ifntv
         strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);
         return;
      }

      if ( !X_DBM_IS_USING_NATIVE_IO )
      {
         /* ---------------------------- */
         /* Use ODBC / ORACLE / SQLCLI   */
         /* ---------------------------- */
         /* Build the required DELETE statement using the RRNO (or PKEY) */

         strcpy(pG->vchSqlStmnt,X_DBM_DeleteFlds);

         if ( fHasRRNO )
         {
#ifdef X_DATABASE_ORACLE
            sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt)," WHERE %s = :0", pvchRRNO );
#else
            sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt)," WHERE %s = ?", pvchRRNO );
#endif
#ifdef X_OAM_UPID_REQUIRED
            if ( fHasUPID )
            {
               /* Append the UPID */
               X_Set_Vchar_from_Double(pX_Ids,pX_Pro,pX_Fun,pG->dThisUPID,vchString,
                                       sizeof(vchString),X_L_X_UPID,X_D_X_UPID);
               sprintf(pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),
                       " AND %s = %s",X_DBM_UPIDNativeName,vchString);
               pX_Ids->chOAMRqsType = X_VARIANT_DELETE;
            }
            else
#endif
            {
               pX_Ids->chOAMRqsType = X_INVARIANT_DELETE;
            }
         }
#ifdef X_OAM_REPLACE_RRN_WITH_PKEY_REQUIRED 
         else
         {
            /* Append where clause of primary key from last record read                */
            /* Note there is a small window btn previous read and this delete where    */
            /* an update may have occurred (as we don't specify all fields on file in  */
            /* the where clause -- the equivalent of specify X_UPID in where clause)   */

            X_OAM_Build_Primary_Key_Where(X_OAM_STANDARD_PARMS,TRUE,FALSE,TRUE);
            if (pX_Ids->chFatalError == YES)
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
               return;
            }
            pX_Ids->chOAMRqsType = X_VARIANT_DELETE;
         }
#endif

         AVOID_JOURNALING(pG->vchSqlStmnt)                              %ifncmt

         X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }

         /* --------------------- */
         /* Get appropriate SQLDA */
         /* --------------------- */
         sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
         if ( sSqlda < 0 ) return;

         /* Execute the prepared DELETE statement */

         if ( fHasRRNO )
         {
            /* Only one column to be processed (RRNO) */
            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) 1, 0, pSqlda )
         }

         X_DBM_OP( pG->lReturnCode, X_DBM_EXECUTE_ROWCOUNT, (X_PVCHAR) (&lRowCount), pX_DBM->sCursorID, pSqlda )

         /* Always set SQLDANo back to default */
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }

         /* If no rows deleted, determine whether row deleted or updated */
         if (lRowCount < 1)
         {
            if ( !fHasRRNO )
            {
               /* Always do this when updating by PKEY as row must have been deleted */
               strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
               X_Issue_Message_Vec(pX_Ids,
                                   pX_Pro,
                                   pX_Fun,
                                   pX_Ids->vchStandardMessageFile,
                                   "IOM0019",
                                   pX_Fld,
                                   2,
                                   X_DBM_FilLibVecs);
            }
            else
            {
               /* Build the required SELECT statement using the RRNO */

               strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
#ifdef X_DATABASE_ORACLE
               sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = :0", X_DBM_SqlTableName, pvchRRNO );
#else
               sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = ?", X_DBM_SqlTableName, pvchRRNO );
#endif

               /* Prepare the required SELECT statement */

               pX_Ids->chOAMRqsType = X_INVARIANT_SELECT;

               X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

               if (pG->lReturnCode != X_DBMS_INFO_OKAY)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lReturnCode;
                  return;
               }

               /* Open the cursor associated with the prepared SELECT */

               /* Only one column to be processed (RRNO) */
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) 1, 0, pSqlda )

               InsertRRNParms.xdVal  = pG->dLastRRNO[pG->sFileNo];
               InsertRRNParms.pSqlda = pSqlda;
               InsertRRNParms.pX_Fld = pX_Fld;
               X_DBM_OP( lDummyRetcode, X_DBM_INSERT_RRN, pX_NULL, 0, &InsertRRNParms )

#ifdef X_DATABASE_ODBC
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )
#endif
               X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, pX_DBM->sCursorID, pSqlda )

               /* Always set SQLDANo back to default for fetch */
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )

               if (pG->lReturnCode != X_DBMS_INFO_OKAY)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lReturnCode;
                  return;
               }

               /* Attempt to fetch a matching row */

               X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )

               if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
                   || (pX_Ids->chFatalError == YES))
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lReturnCode;
               }

               /* If the record is no longer present */

               else if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
                  X_Issue_Message_Vec(pX_Ids,
                                      pX_Pro,
                                      pX_Fun,
                                      pX_Ids->vchStandardMessageFile,
                                      "IOM0019",
                                      pX_Fld,
                                      2,
                                      X_DBM_FilLibVecs);
               }
               /* Close the cursor associated with the prepared SELECT */

               X_DBM_OP( pG->lReturnCode, X_DBM_CLOSE_CURSOR, pX_NULL, pX_DBM->sCursorID, pX_NULL )

               if (pG->lReturnCode != X_DBMS_INFO_OKAY)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lReturnCode;
               }

               if ((strcmp(pX_DBM->vchReturnCode,X_DBM_NO_RECORD) == 0)
                || (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0))
                  return;

               /* If we get this far, we've had a crossed update */

               strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
               X_Issue_Message_Vec(pX_Ids,
                                   pX_Pro,
                                   pX_Fun,
                                   pX_Ids->vchStandardMessageFile,
                                   "IOM0020",
                                   pX_Fld,
                                   2,
                                   X_DBM_FilLibVecs);

               return;
            } /* endif !fHasRRNO */
         } /* if no rows deleted */
      }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
      else                                                            %ifntv
      {                                                               %ifntv
         /* ---------------------------- */                           %ifntv
         /* Use iSeries Native IO        */                           %ifntv
         /* ---------------------------- */                           %ifntv
         /* Delete the record */                                      %ifntv
         X_DBM_OP_NATIVE_CONTROL(pG->lFetchCode, X_DBM_NATIVE_DELETE, pG->pX_Native_Update)  %ifntv
      }                                                               %ifntv
#endif                                                                %ifntv

      strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

      if ( fHasRRNO )
      {
         /* Return @@RRNO if requested */

         if (pX_DBM->chRetRRNO == YES)
            X_Vec_Assign(pX_Ids,
                         pX_Pro,
                         pX_Fun,
                         pX_Fld,
                         X_V_%@RRNOxxxx,
                         pX_DBM->pX_Fld,
                         pX_DBM->sRetRRNO);
      }

      /* Execute batch control logic */                              %ifbch
      X_OAM_Update_Batch_Control(X_OAM_STANDARD_PARMS,               %ifbch
                                 X_DBM_DELETE_OPERATION);            %ifbch
      if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)      %ifbch
         return;                                                     %ifbch

      /* Issue the database COMMIT */

      if ( !(X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS)) ) return;

      /* Drop High Speed Key entries if enabled */

      if (pX_Ids->fHSKCEnabled)
         X_HSKC_Drop(pX_Ids, pX_Pro, pX_Fun, "%sqltablex");

      /* Run after delete trigger */                                 %dltrig
      strcpy(pG->X_Trigger.vchOper,"AFTDLT");                        %dltrig
      %RUNFT *AFTDLT1

      return;

   }

   /* ---------------------------------------------------------*/
   /* If keys are specified then build the WHERE from the keys */
   /* -------------------------------------------------------- */

   /* Check if authorised to read the file first */

   if (pG->chReadAuthChecked != YES)
   {
      pG->chAuthorised = X_Check_Authority(pX_Ids,
                                           pX_Pro,
                                           pX_Fun,
                                           "%tablexxxx",
                                           "%fulllibxx",
                                           X_OBJECT_TYPE_FILE,
                                           X_OBJECT_AUTH_READ_DATA);
      if (pG->chAuthorised == NO)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0009",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }
      else
         pG->chReadAuthChecked = YES;
   }

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* Build the required SELECT statement */

      strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
      X_OAM_Add_Table_Name(X_OAM_STANDARD_PARMS);

      /* Build WHERE according to keys passed in key field vectors */

      if (pX_DBM->scKeyFlds > 0)
         strcat(pG->vchSqlStmnt," WHERE ");

      for (i = 0; i < pX_DBM->scKeyFlds; i++)
      {
         X_SHORT j;

         if (i > 0) strcat(pG->vchSqlStmnt," AND ");

         %where

         strcat(pG->vchSqlStmnt," = ");

         j = pX_DBM->psKeyFlds[i];

         if ( !X_OAM_Add_Value_To_Stmnt(X_OAM_STANDARD_PARMS, j, i) )
         {
            return;
         }
      }

      /* Add any WHERE condition if it involves only "real" fields */

      if (pX_DBM->scWhere > 0)
      {
         if (i > 0)
            strcat(pG->vchSqlStmnt," AND ");
         else
            strcat(pG->vchSqlStmnt," WHERE ");
         X_OAM_Build_Where(X_OAM_STANDARD_PARMS);
         if (pX_Ids->chFatalError == YES)
         {
            strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
            return;
         }
      }

      /* Build ORDER BY according to table/index keys */

      %orderby

      /* Prepare the required SELECT statement */

      pX_Ids->chOAMRqsType = X_VARIANT_SELECT;
      pX_Ids->fX_DBM_PrepareParams = FALSE; /* Because RRN not in SQL */

      X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }

      /* --------------------- */
      /* Get appropriate SQLDA */
      /* --------------------- */
      sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
      if ( sSqlda < 0 ) return;

      /* Open the cursor associated with the prepared SELECT */

      X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, pX_DBM->sCursorID, pSqlda )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }

      /* Attempt to fetch a matching row */

      X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use iSeries Native IO        */                              %ifntv
      /* ---------------------------- */                              %ifntv
      X_OAM_Native_Fetch_First( X_OAM_STANDARD_PARMS );               %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
    || (pX_Ids->chFatalError == YES))
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lFetchCode;
      return;
   }

   /* Set the appropriate return code */

   if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
      if (pX_DBM->chMsgReqd == YES)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0005",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
      }

      /* Close the cursor associated with the prepared SELECT */

      if (pX_DBM->chWhereRDML == NO)
      {
         X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS);
      }

      return;
   }
   else
      strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* Map fields from the Sqlda structure */

      X_DBM_OP( lDummyRetcode, X_DBM_MAP_FROM_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use iSeries Native IO        */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Map from record buffer to OAM */                             %ifntv
      X_DBM_OP_NATIVE_MAP(lDummyRetcode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Curr, pG->pX_Fld, &sX_Zero)  %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   /* Execute virtual code */                                     %ifvcpjf
                                                                  %ifvcpjf
   X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_PARMS);           %ifvcpjf
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)      %ifvcpjf
   {                                                              %ifvcpjf
      return;                                                     %ifvcpjf
   }                                                              %ifvcpjf

   /* Save the @@RRNO and @@UPID */

   if ( fHasRRNO )
   {
      X_Vec_Get_as_Double(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Fld,
                          X_V_%@RRNOxxxx,
                          &(pG->dLastRRNO[pG->sFileNo]));

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID )
      {
         X_Vec_Get_as_Double(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@UPID,
                             &(pG->dLastUPID[pG->sFileNo]));
      }
#endif

      /* Return @@RRNO if requested */

      if ( pX_DBM->chRetRRNO == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      X_V_%@RRNOxxxx,
                      pX_DBM->pX_Fld,
                      pX_DBM->sRetRRNO);
   }

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( (!fHasUPID) && (X_OAM_Save_Current_Record(X_OAM_STANDARD_PARMS) != TRUE) )
   {
      return;
   }
#endif

   /* Save the before delete field details */                         %ifbch
   *(pG->pX_Prev) = *(pG->pX_Curr);                                   %ifbch

   /* ---------------------------------------------------- */
   /* Map the OAM field vectors to the group field vectors */
   /* if the WHERE to be evaluated in the RDML .....       */
   /* ---------------------------------------------------- */

   if (pX_DBM->chWhereRDML == YES)
   {
      struct X_DBM_FLDINDEX *pCurr = pG->pCurrFldIndex;
      for (i = 0; i < X_TOTAL_FIELDS; i++)
      {
         if (pCurr->X_DBM_FldsUsed[i] == YES)
            X_Vec_Assign(pX_Ids,
                         pX_Pro,
                         pX_Fun,
                         pX_Fld,
                         i,
                         pX_DBM->pX_Fld,
                         pCurr->X_DBM_FldsIndex[i]);
      }

      /* Reverse data if SREV used */                                 %ifsrev
      if (X_LANGUAGE_IS_RLTB)                                         %ifsrev
      {                                                               %ifsrev
         for (i = 0; i < pX_DBM->scGrpFlds; i++)                      %ifsrev
         {                                                            %ifsrev
            %srevdout
                  X_Reverse_String(pX_Ids,pX_Pro,pX_Fun,              %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].pField,   %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].sByteLen);%ifsrev
         }                                                            %ifsrev
      }                                                               %ifsrev
   }

   /* -------------------------------------------------------- */
   /* If there is no WHERE condition to be tested in the RDML  */
   /* function, then call X_DBM_Delete_Next_Request repeatedly */
   /* until end of file .....                                  */
   /* -------------------------------------------------------- */

   if (pX_DBM->chWhereRDML == NO)
   {
      pX_DBM->chActionRow = YES;

      while(memcmp(pX_DBM->vchReturnCode,X_DBM_OKAY,2) == 0)
      {
         X_OAM_Delete_Next_Request(X_OAM_STANDARD_PARMS);
      }

      /* Reset return code if no more records ..... */
      if (memcmp(pX_DBM->vchReturnCode,X_DBM_NO_RECORD,2) == 0)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);
      }

      X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS);
   }

   return;

}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Delete_Next_Request                          */
/* Description  : DELETE_NEXT row request                            */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Delete_Next_Request(X_OAM_STANDARD_ARGS)
{

   X_SHORT  sCursorID;
   X_SHORT  i;
   X_PVCHAR pvchRRNO = X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_RRN );
   X_LONG   lRowCount;
   X_VCHAR  vchString[(X_MAX_UPID_FIELD_LEN * 2) + 2 + 1];
   X_SQLDA *pUpdateSqlda;
   X_SHORT  sUpdateSqlda;
   X_SQLDA *pSelectSqlda;
   X_SHORT  sSelectSqlda;
   X_BOOL   fError;

/* Delete always requires primary key or RRNO column */
#if defined(X_DBM_NO_PKEY)
   if ( !fHasRRNO )
   {
      X_Fatal_Error(pX_Ids,
                    pX_Pro,
                    pX_Fun,
                    "OAM for table %tablexxxx",
                    X_TEXT(842));
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      return;
   }
#endif

   /* ------------------------------- */
   /* Search for field index pointer  */
   /* ------------------------------- */

   X_Search_FldIndex (X_OAM_STANDARD_PARMS);

   /* ---------------------------- */
   /* If this row is to be deleted */
   /* ---------------------------- */

   if (pX_DBM->chActionRow == YES)
   {
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
      if ( X_DBM_IS_USING_NATIVE_IO )                                 %ifntv
      {                                                               %ifntv
         /* ---------------------------- */                           %ifntv
         /* Use iSeries Native IO        */                           %ifntv
         /* ---------------------------- */                           %ifntv
         /* Read by relative record number */                         %ifntv
         pG->pX_Native_Update->fLock        = TRUE;                   %ifntv
         X_OAM_Native_Fetch_RRN( X_OAM_STANDARD_PARMS );              %ifntv
                                                                      %ifntv
         if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)             %ifntv
         {                                                            %ifntv
            /* iSeries compatibility issue - this is what L4iS does */   %ifntv
            strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);            %ifntv
            X_Issue_Message_Vec(pX_Ids,                               %ifntv
                                pX_Pro,                               %ifntv
                                pX_Fun,                               %ifntv
                                pX_Ids->vchStandardMessageFile,       %ifntv
                                "IOM0019",                            %ifntv
                                pX_Fld,                               %ifntv
                                2,                                    %ifntv
                                X_DBM_FilLibVecs);                    %ifntv
            return;                                                   %ifntv
         }                                                            %ifntv
         else                                                         %ifntv
         {                                                            %ifntv
            const X_BOOL fCrossedUpdateCheck = TRUE;                  %ifntv
                                                                      %ifntv
            /* Map from record buffer to OAM */                       %ifntv
            X_DBM_OP_NATIVE_MAP(pG->lFetchCode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Update, pG->pX_Fld, &sX_Zero) %ifntv
                                                                      %ifntv
            fError = FALSE;                                           %ifntv
#ifdef X_OAM_UPID_REQUIRED                                            %ifntv
            if ( fHasUPID )                                           %ifntv
            {                                                         %ifntv
               /* Determine if the @@UPID field has changed */        %ifntv
                                                                      %ifntv
               X_Vec_Get_as_Double(pX_Ids,                            %ifntv
                                   pX_Pro,                            %ifntv
                                   pX_Fun,                            %ifntv
                                   pX_Fld,                            %ifntv
                                   X_V_%@UPID,                        %ifntv
                                   &(pG->dThisUPID));                 %ifntv
               if (fCrossedUpdateCheck                                %ifntv
                && (pG->dThisUPID != pG->dLastUPID[pG->sFileNo])) fError = TRUE; %ifntv
            }                                                         %ifntv
#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED                                %ifntv
            else                                                      %ifntv
            {                                                         %ifntv
#endif                                                                %ifntv
#endif                                                                %ifntv
#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED                                %ifntv
            if ( fCrossedUpdateCheck )                                %ifntv
            {                                                         %ifntv
               /* Compare fields to see if any have changed */        %ifntv
               if (X_OAM_Compare_Current_Record(X_OAM_STANDARD_PARMS))  fError = TRUE; %ifntv
            }                                                         %ifntv
#ifdef X_OAM_UPID_REQUIRED                                            %ifntv
            } /* else */                                              %ifntv
#endif                                                                %ifntv
#endif                                                                %ifntv
            if ( fError )                                             %ifntv
            {                                                         %ifntv
               strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);  %ifntv
               X_Issue_Message_Vec(pX_Ids,                            %ifntv
                                   pX_Pro,                            %ifntv
                                   pX_Fun,                            %ifntv
                                   pX_Ids->vchStandardMessageFile,    %ifntv
                                   "IOM0020",                         %ifntv
                                   pX_Fld,                            %ifntv
                                   2,                                 %ifntv
                                   X_DBM_FilLibVecs);                 %ifntv
                                                                      %ifntv
               /* Unlock the record */                                %ifntv
               X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update)   %ifntv
               return;                                                %ifntv
            }                                                         %ifntv
         }                                                            %ifntv
      }                                                               %ifntv
#endif                                                                %ifntv

      /* Perform all deletion validation checks */

      X_OAM_Validation_Checks(X_OAM_STANDARD_PARMS,
                              X_DBM_DELETE_OPERATION);
      if (strcmp(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR) == 0)
      {
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
         if ( X_DBM_IS_USING_NATIVE_IO )                              %ifntv
         {                                                            %ifntv
            /* ---------------------------- */                        %ifntv
            /* Use iSeries Native IO        */                        %ifntv
            /* ---------------------------- */                        %ifntv
            /* Unlock the record */                                   %ifntv
            X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update)  %ifntv
         }                                                            %ifntv
#endif                                                                %ifntv
         return;
      }

      /* Run before delete trigger */                                 %dltrig
      strcpy(pG->X_Trigger.vchOper,"BEFDLT");                         %dltrig
      %RUNFT *BEFDLT1

      /* If only validation checks to be performed then don't delete */

      if (pX_DBM->chValOnly == YES)
      {
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
         if ( X_DBM_IS_USING_NATIVE_IO )                              %ifntv
         {                                                            %ifntv
            /* ---------------------------- */                        %ifntv
            /* Use iSeries Native IO        */                        %ifntv
            /* ---------------------------- */                        %ifntv
            /* Unlock the record */                                   %ifntv
            X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update)  %ifntv
         }                                                            %ifntv
#endif                                                                %ifntv
         strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);
      }
      else
      {

         if ( !X_DBM_IS_USING_NATIVE_IO )
         {
            /* ---------------------------- */
            /* Use ODBC / ORACLE / SQLCLI   */
            /* ---------------------------- */
            /* Build the required DELETE statement using the last @@RRNO or PKEY read */

            strcpy(pG->vchSqlStmnt,X_DBM_DeleteFlds);

            if ( fHasRRNO )
            {
#ifdef X_DATABASE_ORACLE
               sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt)," WHERE %s = :0", pvchRRNO );
#else
               sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt)," WHERE %s = ?", pvchRRNO );
#endif
#ifdef X_OAM_UPID_REQUIRED
               if ( fHasUPID )
               {
                  /* Append the UPID */
                  X_Set_Vchar_from_Double(pX_Ids,pX_Pro,pX_Fun,pG->dLastUPID[pG->sFileNo],vchString,
                                          sizeof(vchString),X_L_X_UPID,X_D_X_UPID);
                  sprintf(pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),
                          " AND %s = %s",X_DBM_UPIDNativeName,vchString);
                  pX_Ids->chOAMRqsType = X_VARIANT_DELETE;
               }
               else
#endif
               {
                  pX_Ids->chOAMRqsType = X_INVARIANT_DELETE;
               }
            }
#ifdef X_OAM_REPLACE_RRN_WITH_PKEY_REQUIRED
            else
            {
               /* Append where clause of primary key from last record read                */
               /* Note there is a small window btn previous read and this delete where    */
               /* an update may have occurred (as we don't specify all fields on file in  */
               /* the where clause -- the equivalent of specify X_UPID in where clause)   */

               X_OAM_Build_Primary_Key_Where(X_OAM_STANDARD_PARMS,TRUE,FALSE,TRUE);
               if (pX_Ids->chFatalError == YES)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  return;
               }
            }
#endif

            AVOID_JOURNALING(pG->vchSqlStmnt)                        %ifncmt

            X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &sCursorID )

            if (pG->lReturnCode != X_DBMS_INFO_OKAY)
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
               pX_Ids->lLastErrorCode = pG->lReturnCode;
               return;
            }

            /* --------------------- */
            /* Get appropriate SQLDA */
            /* --------------------- */
            sUpdateSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pUpdateSqlda,X_SQLDA_SEL_DEL,TRUE);
            if ( sUpdateSqlda < 0 ) return;

            /* Perform delete using an EXECUTE request */

            if ( fHasRRNO )
            {
               /* Only one column to be processed (RRNO) */
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) 1, 0, pUpdateSqlda )
            }
            X_DBM_OP( pG->lReturnCode, X_DBM_EXECUTE_ROWCOUNT, (X_PVCHAR) (&lRowCount), sCursorID, pUpdateSqlda )

            /* Always set SQLDANo back to default */
            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pUpdateSqlda )

            if (pG->lReturnCode != X_DBMS_INFO_OKAY)
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
               pX_Ids->lLastErrorCode = pG->lReturnCode;
               return;
            }

            /* If no rows deleted, determine whether row deleted or updated   */
            /* This processing is not necessary where updating without UPID   */
            /* as there is no crossed update checking and missing rows are ok */

            if ( fHasRRNO && fHasUPID && lRowCount < 1)
            {
               X_SHORT  sCursorID2;

               /* Build the required SELECT statement using the RRNO */

               strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
#ifdef X_DATABASE_ORACLE
               sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = :0", X_DBM_SqlTableName, pvchRRNO );
#else
               sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = ?", X_DBM_SqlTableName, pvchRRNO );
#endif

               /* Prepare the required SELECT statement */

               pX_Ids->chOAMRqsType = X_INVARIANT_SELECT;

               X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &sCursorID2 )

               if (pG->lReturnCode != X_DBMS_INFO_OKAY)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lReturnCode;
                  return;
               }

               /* --------------------- */
               /* Get appropriate SQLDA */
               /* --------------------- */
               sSelectSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSelectSqlda,X_SQLDA_SEL_DEL,FALSE);
               if ( sSelectSqlda < 0 ) return;

               /* Open the cursor associated with the prepared SELECT */

               /* Only one column to be processed (RRNO) */
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) 1, 0, pSelectSqlda )

               InsertRRNParms.xdVal  = pG->dLastRRNO[pG->sFileNo];
               InsertRRNParms.pSqlda = pSelectSqlda;
               InsertRRNParms.pX_Fld = pX_Fld;
               X_DBM_OP( lDummyRetcode, X_DBM_INSERT_RRN, pX_NULL, 0, &InsertRRNParms )

#ifdef X_DATABASE_ODBC
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSelectSqlda )
#endif
               X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, sCursorID2, pSelectSqlda )

               /* Always set SQLDANo back to default for fetch */
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSelectSqlda )

               if (pG->lReturnCode != X_DBMS_INFO_OKAY)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lReturnCode;
                  return;
               }

               /* Attempt to fetch a matching row */

               X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, sCursorID2, pSelectSqlda )

               /* Close the cursor associated with the prepared SELECT */

               X_DBM_OP( pG->lReturnCode, X_DBM_CLOSE_CURSOR, pX_NULL, sCursorID2, pX_NULL )

               if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
                   || (pG->lReturnCode < X_DBMS_INFO_OKAY)
                   || (pX_Ids->chFatalError == YES))
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  if (pG->lFetchCode < X_DBMS_INFO_OKAY)
                     pX_Ids->lLastErrorCode = pG->lFetchCode;
                  if (pG->lReturnCode < X_DBMS_INFO_OKAY)
                     pX_Ids->lLastErrorCode = pG->lReturnCode;
                  return;
               }

               /* If the record is no longer present */

               else if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
               {
                  /* Do not cause an error, simply move to next record */
                  pG->lReturnCode = X_DBMS_INFO_OKAY;
               }

               /* If we get this far, we've had a crossed update */

               else
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
                  X_Issue_Message_Vec(pX_Ids,
                                      pX_Pro,
                                      pX_Fun,
                                      pX_Ids->vchStandardMessageFile,
                                      "IOM0020",
                                      pX_Fld,
                                      2,
                                      X_DBM_FilLibVecs);
                  return;
               }

            } /* if no rows deleted */
         }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
         else                                                         %ifntv
         {                                                            %ifntv
            /* ---------------------------- */                        %ifntv
            /* Use iSeries Native IO        */                        %ifntv
            /* ---------------------------- */                        %ifntv
            /* Delete the record */                                   %ifntv
            X_DBM_OP_NATIVE_CONTROL(pG->lFetchCode, X_DBM_NATIVE_DELETE, pG->pX_Native_Update)   %ifntv
         }                                                            %ifntv
#endif                                                                %ifntv

         strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

         /* Execute batch control logic */                            %ifbch
         X_OAM_Update_Batch_Control(X_OAM_STANDARD_PARMS,             %ifbch
                                    X_DBM_DELETE_OPERATION);          %ifbch
         if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)    %ifbch
            return;                                                   %ifbch

         /* Issue the database COMMIT */

         if ( !(X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS)) ) return;

         /* Drop High Speed Key entries if enabled */

         if (pX_Ids->fHSKCEnabled)
            X_HSKC_Drop(pX_Ids, pX_Pro, pX_Fun, "%sqltablex");

         /* Run after delete trigger */                               %dltrig
         strcpy(pG->X_Trigger.vchOper,"AFTDLT");                      %dltrig
         %RUNFT *AFTDLT1
      }
   }


   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* ----------------------------------------------------- */
      /* FETCH the next row using the cursor previously opened */
      /* ----------------------------------------------------- */

      /* --------------------- */
      /* Get appropriate SQLDA */
      /* --------------------- */
      sSelectSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSelectSqlda,X_SQLDA_SEL_DEL,TRUE);
      if ( sSelectSqlda < 0 ) return;

      /* Attempt to fetch a matching row */

      X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSelectSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use iSeries Native IO        */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Read next record  */                                         %ifntv
      X_OAM_Native_Fetch_Next( X_OAM_STANDARD_PARMS );                %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
    || (pX_Ids->chFatalError == YES))
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lFetchCode;
      return;
   }

   /* Set the appropriate return code */

   if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
      return;
   }

   strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* Map fields from the Sqlda structure */

      X_DBM_OP( lDummyRetcode, X_DBM_MAP_FROM_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSelectSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use iSeries Native IO        */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Map from record buffer to OAM */                             %ifntv
      X_DBM_OP_NATIVE_MAP(lDummyRetcode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Curr, pG->pX_Fld, &sX_Zero)  %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   /* Execute virtual code */                                       %ifvcpjf
                                                                    %ifvcpjf
   X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_PARMS);             %ifvcpjf
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)        %ifvcpjf
      return;                                                       %ifvcpjf

   /* Save the @@RRNO and @@UPID */

   if ( fHasRRNO )
   {
      X_Vec_Get_as_Double(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Fld,
                          X_V_%@RRNOxxxx,
                          &(pG->dLastRRNO[pG->sFileNo]));

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID )
      {
         X_Vec_Get_as_Double(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@UPID,
                             &(pG->dLastUPID[pG->sFileNo]));
      }
#endif

      /* Return @@RRNO if requested */

      if ( pX_DBM->chRetRRNO == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      X_V_%@RRNOxxxx,
                      pX_DBM->pX_Fld,
                      pX_DBM->sRetRRNO);
   }

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( (!fHasUPID) && (X_OAM_Save_Current_Record(X_OAM_STANDARD_PARMS) != TRUE) )
   {
      return;
   }
#endif

   /* Save the before delete field details */                         %ifbch
   *(pG->pX_Prev) = *(pG->pX_Curr);                                   %ifbch

   /* ---------------------------------------------------- */
   /* Map the OAM field vectors to the group field vectors */
   /* if the WHERE to be evaluated in the RDML .....       */
   /* ---------------------------------------------------- */

   if (pX_DBM->chWhereRDML == YES)
   {
      struct X_DBM_FLDINDEX *pCurr = pG->pCurrFldIndex;
      for (i = 0; i < X_TOTAL_FIELDS; i++)
      {
         if (pCurr->X_DBM_FldsUsed[i] == YES)
            X_Vec_Assign(pX_Ids,
                         pX_Pro,
                         pX_Fun,
                         pX_Fld,
                         i,
                         pX_DBM->pX_Fld,
                         pCurr->X_DBM_FldsIndex[i]);
      }

      /* Reverse data if SREV used */                                 %ifsrev
      if (X_LANGUAGE_IS_RLTB)                                         %ifsrev
      {                                                               %ifsrev
         for (i = 0; i < pX_DBM->scGrpFlds; i++)                      %ifsrev
         {                                                            %ifsrev
            %srevdout
                  X_Reverse_String(pX_Ids,pX_Pro,pX_Fun,              %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].pField,   %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].sByteLen);%ifsrev
         }                                                            %ifsrev
      }                                                               %ifsrev
   }

   return;
}

#endif
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
/* ================================================================= */ %ifntv
/*                                                                   */ %ifntv
/* Function     : X_OAM_Native_Fetch_RRN                             */ %ifntv
/* Description  : Fetch the record by RRN via native I/O             */ %ifntv
/*                                                                   */ %ifntv
/* Arguments    : pX_Ids       - standard system def. structure      */ %ifntv
/*                pX_Pro       - standard process defn. structure    */ %ifntv
/*                pX_Fun       - standard function defn. structure   */ %ifntv
/*                pX_Fld       - standard field defn. structure      */ %ifntv
/*                pX_DBM       - standard DBM defn. structure        */ %ifntv
/*                pG           - standard global info. structure     */ %ifntv
/*                                                                   */ %ifntv
/* ================================================================= */ %ifntv
                                                                      %ifntv
O_VOID_FUNCTION X_OAM_Native_Fetch_RRN(X_OAM_STANDARD_ARGS)           %ifntv
{                                                                     %ifntv
   /* Open Update file if not already open */                         %ifntv
   if ( pG->pX_Native_Update->pFile == pX_NULL )                      %ifntv
   {                                                                  %ifntv
      X_DBM_OP_NATIVE_CONTROL(pG->lFetchCode, X_DBM_NATIVE_OPEN_2, pG->pX_Native_Update) %ifntv
      if ((pG->lFetchCode < X_DBMS_INFO_OKAY)                         %ifntv
       || (pX_Ids->chFatalError == YES))                              %ifntv
      {                                                               %ifntv
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);             %ifntv
         return;                                                      %ifntv
      }                                                               %ifntv
   }                                                                  %ifntv
   /* Read by relative record number */                               %ifntv
   pG->pX_Native_Update->lRRN         = pG->dLastRRNO[pG->sFileNo];   %ifntv
   X_DBM_OP_NATIVE_CONTROL(pG->lFetchCode, X_DBM_NATIVE_READ_2, pG->pX_Native_Update) %ifntv
   return;                                                            %ifntv
}                                                                     %ifntv
#endif                                                                %ifntv
                                                                      %ifntv
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
/* ================================================================= */ %ifntv
/*                                                                   */ %ifntv
/* Function     : X_OAM_Native_Fetch_First                           */ %ifntv
/* Description  : Fetch the first record via native I/O              */ %ifntv
/*                                                                   */ %ifntv
/* Arguments    : pX_Ids       - standard system def. structure      */ %ifntv
/*                pX_Pro       - standard process defn. structure    */ %ifntv
/*                pX_Fun       - standard function defn. structure   */ %ifntv
/*                pX_Fld       - standard field defn. structure      */ %ifntv
/*                pX_DBM       - standard DBM defn. structure        */ %ifntv
/*                pG           - standard global info. structure     */ %ifntv
/*                                                                   */ %ifntv
/* ================================================================= */ %ifntv
                                                                      %ifntv
O_VOID_FUNCTION X_OAM_Native_Fetch_First(X_OAM_STANDARD_ARGS)         %ifntv
{                                                                     %ifntv
                                                                      %ifntv
   X_OAM_Native_Locate( X_OAM_STANDARD_PARMS );                       %ifntv
                                                                      %ifntv
   if ((pG->lFetchCode < X_DBMS_INFO_OKAY)                            %ifntv
    || (pX_Ids->chFatalError == YES)                                  %ifntv
	|| (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND))                 %ifntv
   {                                                                  %ifntv
      return;                                                         %ifntv
   }                                                                  %ifntv
                                                                      %ifntv
   if ( pX_DBM->chBackwards == YES )                                  %ifntv
   {                                                                  %ifntv
      pG->pX_Native_Curr->fReadForward   = FALSE;                     %ifntv
      pG->pX_Native_Curr->fReadByKey     = FALSE;                     %ifntv
   }                                                                  %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      pG->pX_Native_Curr->fReadForward   = TRUE;                      %ifntv
      if ( ( pG->pscKeyFlds[pG->sFileNo] > 0 )                        %ifntv
       && ( pX_DBM->scKeyFlds > 0 )  )                                %ifntv
      {                                                               %ifntv
         X_SHORT k = pX_DBM->psKeyFlds[pX_DBM->scKeyFlds - 1];        %ifntv
         /* Start key processing or generic */                        %ifntv
         if ( ( pX_DBM->chStartKey == YES )                           %ifntv
             || ( pX_DBM->chGeneric == YES ) )                        %ifntv
         {                                                            %ifntv
            pG->pX_Native_Curr->fReadByKey = FALSE;                   %ifntv
         }                                                            %ifntv
         else                                                         %ifntv
         {                                                            %ifntv
            pG->pX_Native_Curr->fReadByKey = TRUE;                    %ifntv
         }                                                            %ifntv
      }                                                               %ifntv
      else                                                            %ifntv
      {                                                               %ifntv
        pG->pX_Native_Curr->fReadByKey = FALSE;                       %ifntv
      }                                                               %ifntv
   }                                                                  %ifntv
                                                                      %ifntv
   /* Add any WHERE condition if it involves only "real" fields */    %ifntv
   if (pX_DBM->scWhere > 0)                                           %ifntv
   {                                                                  %ifntv
      X_DBM_OP_NATIVE(lDummyRetcode, X_DBM_NATIVE_BUILD_WHERE_2, pG->pX_Native_Curr, pX_DBM->pX_Fld, &pX_DBM->scWhere, pX_DBM->pWhere) %ifntv
   }                                                                  %ifntv
                                                                      %ifntv
   /* Read record  */                                                 %ifntv
   pG->pX_Native_Curr->fFirstRow = TRUE;                              %ifntv
   X_OAM_Native_Fetch_Next( X_OAM_STANDARD_PARMS );                   %ifntv
                                                                      %ifntv
   if ( ( pX_DBM->scWhere > 0 ) && ( pG->lReturnCode == X_DBMS_INFO_ROW_NOT_FOUND ) ) %ifntv
   {                                                                  %ifntv
      pG->lFetchCode = X_DBMS_INFO_ROW_NOT_FOUND;                     %ifntv
   }                                                                  %ifntv
                                                                      %ifntv
   return;                                                            %ifntv
}                                                                     %ifntv
#endif                                                                %ifntv
                                                                      %ifntv
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
/* ================================================================= */ %ifntv
/*                                                                   */ %ifntv
/* Function     : X_OAM_Native_Locate                                */ %ifntv
/* Description  : Locate a record via native I/O                     */ %ifntv
/*                                                                   */ %ifntv
/* Arguments    : pX_Ids       - standard system def. structure      */ %ifntv
/*                pX_Pro       - standard process defn. structure    */ %ifntv
/*                pX_Fun       - standard function defn. structure   */ %ifntv
/*                pX_Fld       - standard field defn. structure      */ %ifntv
/*                pX_DBM       - standard DBM defn. structure        */ %ifntv
/*                pG           - standard global info. structure     */ %ifntv
/*                                                                   */ %ifntv
/* ================================================================= */ %ifntv
                                                                      %ifntv
O_VOID_FUNCTION X_OAM_Native_Locate(X_OAM_STANDARD_ARGS)              %ifntv
{                                                                     %ifntv
                                                                      %ifntv
   if ( pG->pscKeyFlds[pG->sFileNo] > 0 )                             %ifntv
   {                                                                  %ifntv
      if ( pX_DBM->scKeyFlds > 0 )                                    %ifntv
      {                                                               %ifntv
         pG->pX_Native_Curr->fLocateByKey  = TRUE;                    %ifntv
         /* Set up key                   */                           %ifntv
         pG->pX_Native_Curr->sKeyCount = pX_DBM->scKeyFlds;           %ifntv
         X_DBM_OP_NATIVE_MAP(pG->lFetchCode, X_DBM_MAP_OAM_TO_NATIVE_KEY_2, pG->pX_Native_Curr, pX_DBM->pX_Fld, pX_DBM->psKeyFlds) %ifntv
         /* Start key processing or generic */                        %ifntv
         if ( ( pX_DBM->chStartKey == YES )                           %ifntv
             || ( pX_DBM->chGeneric == YES ) )                        %ifntv
         {                                                            %ifntv
            pG->pX_Native_Curr->fLocateStartKey = TRUE;               %ifntv
         }                                                            %ifntv
         else                                                         %ifntv
         {                                                            %ifntv
            pG->pX_Native_Curr->fLocateStartKey = FALSE;              %ifntv
         }                                                            %ifntv
      }                                                               %ifntv
      else                                                            %ifntv
      {                                                               %ifntv
         pG->pX_Native_Curr->fLocateByKey  = FALSE;                   %ifntv
      }                                                               %ifntv
   }                                                                  %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      pG->pX_Native_Curr->fLocateByKey  = FALSE;                      %ifntv
   }                                                                  %ifntv
                                                                      %ifntv
   if ( pX_DBM->chBackwards == YES )                                  %ifntv
   {                                                                  %ifntv
      pG->pX_Native_Curr->fLocateForward = FALSE;                     %ifntv
   }                                                                  %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      pG->pX_Native_Curr->fLocateForward = TRUE;                      %ifntv
   }                                                                  %ifntv
                                                                      %ifntv
   /* Locate record requested  */                                     %ifntv
   X_DBM_OP_NATIVE_CONTROL(pG->lFetchCode, X_DBM_NATIVE_LOCATE_2, pG->pX_Native_Curr) %ifntv
                                                                      %ifntv
   /* Set greater than by key & backwards did not locate anything */  %ifntv
   /* - just start at the end and work back                       */  %ifntv
   if ( ( pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND )               %ifntv
        && ( pX_DBM->chBackwards == YES )                             %ifntv
        && ( pX_DBM->scKeyFlds > 0 ) )                                %ifntv
   {                                                                  %ifntv
      pG->pX_Native_Curr->fLocateByKey  = FALSE;                      %ifntv
      /* Locate record requested  */                                  %ifntv
      X_DBM_OP_NATIVE_CONTROL(pG->lFetchCode, X_DBM_NATIVE_LOCATE_2, pG->pX_Native_Curr) %ifntv
   }                                                                  %ifntv
                                                                      %ifntv
   return;                                                            %ifntv
}                                                                     %ifntv
#endif                                                                %ifntv
                                                                      %ifntv
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
/* ================================================================= */ %ifntv
/*                                                                   */ %ifntv
/* Function     : X_OAM_Native_Fetch_Next                            */ %ifntv
/* Description  : Fetch the next record via native I/O               */ %ifntv
/*                                                                   */ %ifntv
/* Arguments    : pX_Ids       - standard system def. structure      */ %ifntv
/*                pX_Pro       - standard process defn. structure    */ %ifntv
/*                pX_Fun       - standard function defn. structure   */ %ifntv
/*                pX_Fld       - standard field defn. structure      */ %ifntv
/*                pX_DBM       - standard DBM defn. structure        */ %ifntv
/*                pG           - standard global info. structure     */ %ifntv
/*                                                                   */ %ifntv
/* ================================================================= */ %ifntv
                                                                      %ifntv
O_VOID_FUNCTION X_OAM_Native_Fetch_Next( X_OAM_STANDARD_ARGS )        %ifntv
{                                                                     %ifntv
                                                                      %ifntv
   pG->pX_Native_Curr->fLock = FALSE;                                 %ifntv
                                                                      %ifntv
   /* Do forever */                                                   %ifntv
   do                                                                 %ifntv
   {                                                                  %ifntv
      /* Read record  */                                              %ifntv
      X_DBM_OP_NATIVE_CONTROL(pG->lFetchCode, X_DBM_NATIVE_READ_2, pG->pX_Native_Curr) %ifntv
                                                                      %ifntv
      if ( ( pG->lFetchCode < X_DBMS_INFO_OKAY )                      %ifntv
       || ( pX_Ids->chFatalError == YES )                             %ifntv
       || ( pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND ) )           %ifntv
      {                                                               %ifntv
         break;                                                       %ifntv
      }                                                               %ifntv
                                                                      %ifntv
      /* Backwards with a key, getting to records we are interested in */ %ifntv
      if ( ( pG->pX_Native_Curr->fFirstRow == TRUE )                  %ifntv
           && ( pG->pX_Native_Curr->fReadForward  == FALSE )          %ifntv
           && ( pG->pscKeyFlds[pG->sFileNo] > 0 )                     %ifntv
           && ( pX_DBM->scKeyFlds > 0 ) )                             %ifntv
      {                                                               %ifntv
         X_SHORT i, j, k, sCompareResult;                             %ifntv
         X_SHORT *psInput_Key_Vecs  = pG->pX_Native_Curr->pX_Rec_Input_Key_Vecs; %ifntv
         X_CHAR  *pchInput_Keys_AOD = Global_Info.pX_Rec_InputKeysAOD[pG->sFileNo]; %ifntv
         X_BOOL  *pfLglFlds = pG->pX_Native_Curr->pfX_Rec_LglFlds;    %ifntv
         X_PSHORT psSpecials = pG->pX_Native_Curr->pX_Rec_Specials;   %ifntv
         struct X_FLD *pX_FldRec = pG->pX_Native_Curr->pX_Fld_Rec;    %ifntv
         struct X_FLD *pX_FldKey = pG->pX_Native_Curr->pX_Fld_Key;    %ifntv
         struct X_FLD  X_Fld_Oper1, X_Fld_Oper2;                      %ifntv
         X_FLDDATA        X_FldData_Oper1, X_FldData_Oper2;           %ifntv
         struct X_FLD  *pX_Fld1, *pX_Fld2;                            %ifntv
         X_PCHAR  pchNullIndsRec = pG->pX_Native_Curr->pchX_Rec_NullMap; %ifntv
         X_PCHAR  pchNullIndsKey = pG->pX_Native_Curr->pchX_Key_NullMap; %ifntv
                                                                      %ifntv
         for ( i = 0; i < pX_DBM->scKeyFlds; i++ )                    %ifntv
         {                                                            %ifntv
            j = psInput_Key_Vecs[i];                                  %ifntv
            if ( pfLglFlds != pX_NULL )                               %ifntv
            {                                                         %ifntv
               X_DBM_IS_GET_LGLFLD_VEC(j,k)                           %ifntv
            }                                                         %ifntv
            else                                                      %ifntv
            {                                                         %ifntv
               k = j;                                                 %ifntv
            }                                                         %ifntv
            pX_Fld1 =  &X_Fld_Oper1;                                  %ifntv
            X_DBM_IS_CREATE_XFLD_FROM_NATIVE_XFLD(pX_Fld1,X_FldData_Oper1,pX_FldRec,k) %ifntv
            X_Vec_Set_from_NativeBuffer( pX_Ids,                      %ifntv
                                         pX_Pro,                      %ifntv
                                         pX_Fun,                      %ifntv
                                         pX_Fld1,                     %ifntv
                                         0,                           %ifntv
                                         pX_FldRec,                   %ifntv
                                         k,                           %ifntv
                                         psSpecials != pX_NULL ? psSpecials + j : pX_NULL, %ifntv
                                         pchNullIndsRec != pX_NULL ? pchNullIndsRec + k : pX_NULL ); %ifntv
            pX_Fld2 =  &X_Fld_Oper2;                                  %ifntv
            X_DBM_IS_CREATE_XFLD_FROM_NATIVE_XFLD(pX_Fld2,X_FldData_Oper2,pX_FldKey,i) %ifntv
            X_Vec_Set_from_NativeBuffer( pX_Ids,                      %ifntv
                                         pX_Pro,                      %ifntv
                                         pX_Fun,                      %ifntv
                                         pX_Fld2,                     %ifntv
                                         0,                           %ifntv
                                         pX_FldKey,                   %ifntv
                                         i,                           %ifntv
                                         psSpecials != pX_NULL ? psSpecials + j : pX_NULL, %ifntv
                                         pchNullIndsKey != pX_NULL ? pchNullIndsKey + i : pX_NULL ); %ifntv
            sCompareResult = X_Vec_Compare( pX_Ids,                   %ifntv
                                            pX_Pro,                   %ifntv
                                            pX_Fun,                   %ifntv
                                            pX_Fld1,                  %ifntv
                                            0,                        %ifntv
                                            pX_Fld2,                  %ifntv
                                            0 );                      %ifntv
                                                                      %ifntv
            if ( sCompareResult != 0 )                                %ifntv
            {                                                         %ifntv
               break;                                                 %ifntv
            }                                                         %ifntv
         }                                                            %ifntv
         /* Just read in is "higher" than asked for */                %ifntv
         if ( ( ( sCompareResult > 0 ) && ( pchInput_Keys_AOD[i] == 'A' ) ) %ifntv
              || ( ( sCompareResult < 0 ) && ( pchInput_Keys_AOD[i] != 'A' ) ) )  %ifntv
         {                                                            %ifntv
            continue;                                                 %ifntv
         }                                                            %ifntv
         if ( ( pX_DBM->chStartKey != YES )                           %ifntv
             && ( pX_DBM->chGeneric != YES ) )                        %ifntv
         {                                                            %ifntv
            /* Just read in is "same" as asked for */                 %ifntv
            if ( sCompareResult == 0 )                                %ifntv
            {                                                         %ifntv
               pG->pX_Native_Curr->fReadByKey = TRUE;                 %ifntv
            }                                                         %ifntv
            /* Just read in is "lower" than asked for */              %ifntv
            if ( ( ( sCompareResult < 0 ) && ( pchInput_Keys_AOD[i] == 'A' ) ) %ifntv
                 || ( ( sCompareResult > 0 ) && ( pchInput_Keys_AOD[i] != 'A' ) ) )  %ifntv
            {                                                         %ifntv
               pG->lFetchCode = X_DBMS_INFO_ROW_NOT_FOUND;            %ifntv
               break;                                                 %ifntv
            }                                                         %ifntv
         }                                                            %ifntv
                                                                      %ifntv
      }                                                               %ifntv
                                                                      %ifntv
                                                                      %ifntv
      /* Generic key processing */                                    %ifntv
      if ( ( pG->pscKeyFlds[pG->sFileNo] > 0 )                        %ifntv
          &&( pX_DBM->scKeyFlds > 0 )                                 %ifntv
          && ( pX_DBM->chGeneric == YES )                             %ifntv
          && ( pG->pX_Native_Curr->fReadByKey == FALSE ) )            %ifntv
      {                                                               %ifntv
         X_SHORT i, j, k, sCompareResult;                             %ifntv
         X_SHORT *psInput_Key_Vecs  = pG->pX_Native_Curr->pX_Rec_Input_Key_Vecs; %ifntv
         X_CHAR  *pchInput_Keys_AOD = Global_Info.pX_Rec_InputKeysAOD[pG->sFileNo]; %ifntv
         X_BOOL  *pfLglFlds = pG->pX_Native_Curr->pfX_Rec_LglFlds;    %ifntv
         X_PSHORT psSpecials = pG->pX_Native_Curr->pX_Rec_Specials;   %ifntv
         struct X_FLD *pX_FldRec = pG->pX_Native_Curr->pX_Fld_Rec;    %ifntv
         struct X_FLD *pX_FldKey = pG->pX_Native_Curr->pX_Fld_Key;    %ifntv
         struct X_FLD            X_Fld_Oper1, X_Fld_Oper2;            %ifntv
         X_FLDDATA               X_FldData_Oper1, X_FldData_Oper2;    %ifntv
         struct X_FLD            *pX_Fld1, *pX_Fld2;                  %ifntv
         X_PCHAR  pchNullIndsRec = pG->pX_Native_Curr->pchX_Rec_NullMap; %ifntv
         X_PCHAR  pchNullIndsKey = pG->pX_Native_Curr->pchX_Key_NullMap; %ifntv
                                                                      %ifntv
         for ( i = 0; i < pX_DBM->scKeyFlds; i++ )                    %ifntv
         {                                                            %ifntv
            j = psInput_Key_Vecs[i];                                  %ifntv
            if ( pfLglFlds != pX_NULL )                               %ifntv
            {                                                         %ifntv
               X_DBM_IS_GET_LGLFLD_VEC(j,k)                           %ifntv
            }                                                         %ifntv
            else                                                      %ifntv
            {                                                         %ifntv
               k = j;                                                 %ifntv
            }                                                         %ifntv
            pX_Fld1 = &X_Fld_Oper1;                                    %ifntv
            X_DBM_IS_CREATE_XFLD_FROM_NATIVE_XFLD(pX_Fld1,X_FldData_Oper1,pX_FldRec,k) %ifntv
            X_Vec_Set_from_NativeBuffer( pX_Ids,                      %ifntv
                                         pX_Pro,                      %ifntv
                                         pX_Fun,                      %ifntv
                                         pX_Fld1,                     %ifntv
                                         0,                           %ifntv
                                         pX_FldRec,                   %ifntv
                                         k,                           %ifntv
                                         psSpecials != pX_NULL ? psSpecials + j : pX_NULL, %ifntv
                                         pchNullIndsRec != pX_NULL ? pchNullIndsRec + k : pX_NULL ); %ifntv
            pX_Fld2 = &X_Fld_Oper2;                                    %ifntv
            X_DBM_IS_CREATE_XFLD_FROM_NATIVE_XFLD(pX_Fld2,X_FldData_Oper2,pX_FldKey,i) %ifntv
            X_Vec_Set_from_NativeBuffer( pX_Ids,                      %ifntv
                                         pX_Pro,                      %ifntv
                                         pX_Fun,                      %ifntv
                                         pX_Fld2,                     %ifntv
                                         0,                           %ifntv
                                         pX_FldKey,                   %ifntv
                                         i,                           %ifntv
                                         psSpecials != pX_NULL ? psSpecials + j : pX_NULL, %ifntv
                                         pchNullIndsKey != pX_NULL ? pchNullIndsKey + i : pX_NULL ); %ifntv
            if ( i < ( pX_DBM->scKeyFlds - 1 ) )                      %ifntv
            {                                                         %ifntv
               sCompareResult = X_Vec_Compare( pX_Ids,                %ifntv
                                               pX_Pro,                %ifntv
                                               pX_Fun,                %ifntv
                                               pX_Fld1,               %ifntv
                                               0,                     %ifntv
                                               pX_Fld2,               %ifntv
                                               0 );                   %ifntv
                                                                      %ifntv
                                                                      %ifntv
            }                                                         %ifntv
            else                                                      %ifntv
            {                                                         %ifntv
               sCompareResult = X_OAM_Compare_Generic( pX_Ids,        %ifntv
                                                       pX_Pro,        %ifntv
                                                       pX_Fun,        %ifntv
                                                       pX_Fld1,       %ifntv
                                                       0,             %ifntv
                                                       pX_Fld2,       %ifntv
                                                       0 );           %ifntv
                                                                      %ifntv
            }                                                         %ifntv
            if ( sCompareResult != 0 )                                %ifntv
            {                                                         %ifntv
               break;                                                 %ifntv
            }                                                         %ifntv
         }                                                            %ifntv
         if ( sCompareResult != 0 )                                   %ifntv
         {                                                            %ifntv
            pG->lFetchCode = X_DBMS_INFO_ROW_NOT_FOUND;               %ifntv
            break;                                                    %ifntv
         }                                                            %ifntv
                                                                      %ifntv
      }                                                               %ifntv
                                                                      %ifntv
      if (pX_DBM->scWhere > 0)                                        %ifntv
      {                                                               %ifntv
         /* Evaluate the where condition */                           %ifntv
         X_DBM_OP_NATIVE_CONTROL(pG->lReturnCode, X_DBM_NATIVE_EVALUATE_WHERE_2, pG->pX_Native_Curr) %ifntv
         if ( pG->lReturnCode == X_DBMS_INFO_ROW_NOT_FOUND )          %ifntv
         {                                                            %ifntv
            pG->pX_Native_Curr->fFirstRow = FALSE;                    %ifntv
            continue;                                                 %ifntv
         }                                                            %ifntv
      }                                                               %ifntv
                                                                      %ifntv
      /* Return a record if we got to here */                         %ifntv
      pG->pX_Native_Curr->fFirstRow = FALSE;                          %ifntv
      pG->lReturnCode = X_DBMS_INFO_OKAY;                             %ifntv
      break;                                                          %ifntv
                                                                      %ifntv
   } while ( 1 == 1 );                                                %ifntv
                                                                      %ifntv
   return;                                                            %ifntv
}                                                                     %ifntv
#endif                                                                %ifntv
                                                                      %ifntv
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
/* ================================================================= */ %ifntv
/*                                                                   */ %ifntv
/* Function     : X_OAM_Compare_Generic                              */ %ifntv
/* Description  : Compare 2 vectors generically whether alpha or     */ %ifntv
/*                numeric                                            */ %ifntv
/* Arguments    : pX_Ids       - standard system def. structure      */ %ifntv
/*                pX_Pro       - standard process defn. structure    */ %ifntv
/*                pX_Fun       - standard function defn. structure   */ %ifntv
/*                X_Fld_Read   - standard X_FLD vector for read      */ %ifntv
/*                sVector_Read - vector number of read               */ %ifntv
/*                                                                   */ %ifntv
/*                X_Fld_Key    - standard X_FLD vector for generic   */ %ifntv
/*                               key                                 */ %ifntv
/*                sVector_Key  - vector number of generic key        */ %ifntv
/*                                                                   */ %ifntv
/* Returns      : X_SHORT sValue   0 means A and B are equal         */ %ifntv
/*                                +1 means A is greater than B       */ %ifntv
/*                                -1 means A is less than B          */ %ifntv
/*                                                                   */ %ifntv
/*===================================================================*/ %ifntv
X_SHORT_FUNCTION X_OAM_Compare_Generic(struct X_IDS *pX_Ids,          %ifntv
                                       struct X_PRO *pX_Pro,          %ifntv
                                       struct X_FUN *pX_Fun,          %ifntv
                                       struct X_FLD *pX_Fld_Rec,      %ifntv
                                       X_SHORT sVector_Rec,           %ifntv
                                       struct X_FLD *pX_Fld_Key,      %ifntv
                                       X_SHORT sVector_Key )          %ifntv
{                                                                     %ifntv
   X_SHORT        sCompareResult, sRetLength;                         %ifntv
                                                                      %ifntv
   if ( !X_VECTOR_STORED_AS_NUMERIC(pX_Fld_Key,sVector_Key) )         %ifntv
   {                                                                  %ifntv
      sCompareResult = X_Vec_Compare_Generic( pX_Ids,                 %ifntv
                                              pX_Pro,                 %ifntv
                                              pX_Fun,                 %ifntv
                                              pX_Fld_Rec,             %ifntv
                                              sVector_Rec,            %ifntv
                                              pX_Fld_Key,             %ifntv
                                              sVector_Key );          %ifntv
   }                                                                  %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      X_SHORT  sRetLength, i, sGenLength;                             %ifntv
	  X_CHAR   vchGen[X_MAX_ALPHA_FIELD_LEN];                         %ifntv
	  X_CHAR   vchRec[X_MAX_ALPHA_FIELD_LEN];                         %ifntv
                                                                      %ifntv
      X_Vec_Get_as_String( pX_Ids,                                    %ifntv
                           pX_Pro,                                    %ifntv
                           pX_Fun,                                    %ifntv
                           pX_Fld_Key,                                %ifntv
                           sVector_Key,                               %ifntv
                           BLANK,                                     %ifntv
                           pX_NULL,                                   %ifntv
                           &sRetLength,                               %ifntv
                           vchGen );                                  %ifntv
      /* get generic length */                                        %ifntv
      for ( i = strlen( vchGen ) - 1; i >= 0; i-- )                   %ifntv
      {                                                               %ifntv
         if ( vchGen[i] != '0' )                                      %ifntv
            break;                                                    %ifntv
      }                                                               %ifntv
      sGenLength = i + 1;                                             %ifntv
                                                                      %ifntv
      X_Vec_Get_as_String( pX_Ids,                                    %ifntv
                           pX_Pro,                                    %ifntv
                           pX_Fun,                                    %ifntv
                           pX_Fld_Rec,                                %ifntv
                           sVector_Rec,                               %ifntv
                           BLANK,                                     %ifntv
                           pX_NULL,                                   %ifntv
                           &sRetLength,                               %ifntv
                           vchRec );                                  %ifntv
      sCompareResult = memcmp( vchGen, vchRec, sGenLength );          %ifntv
   }                                                                  %ifntv
                                                                      %ifntv
   return sCompareResult;                                             %ifntv
}                                                                     %ifntv
#endif                                                                %ifntv


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Cursor_Close_Request                         */
/* Description  : CURSOR_CLOSE request; also marks SQLDA available   */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Cursor_Close_Request(X_OAM_STANDARD_ARGS)
{
   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* ---------------------------------------------------- */
      /* Close the cursor associated with the prepared SELECT */
      /* ---------------------------------------------------- */

      X_DBM_OP( pG->lReturnCode, X_DBM_CLOSE_CURSOR, pX_NULL, pX_DBM->sCursorID, pX_NULL )

   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use iSeries Native IO        */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Destroy the where structures etc. */                         %ifntv
      X_DBM_OP_NATIVE_CONTROL(pG->lReturnCode, X_DBM_CLOSE_CURSOR, pG->pX_Native_Curr) %ifntv
                                                                      %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   {                                                               %iflob
      X_LONG lReturnCode;                                          %iflob
      struct X_DBM_FLDINDEX *pCurr = pG->pCurrFldIndex;            %iflob
                                                                   %iflob
      X_Search_FldIndex (X_OAM_STANDARD_PARMS);                    %iflob
      pCurr = pG->pCurrFldIndex;                                   %iflob
      %lobcursorclose
   }                                                               %iflob


   if (pG->lReturnCode != X_DBMS_INFO_OKAY)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lReturnCode;
      return;
   }

   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Fetch_Request                                */
/* Description  : FETCH a row request                                */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Fetch_Request(X_OAM_STANDARD_ARGS)
{

   X_SHORT sStringLength;
   X_SHORT i;
   X_SHORT j;
   struct X_DBM_FLDINDEX *pCurr;
   X_SQLDA *pSqlda;
   X_SHORT  sSqlda;
   X_PVCHAR pvchRRNO = X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_RRN );

   if ( fHasRRNO )
   {
      /* Set the @@RRNO and @@UPID .....                               */

      pG->dLastRRNO[pG->sFileNo] = 0.0;

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID ) pG->dLastUPID[pG->sFileNo] = 0.0;
#endif
   }

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( !fHasUPID )
   {
      pG->fLastSaved[pG->sFileNo] = FALSE;
   }
#endif

   /* ------------------------------------------ */
   /* Check if authorised to read the file first */
   /* ------------------------------------------ */

   if (pG->chReadAuthChecked != YES)
   {
      pG->chAuthorised = X_Check_Authority(pX_Ids,
                                           pX_Pro,
                                           pX_Fun,
                                           "%tablexxxx",
                                           "%fulllibxx",
                                           X_OBJECT_TYPE_FILE,
                                           X_OBJECT_AUTH_READ_DATA);
      if (pG->chAuthorised == NO)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0009",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }
      else
         pG->chReadAuthChecked = YES;
   }

   /* ------------------------------- */
   /* Set current field index pointer */
   /* ------------------------------- */

   X_Search_FldIndex (X_OAM_STANDARD_PARMS);
   pCurr = pG->pCurrFldIndex;

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* -------------------------------- */
      /* Build SELECT of all table fields */
      /* -------------------------------- */

      strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
      X_OAM_Add_Table_Name(X_OAM_STANDARD_PARMS);

      /* If WITH_RRN specified use this vector as the fetch key */

      if ( pX_DBM->chWithRRNO == YES)
      {
         if ( !fHasRRNO )
         {
            X_Fatal_Error(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          "OAM for table %tablexxxx",
                          X_TEXT(842));
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            return;
         }
         else
         {
            X_PVCHAR pvchString;

            X_Vec_Get_as_VarChar(pX_Ids,
                                 pX_Pro,
                                 pX_Fun,
                                 pX_DBM->pX_Fld,
                                 pX_DBM->sWithRRNO,
                                 X_DBM_DECIMAL_EDIT_CODE,
                                 pX_NULL,
                                 &VarCharTemp,
                                 pX_NULL);

            X_VAR_VarChar_GetAsVchar(pX_Ids, pX_Pro, pX_Fun, &VarCharTemp, &pvchString );
            sprintf(pG->vchSqlStmnt + strlen(pG->vchSqlStmnt), " WHERE %s = %s", pvchRRNO, pvchString);

            if (  (X_VECTOR_STORED_AS_NUMERIC(pX_DBM->pX_Fld, pX_DBM->sWithRRNO))
             &&   (pX_DBM->pX_Fld[pX_DBM->sWithRRNO].sDec == 0) )
            {
               if ( X_VECTOR_STORED_AS_FLOAT(pX_DBM->pX_Fld, pX_DBM->sWithRRNO) == FALSE ) %ifRDMLX_File
               {
                  strcat(pG->vchSqlStmnt, ".0");
               }
            }
         }
      }

      /* Build WHERE according to keys passed in key field vectors */

      if (pX_DBM->scKeyFlds > 0)
         strcat(pG->vchSqlStmnt," WHERE ");

      for (i = 0; i < pX_DBM->scKeyFlds; i++)
      {

         if (i > 0) strcat(pG->vchSqlStmnt," AND ");

         %where

         strcat(pG->vchSqlStmnt," = ");

         j = pX_DBM->psKeyFlds[i];

         if ( !X_OAM_Add_Value_To_Stmnt(X_OAM_STANDARD_PARMS, j, i) )
         {
            return;
         }
      }

      /* Add any WHERE condition if it involves only "real" fields */

      if (pX_DBM->scWhere > 0)
      {
         if (i > 0)
            strcat(pG->vchSqlStmnt," AND ");
         else
            strcat(pG->vchSqlStmnt," WHERE ");
         X_OAM_Build_Where(X_OAM_STANDARD_PARMS);
         if (pX_Ids->chFatalError == YES)
         {
            strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
            return;
         }
      }

      /* Build ORDER BY according to table/index keys */

      %orderby

      /* ------------------------------------- */
      /* Prepare the required SELECT statement */
      /* ------------------------------------- */

      pX_Ids->chOAMRqsType = X_VARIANT_SELECT;
      pX_Ids->fX_DBM_PrepareParams = FALSE; /* Because RRN not in SQL */

      X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }

      /* --------------------- */
      /* Get appropriate SQLDA */
      /* --------------------- */
      sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
      if ( sSqlda < 0 ) return;

      /* --------------------------------------------------- */
      /* Open the cursor associated with the prepared SELECT */
      /* --------------------------------------------------- */

      X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, pX_DBM->sCursorID, pSqlda )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }
   }

   /* Run before read trigger */                                      %rdtrig
   strcpy(pG->X_Trigger.vchOper,"BEFRED");                            %rdtrig
   X_OAM_Read_Triggers(X_OAM_STANDARD_PARMS);                         %rdtrig
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_OKAY) != 0)                 %rdtrig
   {                                                                  %rdtrig
      return;                                                         %rdtrig
   }                                                                  %rdtrig

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* ------------------------------- */
      /* Attempt to fetch a matching row */
      /* ------------------------------- */

      X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* read by relative record number */                            %ifntv
                                                                      %ifntv
      if (pX_DBM->chWithRRNO == YES)                                  %ifntv
      {                                                               %ifntv
         X_Vec_Get_as_Double(pX_Ids,                                  %ifntv
                             pX_Pro,                                  %ifntv
                             pX_Fun,                                  %ifntv
                             pX_DBM->pX_Fld,                          %ifntv
                             pX_DBM->sWithRRNO,                       %ifntv
                             &(pG->dLastRRNO[pG->sFileNo]));          %ifntv
         /* Read by relative record number */                         %ifntv
         pG->pX_Native_Update->fLock        = FALSE;                  %ifntv
         X_OAM_Native_Fetch_RRN( X_OAM_STANDARD_PARMS );              %ifntv
                                                                      %ifntv
         pG->dLastRRNO[pG->sFileNo] = 0.0;                            %ifntv
      }                                                               %ifntv
      else                                                            %ifntv
      {                                                               %ifntv
         /* Fetch with_key and / or where */                          %ifntv
         X_OAM_Native_Fetch_First( X_OAM_STANDARD_PARMS );            %ifntv
      }                                                               %ifntv
                                                                      %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
    || (pX_Ids->chFatalError == YES))
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lFetchCode;
      return;
   }

   /* ------------------------------- */
   /* Set the appropriate return code */
   /* ------------------------------- */

   if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
      if (pX_DBM->chMsgReqd == YES)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0005",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
      }

      /* ---------------------------------------------------- */
      /* Close the cursor associated with the prepared SELECT */
      /* ---------------------------------------------------- */

      if (pX_DBM->chWhereRDML == NO)
      {
         X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS);
      }

      return;
   }


   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* ---------------------------------------------- */
      /* Map fields from the Sqlda structure after read */
      /* ---------------------------------------------- */

      X_DBM_OP( lDummyRetcode, X_DBM_MAP_FROM_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                                %ifntv
   else                                                                %ifntv
   {                                                                   %ifntv
                                                                       %ifntv
      /* ---------------------------- */                               %ifntv
      /* Use Native I/O               */                               %ifntv
      /* ---------------------------- */                               %ifntv
      /* Map from record buffer to OAM */                              %ifntv
      if (pX_DBM->chWithRRNO == YES)                                  %ifntv
      {                                                               %ifntv
         X_DBM_OP_NATIVE_MAP(pG->lFetchCode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Update, pG->pX_Fld, &sX_Zero) %ifntv
      }                                                               %ifntv
      else                                                            %ifntv
      {                                                               %ifntv
         X_DBM_OP_NATIVE_MAP(pG->lFetchCode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Curr, pG->pX_Fld, &sX_Zero) %ifntv
      }                                                               %ifntv
   }                                                                   %ifntv
#endif                                                                 %ifntv

   {                                                                   %iflob
      X_SHORT rc = 0;                                                  %iflob
      X_VCHAR vchLOBDir[X_MAX_SIZE_LOB_FILE_NAME + 1] = "";            %iflob
      X_TYPE_FLAG chAttrib;                                            %iflob
      PX_LIST_VOID pX_List = pX_NULL;                                  %iflob
      const X_BOOL fCurrent = TRUE;                                    %iflob
      X_SHORT sMsgId;                                                  %iflob
                                                                       %iflob
      %lobfetchinit
      %lobfetchfetch
      %lobfetchmap
                                                                       %iflob
      switch ( rc )                                                    %iflob
      {                                                                %iflob
         case -1:                                                      %iflob
            sMsgId = 1038;                                             %iflob
            break;                                                     %iflob
                                                                       %iflob
         case -2:                                                      %iflob
            sMsgId = 1039;                                             %iflob
            break;                                                     %iflob
                                                                       %iflob
         case -3:                                                      %iflob
            sMsgId = 1040;                                             %iflob
            break;                                                     %iflob
      }                                                                %iflob
                                                                       %iflob
      if ( rc < 0 )                                                    %iflob
      {                                                                %iflob
         X_Issue_Message_VChar( pX_Ids,                                %iflob
                                pX_Pro,                                %iflob
                                pX_Fun,                                %iflob
                                pX_Ids->vchStandardMessageFile,        %iflob
                                "DCM9899",                             %iflob
                                X_TEXT_NOID(sMsgId));                  %iflob
      }                                                                %iflob
                                                                       %iflob
      if ( pX_Ids->chFatalError == YES || rc < 0 )                     %iflob
      {                                                                %iflob
         if (pX_DBM->chWhereRDML == NO)                                %iflob
         {                                                             %iflob
            X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS);          %iflob
         }                                                             %iflob
         return;                                                       %iflob
      }                                                                %iflob
                                                                       %iflob
      /* Close cursor as we need to handle each record independently */%iflob
      %lobfetchclose
   }                                                                   %iflob

   /* Execute virtual code */                                        %ifvcpjf
                                                                     %ifvcpjf
   X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_PARMS);              %ifvcpjf
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)         %ifvcpjf
   {                                                                 %ifvcpjf
      return;                                                        %ifvcpjf
   }                                                                 %ifvcpjf

   /* Save the @@RRNO and @@UPID */

   if ( fHasRRNO )
   {
      X_Vec_Get_as_Double(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Fld,
                          X_V_%@RRNOxxxx,
                          &(pG->dLastRRNO[pG->sFileNo]));

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID )
      {
         X_Vec_Get_as_Double(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@UPID,
                             &(pG->dLastUPID[pG->sFileNo]));
      }
#endif

      /* Return @@RRNO if requested */

      if ( pX_DBM->chRetRRNO == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      X_V_%@RRNOxxxx,
                      pX_DBM->pX_Fld,
                      pX_DBM->sRetRRNO);
   }

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( (!fHasUPID) && (X_OAM_Save_Current_Record(X_OAM_STANDARD_PARMS) != TRUE) )
   {
      return;
   }
#endif

   /* Run after read trigger */                                       %rdtrig
   strcpy(pG->X_Trigger.vchOper,"AFTRED");                            %rdtrig
   X_OAM_Read_Triggers(X_OAM_STANDARD_PARMS);                         %rdtrig
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_OKAY) != 0)                 %rdtrig
   {                                                                  %rdtrig
      return;                                                         %rdtrig
   }                                                                  %rdtrig

   /* ---------------------------------------------------- */
   /* Map the OAM field vectors to the group field vectors */
   /* ---------------------------------------------------- */

   for (i = 0; i < X_TOTAL_FIELDS; i++)
   {
      if (pCurr->X_DBM_FldsUsed[i] == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      i,
                      pX_DBM->pX_Fld,
                      pCurr->X_DBM_FldsIndex[i]);
   }

   /* Reverse data if SREV used */                                    %ifsrev
   if (X_LANGUAGE_IS_RLTB)                                            %ifsrev
   {                                                                  %ifsrev
      for (i = 0; i < pX_DBM->scGrpFlds; i++)                         %ifsrev
      {                                                               %ifsrev
         %srevdout
               X_Reverse_String(pX_Ids,pX_Pro,pX_Fun,                 %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].pField,   %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].sByteLen);%ifsrev
      }                                                               %ifsrev
   }                                                                  %ifsrev

   /* ------------------------------------------------------------ */
   /* Close the cursor unless a WHERE condition tested in the RDML */
   /* function is being used .....                                 */
   /* ------------------------------------------------------------ */

   if (pX_DBM->chWhereRDML == NO)
   {

      X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS);

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }
   }

   strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);
   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Fetch_Next_Request                           */
/* Description  : FETCH_NEXT row request                             */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Fetch_Next_Request(X_OAM_STANDARD_ARGS)
{
   X_SHORT  i;
   struct X_DBM_FLDINDEX *pCurr;
   X_SQLDA *pSqlda;
   X_SHORT  sSqlda;

   /* ------------------------------- */
   /* Set current field index pointer */
   /* ------------------------------- */

   X_Search_FldIndex (X_OAM_STANDARD_PARMS);
   pCurr = pG->pCurrFldIndex;

   /* Run before read trigger ..... */                                %rdtrig
   strcpy(pG->X_Trigger.vchOper,"BEFRED");                            %rdtrig
   X_OAM_Read_Triggers(X_OAM_STANDARD_PARMS);                         %rdtrig
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_OKAY) != 0)                 %rdtrig
      return;                                                         %rdtrig

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */

      /* --------------------- */
      /* Get appropriate SQLDA */
      /* --------------------- */
      sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
      if ( sSqlda < 0 ) return;

      /* -------------------------------------- */
      /* Attempt to fetch the next matching row */
      /* -------------------------------------- */

      X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Read next record   */                                        %ifntv
      X_OAM_Native_Fetch_Next( X_OAM_STANDARD_PARMS );                %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
    || (pX_Ids->chFatalError == YES))
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lFetchCode;
      return;
   }

   /* ------------------------------- */
   /* Set the appropriate return code */
   /* ------------------------------- */

   if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
      return;
   }

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* ---------------------------------------------- */
      /* Map fields from the Sqlda structure after read */
      /* ---------------------------------------------- */

      X_DBM_OP( lDummyRetcode, X_DBM_MAP_FROM_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Map from record buffer to OAM */                             %ifntv
      X_DBM_OP_NATIVE_MAP(lDummyRetcode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Curr, pG->pX_Fld, &sX_Zero) %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   {                                                                   %iflob
      X_SHORT rc = 0;                                                  %iflob
      X_VCHAR vchLOBDir[X_MAX_SIZE_LOB_FILE_NAME + 1] = "";            %iflob
      X_TYPE_FLAG chAttrib;                                            %iflob
      PX_LIST_VOID pX_List = pX_NULL;                                  %iflob
      const X_BOOL fCurrent = TRUE;                                    %iflob
      X_SHORT sMsgId;                                                  %iflob
                                                                       %iflob
      %lobfetchinit
      %lobfetchfetch
      %lobfetchmap
                                                                       %iflob
      switch ( rc )                                                    %iflob
      {                                                                %iflob
         case -1:                                                      %iflob
            sMsgId = 1038;                                             %iflob
            break;                                                     %iflob
                                                                       %iflob
         case -2:                                                      %iflob
            sMsgId = 1039;                                             %iflob
            break;                                                     %iflob
                                                                       %iflob
         case -3:                                                      %iflob
            sMsgId = 1040;                                             %iflob
            break;                                                     %iflob
      }                                                                %iflob
                                                                       %iflob
      if ( rc < 0 )                                                    %iflob
      {                                                                %iflob
         X_Issue_Message_VChar( pX_Ids,                                %iflob
                                pX_Pro,                                %iflob
                                pX_Fun,                                %iflob
                                pX_Ids->vchStandardMessageFile,        %iflob
                                "DCM9899",                             %iflob
                                X_TEXT_NOID(sMsgId));                  %iflob
      }                                                                %iflob
                                                                       %iflob
      if ( pX_Ids->chFatalError == YES || rc < 0 )                     %iflob
      {                                                                %iflob
         if (pX_DBM->chWhereRDML == NO)                                %iflob
         {                                                             %iflob
            X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS);          %iflob
         }                                                             %iflob
         return;                                                       %iflob
      }                                                                %iflob
      /* Close cursor as we need to handle each record independently */%iflob
      %lobfetchclose
   }                                                                   %iflob

   /* Execute virtual code */                                        %ifvcpjf
                                                                     %ifvcpjf
   X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_PARMS);              %ifvcpjf
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)         %ifvcpjf
      return;                                                        %ifvcpjf

   /* Save the @@RRNO and @@UPID */

   if ( fHasRRNO )
   {
      X_Vec_Get_as_Double(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Fld,
                          X_V_%@RRNOxxxx,
                          &(pG->dLastRRNO[pG->sFileNo]));

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID )
      {
         X_Vec_Get_as_Double(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@UPID,
                             &(pG->dLastUPID[pG->sFileNo]));
      }
#endif

      /* Return @@RRNO if requested */

      if ( pX_DBM->chRetRRNO == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      X_V_%@RRNOxxxx,
                      pX_DBM->pX_Fld,
                      pX_DBM->sRetRRNO);
   }

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( (!fHasUPID) && (X_OAM_Save_Current_Record(X_OAM_STANDARD_PARMS) != TRUE) )
   {
      return;
   }
#endif

   /* Run after read trigger */                                       %rdtrig
   strcpy(pG->X_Trigger.vchOper,"AFTRED");                            %rdtrig
   X_OAM_Read_Triggers(X_OAM_STANDARD_PARMS);                         %rdtrig
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_OKAY) != 0)                 %rdtrig
      return;                                                         %rdtrig

   /* ---------------------------------------------------- */
   /* Map the OAM field vectors to the group field vectors */
   /* ---------------------------------------------------- */

   for (i = 0; i < X_TOTAL_FIELDS; i++)
   {
      if (pCurr->X_DBM_FldsUsed[i] == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      i,
                      pX_DBM->pX_Fld,
                      pCurr->X_DBM_FldsIndex[i]);
   }

   /* Reverse data if SREV used */                                    %ifsrev
   if (X_LANGUAGE_IS_RLTB)                                            %ifsrev
   {                                                                  %ifsrev
      for (i = 0; i < pX_DBM->scGrpFlds; i++)                         %ifsrev
      {                                                               %ifsrev
         %srevdout
               X_Reverse_String(pX_Ids,pX_Pro,pX_Fun,                 %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].pField,   %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].sByteLen);%ifsrev
      }                                                               %ifsrev
   }                                                                  %ifsrev

   strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);
   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Filecheck_Request                            */
/* Description  : FILECHECK request                                  */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Filecheck_Request(X_OAM_STANDARD_ARGS)
{
   X_SHORT sStringLength;
   X_SHORT i;
   X_SHORT j;
   X_SQLDA *pSqlda;
   X_SHORT  sSqlda;

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* -------------------------------- */
      /* Build SELECT of all table fields */
      /* -------------------------------- */

      strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
      X_OAM_Add_Table_Name(X_OAM_STANDARD_PARMS);

      /* Build WHERE according to keys passed in key field vectors */

      strcat(pG->vchSqlStmnt," WHERE ");
      for (i = 0; i < pX_DBM->scKeyFlds; i++)
      {
         if (i > 0) strcat(pG->vchSqlStmnt," AND ");

         %where

         strcat(pG->vchSqlStmnt," = ");

         j = pX_DBM->psKeyFlds[i];

         if ( !X_OAM_Add_Value_To_Stmnt(X_OAM_STANDARD_PARMS, j, i) )
         {
            return;
         }
      }

      /* Build ORDER BY according to table/index keys */

      %orderby

      /* ------------------------------------- */
      /* Prepare the required SELECT statement */
      /* ------------------------------------- */

      pX_Ids->chOAMRqsType = X_VARIANT_SELECT;
      pX_Ids->fX_DBM_PrepareParams = FALSE; /* Because RRN not in SQL */

      X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }

      /* --------------------- */
      /* Get appropriate SQLDA */
      /* --------------------- */
      sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
      if ( sSqlda < 0 ) return;

      /* --------------------------------------------------- */
      /* Open the cursor associated with the prepared SELECT */
      /* --------------------------------------------------- */

      X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, pX_DBM->sCursorID, pSqlda )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }

      /* ------------------------------- */
      /* Attempt to fetch a matching row */
      /* ------------------------------- */

      X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Locate a record */                                           %ifntv
      X_OAM_Native_Locate( X_OAM_STANDARD_PARMS );                    %ifntv
                                                                      %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
    || (pX_Ids->chFatalError == YES))
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      return;
   }


   /* ------------------------------- */
   /* Set the appropriate return code */
   /* ------------------------------- */

   if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
      strcpy(pX_DBM->vchReturnCode,X_DBM_NOT_EQUAL_KEY);
   else
      strcpy(pX_DBM->vchReturnCode,X_DBM_EQUAL_KEY);

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* ---------------------------------------------------- */
      /* Close the cursor associated with the prepared SELECT */
      /* ---------------------------------------------------- */

      X_DBM_OP( pG->lReturnCode, X_DBM_CLOSE_CURSOR, pX_NULL, pX_DBM->sCursorID, pX_NULL )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }
   }

   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Insert_Request                               */
/* Description  : INSERT a row request. LOB fields ARE included.     */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Insert_Request(X_OAM_STANDARD_ARGS)
{
#define X_OAM_LOAD_DATA_CLEANUP(_DELETE)

   X_SHORT i;
   struct X_DBM_FLDINDEX *pCurr;
   X_SQLDA *pSqlda;
   X_SHORT  sSqlda;
#if !defined(X_DBM_ISERIES_IDENTITY)
   X_SHORT sFields = X_TOTAL_REAL_FIELDS - (fHasUPID ? 2 : 3);
#else
   X_SHORT sFields = X_TOTAL_REAL_FIELDS - 4; /* Never has @@UPID, and Identity to be removed */
#endif
 
   /* Abort if read-only file */                                       %ifrdonly
   {                                                                   %ifrdonly
      X_PVCHAR avchParms[3];                                           %ifrdonly
                                                                       %ifrdonly
      avchParms[0] = "INSERT";                                         %ifrdonly
      avchParms[1] = ErrTxt1;                                          %ifrdonly
      avchParms[2] = ErrTxt2;                                          %ifrdonly
                                                                       %ifrdonly
      X_Issue_Message_VChar_Ptrs( pX_Ids, pX_Pro, pX_Fun,              %ifrdonly
                                  pX_Ids->vchStandardMessageFile,      %ifrdonly
                                  "IOM0052", 3, avchParms );           %ifrdonly
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);                 %ifrdonly
      return;                                                          %ifrdonly
   }                                                                   %ifrdonly
                                                                       %ifrdonly
   /* ---------------------------------------------------- */
   /* Check if authorised to insert rows in the file first */
   /* ---------------------------------------------------- */

   if (pG->chInsertAuthChecked != YES)
   {
      pG->chAuthorised = X_Check_Authority(pX_Ids,
                                           pX_Pro,
                                           pX_Fun,
                                           "%tablexxxx",
                                           "%fulllibxx",
                                           X_OBJECT_TYPE_FILE,
                                           X_OBJECT_AUTH_ADD_DATA);
      if (pG->chAuthorised == NO)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0011",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }
      else
         pG->chInsertAuthChecked = YES;
   }

   /* ------------------------------- */
   /* Set current field index pointer */
   /* ------------------------------- */

   X_Search_FldIndex (X_OAM_STANDARD_PARMS);
   pCurr = pG->pCurrFldIndex;

   /* ---------------------------------------------------- */
   /* Map the group field vectors to the OAM field vectors */
   /* ---------------------------------------------------- */

   for (i = 0; i < X_TOTAL_FIELDS; i++)
   {
      if (pCurr->X_DBM_FldsUsed[i] == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_DBM->pX_Fld,
                      pCurr->X_DBM_FldsIndex[i],
                      pX_Fld,
                      i);
   }

   /* Reverse data if SREV used ..... */                              %ifsrev
   if (X_LANGUAGE_IS_RLTB)                                            %ifsrev
   {                                                                  %ifsrev
      %srevdin
   }                                                                  %ifsrev

   /* ---------------------------------------------------- */
   /* If all key fields not provided then validation error */
   /* ---------------------------------------------------- */

   pG->chAllKeys = YES;
   %allkeys
   if (pG->chAllKeys == NO)
   {
      X_Issue_Message_Vec(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Ids->vchStandardMessageFile,
                          "IOM0021",
                          pX_Fld,
                          2,
                          X_DBM_FilLibVecs);
      strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
      return;
   }

   /* ----------------------------------------------------- */
   /* Set dictionary default values for non-supplied fields */
   /* ----------------------------------------------------- */

   X_OAM_Set_Defaults(X_OAM_STANDARD_PARMS);

   /* -------------------- */                                       %ifstmp
   /* Set date/time stamps */                                       %ifstmp
   /* -------------------- */                                       %ifstmp
                                                                    %ifstmp
   X_OAM_Stamp_Attributes(X_OAM_STANDARD_PARMS,                     %ifstmp
                          X_DBM_INSERT_OPERATION);                  %ifstmp
                                                                    %ifstmp
   /* -------------------- */                                          %ifvc
   /* Execute virtual code */                                          %ifvc
   /* -------------------- */                                          %ifvc
                                                                       %ifvc
   X_OAM_Virtual_Code_Before_Write(X_OAM_STANDARD_PARMS);              %ifvc
                                                                       %ifvc
   /* ----------------------------- */
   /* Perform any validation checks */
   /* ----------------------------- */

   X_OAM_Validation_Checks(X_OAM_STANDARD_PARMS,
                           X_DBM_INSERT_OPERATION);
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR) == 0)
      return;

   /* Run before insert trigger */                                   %intrig
   strcpy(pG->X_Trigger.vchOper,"BEFINS");                           %intrig
   %RUNFT *BEFINS1

   /* If only validation checks are to be performed then return */

   if (pX_DBM->chValOnly == YES)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);
      return;
   }

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* -------------------------------------- */
      /* Copy the required INSERT SQL statement */
      /* -------------------------------------- */

      strcpy(pG->vchSqlStmnt,X_DBM_InsertFlds);

      /* ------------------------------------- */
      /* Prepare the required INSERT statement */
      /* ------------------------------------- */

      pX_Ids->chOAMRqsType = X_INVARIANT_INSERT;

      AVOID_JOURNALING(pG->vchSqlStmnt)                              %ifncmt

      X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }

      /* --------------------- */
      /* Get appropriate SQLDA */
      /* --------------------- */
      sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_INSERT,TRUE);

      if ( sSqlda < 0 ) 
      {
         X_DBM_OP( pG->lReturnCode, X_DBM_FREE_STATEMENT, pX_NULL, pX_DBM->sCursorID, pX_NULL );
         return;
      }

      if ( fHasRRNO )
      {
#ifdef X_OAM_UPID_REQUIRED
         if ( fHasUPID )
         {
            X_Vec_Set_from_Double(pX_Ids,
                                  pX_Pro,
                                  pX_Fun,
                                  pX_Fld,
                                  X_V_%@UPID,
                                  1.0);
         }
#endif

         if ( !fAutoRRN )
         {
            /* -------------------------------- */
            /* Set the @@RRNO and @@UPID fields */
            /* -------------------------------- */

            X_PDF_Get_RRNO_2(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@RRNOxxxx,
                             %qtablexxxxx,
                             (X_CHAR)(X_DBM_V4_OR_LATER ? pX_DBM->chSystem : NO));

            if (pX_Ids->chFatalError == YES)
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
               X_DBM_OP( pG->lReturnCode, X_DBM_FREE_STATEMENT, pX_NULL, pX_DBM->sCursorID, pX_NULL );
               return;
            }

            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) (X_TOTAL_REAL_FIELDS - 1), 0, pSqlda )
         }
         else
         {
            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) sFields, 0, pSqlda )
         }
      }
      else
      {
#if defined(X_DBM_IDENTITY_COLUMN)
         /* Skip mapping the last field (identity column) */
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) (X_TOTAL_REAL_FIELDS - 1), 0, pSqlda )
#else
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_TOTAL_REAL_FIELDS, 0, pSqlda )
#endif
      }

      /* ------------------------------------------------------ */
      /* Map fields to the Sqlda structure before actual insert */
      /* ------------------------------------------------------ */

#if !defined(X_DBM_ISERIES_IDENTITY)
      if ( fIdentity || fAutoRRN )
      {
         /* Skips mapping the first field */
         X_DBM_OP( lDummyRetcode, X_DBM_MAP_TO_TABLE_NO_RRNO, (X_PVCHAR) pX_Fld, 0, pSqlda )
      }
      else
      {
         X_DBM_OP( lDummyRetcode, X_DBM_MAP_TO_TABLE_2, (X_PVCHAR) pX_Fld, 0, pSqlda )
      }
#else
      {
         /* We need to skip mapping RRNO AND Identity */
         X_DBM_OP( lDummyRetcode, X_DBM_MAP_TO_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_INITIAL + 2, pSqlda )
      }
#endif
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
#ifdef X_OAM_UPID_REQUIRED                                            %ifntv
      if ( fHasUPID )                                                 %ifntv
      {                                                               %ifntv
         /* Set the @@UPID field */                                   %ifntv
         X_Vec_Set_from_Double(pX_Ids,                                %ifntv
                               pX_Pro,                                %ifntv
                               pX_Fun,                                %ifntv
                               pX_Fld,                                %ifntv
                               X_V_%@UPID,                            %ifntv
                               1.0);                                  %ifntv
      }                                                               %ifntv
#endif                                                                %ifntv
      /* Map from OAM to record buffer */                             %ifntv
      X_DBM_OP_NATIVE_MAP(pG->lFetchCode, X_DBM_MAP_OAM_TO_NATIVE_2, pG->pX_Native_Update, pG->pX_Fld, &sX_Zero) %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   /* ---------------------------------------------------------------------- */       %iflob
   /* Map additional LOB columns to the Sqlda structure before actual insert */       %iflob
   /* ---------------------------------------------------------------------- */       %iflob
                                                                                      %iflob
   if ( fHasRRNO )                                                                    %iflob
   {                                                                                  %iflob
      if ( !fAutoRRN )                                                                %iflob
      {                                                                               %iflob
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) (X_TOTAL_REAL_FIELDS + X_TOTAL_ADDITIONAL_LOB_COLS - 1), 0, pSqlda ) %iflob
      }                                                                               %iflob
      else                                                                            %iflob
      {                                                                               %iflob
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) (sFields + X_TOTAL_ADDITIONAL_LOB_COLS), 0, pSqlda ) %iflob
      }                                                                               %iflob
   }                                                                                  %iflob
#if defined(X_DBM_IDENTITY_COLUMN)                                                    %iflob
   else                                                                               %iflob
   {                                                                                  %iflob
      /* Skip mapping the last field (identity column) */                             %iflob
      X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) (X_TOTAL_REAL_FIELDS + X_TOTAL_ADDITIONAL_LOB_COLS - 1), 0, pSqlda ) %iflob
   }                                                                                  %iflob
#else                                                                                 %iflob
   else                                                                               %iflob
   {                                                                                  %iflob
      X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_TOTAL_REAL_FIELDS + X_TOTAL_ADDITIONAL_LOB_COLS , 0, pSqlda ) %iflob
   }                                                                                  %iflob
#endif                                                                                %iflob
   %lobinsert
                                                                                      %iflob
   if ( strcmp(pX_DBM->vchReturnCode,X_DBM_OKAY) != 0 )                                       %iflob
   {                                                                                          %iflob
      X_DBM_OP( pG->lReturnCode, X_DBM_FREE_STATEMENT, pX_NULL, pX_DBM->sCursorID, pX_NULL ); %iflob
      return;                                                                                 %iflob
   }                                                                                          %iflob

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* ------------------------------------- */
      /* Execute the prepared INSERT statement */
      /* ------------------------------------- */

      X_DBM_OP( pG->lReturnCode, X_DBM_EXECUTE, pX_NULL, pX_DBM->sCursorID, pSqlda )

      /* Always set SQLDANo back to default */
      X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Open Update file if not already open */                      %ifntv
      if ( pG->pX_Native_Update->pFile == pX_NULL )                   %ifntv
      {                                                               %ifntv
         X_LONG lRetCode;                                             %ifntv
         X_DBM_OP_NATIVE_CONTROL(lRetCode, X_DBM_NATIVE_OPEN_2, pG->pX_Native_Update) %ifntv
         if ((lRetCode < X_DBMS_INFO_OKAY)                            %ifntv
          || (pX_Ids->chFatalError == YES))                           %ifntv
         {                                                            %ifntv
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);          %ifntv
            pX_Ids->lLastErrorCode = lRetCode;                        %ifntv
            return;                                                   %ifntv
         }                                                            %ifntv
      }                                                               %ifntv
      /* Insert the record */                                         %ifntv
      X_DBM_OP_NATIVE_CONTROL(pG->lReturnCode, X_DBM_NATIVE_INSERT_2, pG->pX_Native_Update) %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   /* Duplicate row is a validation error only */

   if ( X_DBMS_INFO_IS_DUPLICATE_ROW(pG->lReturnCode) )
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
      X_Issue_Message_Vec(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Ids->vchStandardMessageFile,
                          "IOM0025",
                          pX_Fld,
                          2,
                          X_DBM_FilLibVecs);

      X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS);

      return;
   }

   if (pG->lReturnCode != X_DBMS_INFO_OKAY)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lReturnCode;
      return;
   }

   strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

   if ( fHasRRNO )
   {
      if ( fAutoRRN )
      {
         /* ---------------------------------------------- */
         /* Erase the last RRNO value as we do not have it */
         /* ---------------------------------------------- */
         X_Vec_Set_from_Double(pX_Ids,
                               pX_Pro,
                               pX_Fun,
                               pX_Fld,
                               X_V_%@RRNOxxxx,
                               0.0);
      }
   }

#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   if ( pX_DBM->fUseNativeIO )                                        %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Map from record buffer to OAM to get RRN */                  %ifntv
      X_DBM_OP_NATIVE_MAP(pG->lFetchCode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Update, pG->pX_Fld, &sX_Zero) %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   /* Save the @@RRNO and @@UPID */

   if ( fHasRRNO )
   {
      X_Vec_Get_as_Double(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Fld,
                          X_V_%@RRNOxxxx,
                          &(pG->dLastRRNO[pG->sFileNo]));

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID )
      {
         X_Vec_Get_as_Double(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@UPID,
                             &(pG->dLastUPID[pG->sFileNo]));
      }
#endif

      /* Return @@RRNO if requested */

      if ( pX_DBM->chRetRRNO == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      X_V_%@RRNOxxxx,
                      pX_DBM->pX_Fld,
                      pX_DBM->sRetRRNO);
   }

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( (!fHasUPID) && (X_OAM_Save_Current_Record(X_OAM_STANDARD_PARMS) != TRUE) )
   {
      return;
   }
#endif

   /* Execute batch control logic */                                 %ifbch
   X_OAM_Update_Batch_Control(X_OAM_STANDARD_PARMS,                  %ifbch
                              X_DBM_INSERT_OPERATION);               %ifbch
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)         %ifbch
      return;                                                        %ifbch

   /* Issue the database COMMIT */

   if ( !(X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS)) ) return;

   /* Run after insert trigger */                                    %intrig
   strcpy(pG->X_Trigger.vchOper,"AFTINS");                           %intrig
   %RUNFT *AFTINS1

   return;
#undef X_OAM_LOAD_DATA_CLEANUP
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Open_Request                                 */
/* Description  : OPEN database file request                         */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_CHAR_FUNCTION X_OAM_Open_Request(X_OAM_STANDARD_ARGS)
{

   /* -------------------------------------------------------- */
   /* OPNQRYF is only valid when connected to an AS/400 server */
   /* -------------------------------------------------------- */

   if (pX_DBM->chOPNQRYF == YES)
   {
      X_Issue_Message_Vec(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Ids->vchStandardMessageFile,
                          "IOM0045",
                          pX_Fld,
                          2,
                          X_DBM_FilLibVecs);
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      return(NO);
   }

   /* ------------------------------------------------------------- */
   /* If this is the first open request, then allocate the required */
   /* SQLDA for a select of all table fields .....                  */
   /* ------------------------------------------------------------- */

   if (pG->chFirstCall == YES)
   {

      if ( X_DBM_EXEC_TRIGGER(pG->sSaveRequest) )                     %optrig
      {                                                               %optrig
         /* Run before open trigger ..... */                          %optrig
         strcpy(pG->X_Trigger.vchOper,"BEFOPN");                      %optrig
         %RUNFT *BEFOPN0
      }                                                               %optrig

      /* ------------------------------------------------------ */
      /* Build the SELECT statement for all fields and allocate */
      /* an SQLDA of the appropriate size for this table ....   */
      /* ------------------------------------------------------ */

      /* We will only allocate aSqlda[0] here. Others allocated on the fly */
      memset (pG->aSqlda,LOVAL,sizeof(pG->aSqlda));

      if ( !pX_DBM->fUseNativeIO )                                    %ifntv
      {
         strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
         strcat( pG->vchSqlStmnt, X_DBM_SqlTableName );

         X_DBM_OP( pG->lReturnCode, X_DBM_ALLOCATE_SQLDA, pG->vchSqlStmnt, FALSE, &(pG->aSqlda[0].pSqlda) ) %ifnRDMLX_File
         X_DBM_OP( pG->lReturnCode, X_DBM_ALLOCATE_SQLDA, pG->vchSqlStmnt, TRUE,  &(pG->aSqlda[0].pSqlda) ) %ifRDMLX_File

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return(NO);
         }

         pG->aSqlda[0].chType = ( fIdentity || fAutoRRN ) ? X_SQLDA_SEL_DEL : X_SQLDA_ANY;
      }

      if ( X_DBM_EXEC_TRIGGER(pG->sSaveRequest) )                     %optrig
      {                                                               %optrig
         /* Run after open trigger ..... */                           %optrig
         strcpy(pG->X_Trigger.vchOper,"AFTOPN");                      %optrig
         %RUNFT *AFTOPN0
      }                                                               %optrig

      /* --------------------------------------------- */
      /* Save the process & function opening the table */
      /* --------------------------------------------- */

      pG->chFirstCall = NO;
      pG->pFunctionOpening = pX_Fun;
      pG->pProcessOpening  = pX_Pro;
   }

#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   if ( pX_DBM->fUseNativeIO )                                        %ifntv
   {                                                                  %ifntv
      if ( pG->pX_Native_Curr->pFile == pX_NULL )                     %ifntv
      {                                                               %ifntv
         X_LONG lRetCode;                                             %ifntv
                                                                      %ifntv
         X_DBM_OP_NATIVE_CONTROL(lRetCode, X_DBM_NATIVE_OPEN_2, pG->pX_Native_Curr)                               %ifntv
         if ((lRetCode < X_DBMS_INFO_OKAY)                            %ifntv
          || (pX_Ids->chFatalError == YES))                           %ifntv
         {                                                            %ifntv
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);          %ifntv
            pX_Ids->lLastErrorCode = lRetCode;                        %ifntv
            return(NO);                                               %ifntv
         }                                                            %ifntv
      }                                                               %ifntv
   }                                                                  %ifntv
                                                                      %ifntv
#endif                                                                %ifntv

   /* -------------------------------------------------- */
   /* If this wasn't an open call then reset the request */
   /* before continuing .....                            */
   /* -------------------------------------------------- */

   if (pG->sSaveRequest != pX_DBM->sDBMRequest)
   {
      pX_DBM->sDBMRequest = pG->sSaveRequest;
      return(YES);
   }
   else
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);
      return(NO);
   }

}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Select_Request                               */
/* Description  : SELECT rows request                                */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Select_Request(X_OAM_STANDARD_ARGS)
{

   struct X_DBM_FLDINDEX   *pCurr;
   X_SHORT  sStringLength;
   X_SHORT  i;
   X_SHORT  k;
   X_SQLDA *pSqlda;
   X_SHORT  sSqlda;

   if ( fHasRRNO )
   {
      /* Set the @@RRNO and @@UPID .....                               */

      pG->dLastRRNO[pG->sFileNo] = 0.0;

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID ) pG->dLastUPID[pG->sFileNo] = 0.0;
#endif
   }
   
#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( !fHasUPID )
   {
      pG->fLastSaved[pG->sFileNo] = FALSE;
   }
#endif

   /* ------------------------------------------ */
   /* Check if authorised to read the file first */
   /* ------------------------------------------ */

   if (pG->chReadAuthChecked != YES)
   {
      pG->chAuthorised = X_Check_Authority(pX_Ids,
                                           pX_Pro,
                                           pX_Fun,
                                           "%tablexxxx",
                                           "%fulllibxx",
                                           X_OBJECT_TYPE_FILE,
                                           X_OBJECT_AUTH_READ_DATA);
      if (pG->chAuthorised == NO)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0009",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }
      else
         pG->chReadAuthChecked = YES;
   }

   /* ------------------------------- */
   /* Set current field index pointer */
   /* ------------------------------- */

   X_Search_FldIndex (X_OAM_STANDARD_PARMS);
   pCurr = pG->pCurrFldIndex;

   /* ----------------------------------------- */
   /* If generic key processing, check last key */
   /* ----------------------------------------- */
   if ( ( pX_DBM->chGeneric == YES )
       && ( pX_DBM->scKeyFlds > 0 ) )
   {
      k = pX_DBM->psKeyFlds[pX_DBM->scKeyFlds - 1];
	  if ( !X_VECTOR_USABLE_AS_GENERIC_KEY(pX_DBM->pX_Fld,k) )
      {
         X_Fatal_Error( pX_Ids,
                        pX_Pro,
                        pX_Fun,
                        "X_OAM_Build_Start_Key",
                        "Field %s is not supported by *GENERIC",
                        (pX_DBM->pX_Fld)[ k ].fchName2);
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return ;
      }
   }
   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* ----------------------------------- */
      /* Build the required SELECT statement */
      /* ----------------------------------- */

      strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
      X_OAM_Add_Table_Name(X_OAM_STANDARD_PARMS);

      /* Build WHERE according to keys passed in key field vectors */

      if (pX_DBM->scKeyFlds > 0)
         strcat(pG->vchSqlStmnt," WHERE ");

      /* If key is a starting position key build the condition */

      if (pX_DBM->chStartKey == YES)
      {
         X_OAM_Build_Start_Key(X_OAM_STANDARD_PARMS);
         if (pX_Ids->chFatalError == YES)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            return;
         }
      }

      /* Otherwise build simple where condition */

      else
      {
         for (i = 0; i < pX_DBM->scKeyFlds; i++)
         {
            X_PVCHAR pvchTemp;

            if (i > 0) strcat(pG->vchSqlStmnt," AND ");

            %where

            /* If generic searching use the LIKE predicate */

            k = pX_DBM->psKeyFlds[i];

            if ( ( pX_DBM->chGeneric == YES )
             && ( i == (pX_DBM->scKeyFlds - 1 ) ) )
            {
               if ( ( X_VECTOR_STORED_AS_ALPHA( pX_DBM->pX_Fld, k) ) || ( X_VECTOR_STORED_AS_CHAR( pX_DBM->pX_Fld, k) ) ) 
               {
                  X_VCHAR vchEscape[11 + 1]; /* Allow for DBCS escape char */
                  
                  struct X_CTD_DBMS_INFO * pDBMSInfo =
                  ((X_DBM_V3_OR_LATER && pX_DBM->pDatabase) ? pX_DBM->pDatabase->pDBMSInfo
                                                            : pX_Ids->pUserDBMSInfo);

                  strcat(pG->vchSqlStmnt," LIKE ");
                  pvchTemp = pG->vchSqlStmnt + strlen(pG->vchSqlStmnt);

                  if ( !X_OAM_Add_Value_To_Stmnt(X_OAM_STANDARD_PARMS, k, i) )
                  {
                     return;
                  }
                  pvchTemp[strlen(pvchTemp) - 1] = END_OF_STRING;
                  X_Remove_Blanks(pX_Ids,pX_Pro,pX_Fun,
                                  pvchTemp,X_STRIP_BLANKS_TRAILING);

                  /* Must escape wildcards in data to be same as 400 */
                  X_EscapeSQLWildcards_2( pX_Ids,
                                          pX_Pro,
                                          pX_Fun,
                                          pDBMSInfo,
                                          pvchTemp,
                                          sizeof(pG->vchSqlStmnt) - (pvchTemp - pG->vchSqlStmnt),
                                          TRUE,
                                          TRUE,
                                          TRUE,
                                          pX_DBM->pX_Fld[k].chDBCS,
                                          vchEscape,
                                          sizeof(vchEscape) );

                  strcat(pvchTemp, "%\'");

                  if ( vchEscape[0] != END_OF_STRING )
                  {
                     strcat(pvchTemp," ");
                     strcat(pvchTemp, vchEscape);
                  }

               }
               else if ( X_VECTOR_STORED_AS_PACKED( pX_DBM->pX_Fld, k)  || X_VECTOR_STORED_AS_SIGNED( pX_DBM->pX_Fld, k) ||
                            X_VECTOR_STORED_AS_INTEGER( pX_DBM->pX_Fld, k) )
 
               {
                  /* TN: Generic Numeric */

                  %gennum            
               }
            }
            else
            {
               strcat(pG->vchSqlStmnt," = ");
               if ( !X_OAM_Add_Value_To_Stmnt(X_OAM_STANDARD_PARMS, k, i) )
               {
                  return;
               }

            }
         }
      }

      /* Add any WHERE condition if it involves only "real" fields */

      if (pX_DBM->scWhere > 0)
      {
         if (pX_DBM->scKeyFlds > 0)
            strcat(pG->vchSqlStmnt," AND ");
         else
            strcat(pG->vchSqlStmnt," WHERE ");
         X_OAM_Build_Where(X_OAM_STANDARD_PARMS);
         if (pX_Ids->chFatalError == YES)
         {
            strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
            return;
         }
      }

      /* Check length does not exceed sizeof(pG->vchSqlStmnt) */
      if ( strlen(pG->vchSqlStmnt) >= sizeof(pG->vchSqlStmnt) )
      {
         X_Fatal_Error(pX_Ids,
                       pX_Pro,
                       pX_Fun,
                       "OAM for table %tablexxxx",
                       X_TEXT(273));
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }

      /* Build ORDER BY according to table/index keys */

      if (pX_DBM->chBackwards == YES)
      {
         %orderback
      }
      else
      {
         %orderby
      }

      /* Check length does not exceed sizeof(pG->vchSqlStmnt) */
      if ( strlen(pG->vchSqlStmnt) >= sizeof(pG->vchSqlStmnt) )
      {
         X_Fatal_Error(pX_Ids,
                       pX_Pro,
                       pX_Fun,
                       "OAM for table %tablexxxx",
                       X_TEXT(273));
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }

      /* ------------------------------------- */
      /* Prepare the required SELECT statement */
      /* ------------------------------------- */

      pX_Ids->chOAMRqsType = X_VARIANT_SELECT;
      pX_Ids->fX_DBM_PrepareParams = FALSE; /* Because RRN not in SQL */

      X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0,  &(pX_DBM->sCursorID) )
      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }

      /* -------------------------------------------- */              %iflob
      /* Copy where and order by to LOB SQL statement */              %iflob
      /* -------------------------------------------- */              %iflob
      {                                                               %iflob
         const X_BOOL fCurrent = FALSE;                               %iflob
         %lobfetchinit
      }                                                               %iflob
                                                                      %iflob
      /* --------------------- */
      /* Get appropriate SQLDA */
      /* --------------------- */
      sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
      if ( sSqlda < 0 ) return;

      /* --------------------------------------------------- */
      /* Open the cursor associated with the prepared SELECT */
      /* --------------------------------------------------- */

      X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, pX_DBM->sCursorID, pSqlda )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }
   }

   /* Run before read trigger ..... */                                %rdtrig
   strcpy(pG->X_Trigger.vchOper,"BEFRED");                            %rdtrig
   X_OAM_Read_Triggers(X_OAM_STANDARD_PARMS);                         %rdtrig
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_OKAY) != 0)                 %rdtrig
      return;                                                         %rdtrig

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {

      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* ------------------------------- */
      /* Attempt to fetch a matching row */
      /* ------------------------------- */

      X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
      X_OAM_Native_Fetch_First( X_OAM_STANDARD_PARMS );               %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
    || (pX_Ids->chFatalError == YES))
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lFetchCode;
      return;
   }

   /* ------------------------------- */
   /* Set the appropriate return code */
   /* ------------------------------- */

   if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
   {
      X_PVCHAR pvchEOFCode = (pX_DBM->chBackwards == YES) ? X_DBM_BEGIN_FILE : X_DBM_END_FILE;
      strcpy(pX_DBM->vchReturnCode,pvchEOFCode);
      if (pX_DBM->chMsgReqd == YES)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0014",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
      }
      return;
   }

   else
      strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* ---------------------------------------------- */
      /* Map fields from the Sqlda structure after read */
      /* ---------------------------------------------- */

      X_DBM_OP( lDummyRetcode, X_DBM_MAP_FROM_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Map from record buffer to OAM */                             %ifntv
      X_DBM_OP_NATIVE_MAP(lDummyRetcode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Curr, pG->pX_Fld, &sX_Zero) %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   /* --------------------------- */                                  %iflob
   /* Fetch matching LOBs, if any */                                  %iflob
   /* --------------------------- */                                  %iflob
   if ( X_DBM_IS_USING_NATIVE_IO )                                    %iflob
   {                                                                  %iflob
      const X_BOOL fCurrent = TRUE;                                   %iflob
      %lobfetchinit
   }                                                                  %iflob

   {                                                                   %iflob
      X_SHORT rc = 0;                                                  %iflob
      X_VCHAR vchLOBDir[X_MAX_SIZE_LOB_FILE_NAME + 1] = "";            %iflob
      X_TYPE_FLAG chAttrib;                                            %iflob
      PX_LIST_VOID pX_List = pX_NULL;                                  %iflob
      X_SHORT sMsgId;                                                  %iflob
                                                                       %iflob
      %lobfetchfetch
      %lobfetchmap
                                                                       %iflob
      switch ( rc )                                                    %iflob
      {                                                                %iflob
         case -1:                                                      %iflob
            sMsgId = 1038;                                             %iflob
            break;                                                     %iflob
                                                                       %iflob
         case -2:                                                      %iflob
            sMsgId = 1039;                                             %iflob
            break;                                                     %iflob
                                                                       %iflob
         case -3:                                                      %iflob
            sMsgId = 1040;                                             %iflob
            break;                                                     %iflob
      }                                                                %iflob
                                                                       %iflob
      if ( rc < 0 )                                                    %iflob
      {                                                                %iflob
         X_Issue_Message_VChar( pX_Ids,                                %iflob
                                pX_Pro,                                %iflob
                                pX_Fun,                                %iflob
                                pX_Ids->vchStandardMessageFile,        %iflob
                                "DCM9899",                             %iflob
                                X_TEXT_NOID(sMsgId));                  %iflob
      }                                                                %iflob
                                                                       %iflob
      if ( pX_Ids->chFatalError == YES || rc < 0 )                     %iflob
      {                                                                %iflob
         if (pX_DBM->chWhereRDML == NO)                                %iflob
         {                                                             %iflob
            X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS);          %iflob
         }                                                             %iflob
         return;                                                       %iflob
      }                                                                %iflob
                                                                       %iflob
      if ( X_DBM_IS_USING_NATIVE_IO )                                  %iflob
      {                                                                %iflob
         /* Close cursor as we need to handle each record independently */ %iflob
         %lobfetchclose
      }                                                                %iflob
   }                                                                   %iflob

   /* Execute virtual code */                                        %ifvcpjf
                                                                     %ifvcpjf
   X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_PARMS);              %ifvcpjf
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)         %ifvcpjf
      return;                                                        %ifvcpjf

   /* Save the @@RRNO and @@UPID */

   if ( fHasRRNO )
   {
      X_Vec_Get_as_Double(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Fld,
                          X_V_%@RRNOxxxx,
                          &(pG->dLastRRNO[pG->sFileNo]));

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID )
      {
         X_Vec_Get_as_Double(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@UPID,
                             &(pG->dLastUPID[pG->sFileNo]));
      }
#endif

      /* Return @@RRNO if requested */

      if ( pX_DBM->chRetRRNO == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      X_V_%@RRNOxxxx,
                      pX_DBM->pX_Fld,
                      pX_DBM->sRetRRNO);
   }

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( (!fHasUPID) && (X_OAM_Save_Current_Record(X_OAM_STANDARD_PARMS) != TRUE) )
   {
      return;
   }
#endif

   /* Run after read trigger ..... */                                 %rdtrig
   strcpy(pG->X_Trigger.vchOper,"AFTRED");                            %rdtrig
   X_OAM_Read_Triggers(X_OAM_STANDARD_PARMS);                         %rdtrig
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_OKAY) != 0)                 %rdtrig
      return;                                                         %rdtrig

   /* ---------------------------------------------------- */
   /* Map the OAM field vectors to the group field vectors */
   /* ---------------------------------------------------- */

   for (i = 0; i < X_TOTAL_FIELDS; i++)
   {
      if (pCurr->X_DBM_FldsUsed[i] == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      i,
                      pX_DBM->pX_Fld,
                      pCurr->X_DBM_FldsIndex[i]);
   }

   /* ------------------------------------------------ */
   /* Make Group field usage info available externally */
   /* ------------------------------------------------ */

   if ( pX_DBM->scGrpFlds )
   {
      pX_Ids->pchIOMUsedGrpFlds = pCurr->X_DBM_UsedGrpFlds;
   }

   /* Reverse data if SREV used */                                    %ifsrev
   if (X_LANGUAGE_IS_RLTB)                                            %ifsrev
   {                                                                  %ifsrev
      for (i = 0; i < pX_DBM->scGrpFlds; i++)                         %ifsrev
      {                                                               %ifsrev
         %srevdout
               X_Reverse_String(pX_Ids,pX_Pro,pX_Fun,                 %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].pField,   %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].sByteLen);%ifsrev
      }                                                               %ifsrev
   }                                                                  %ifsrev
                                                                      %ifsrev
   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Select_Next_Request                          */
/* Description  : SELECT_NEXT row request                            */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Select_Next_Request(X_OAM_STANDARD_ARGS)
{

   X_SHORT  i;
   struct X_DBM_FLDINDEX *pCurr;
   X_SQLDA *pSqlda;
   X_SHORT  sSqlda;

   /* ------------------------------- */
   /* Set current field index pointer */
   /* ------------------------------- */

   X_Search_FldIndex (X_OAM_STANDARD_PARMS);
   pCurr = pG->pCurrFldIndex;

   /* Run before read trigger ..... */                                %rdtrig
   strcpy(pG->X_Trigger.vchOper,"BEFRED");                            %rdtrig
   X_OAM_Read_Triggers(X_OAM_STANDARD_PARMS);                         %rdtrig
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_OKAY) != 0)                 %rdtrig
      return;                                                         %rdtrig

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */

      /* --------------------- */
      /* Get appropriate SQLDA */
      /* --------------------- */
      sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
      if ( sSqlda < 0 ) return;

      /* -------------------------------------- */
      /* Attempt to fetch the next matching row */
      /* -------------------------------------- */

      X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Read the next/previous record */                             %ifntv
      X_OAM_Native_Fetch_Next( X_OAM_STANDARD_PARMS );                %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
    || (pX_Ids->chFatalError == YES))
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lFetchCode;
      return;
   }

   /* ------------------------------- */
   /* Set the appropriate return code */
   /* ------------------------------- */

   if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
   {
      X_PVCHAR pvchEOFCode = (pX_DBM->chBackwards == YES) ? X_DBM_BEGIN_FILE : X_DBM_END_FILE;
      strcpy(pX_DBM->vchReturnCode,pvchEOFCode);
      return;
   }

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* ---------------------------------------------- */
      /* Map fields from the Sqlda structure after read */
      /* ---------------------------------------------- */

      X_DBM_OP( lDummyRetcode, X_DBM_MAP_FROM_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use Native I/O               */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Map from record buffer to OAM */                             %ifntv
      X_DBM_OP_NATIVE_MAP(lDummyRetcode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Curr, pG->pX_Fld, &sX_Zero)  %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   /* --------------------------- */                                  %iflob
   /* Fetch matching LOBs, if any */                                  %iflob
   /* --------------------------- */                                  %iflob
   if ( X_DBM_IS_USING_NATIVE_IO )                                    %iflob
   {                                                                  %iflob
      const X_BOOL fCurrent = TRUE;                                   %iflob
      %lobfetchinit
   }                                                                  %iflob

   {                                                                   %iflob
      X_SHORT rc = 0;                                                  %iflob
      X_VCHAR vchLOBDir[X_MAX_SIZE_LOB_FILE_NAME + 1] = "";            %iflob
      X_TYPE_FLAG chAttrib;                                            %iflob
      PX_LIST_VOID pX_List = pX_NULL;                                  %iflob
      X_SHORT sMsgId;                                                  %iflob
                                                                       %iflob
      %lobfetchfetch
      %lobfetchmap
                                                                       %iflob
      switch ( rc )                                                    %iflob
      {                                                                %iflob
         case -1:                                                      %iflob
            sMsgId = 1038;                                             %iflob
            break;                                                     %iflob
                                                                       %iflob
         case -2:                                                      %iflob
            sMsgId = 1039;                                             %iflob
            break;                                                     %iflob
                                                                       %iflob
         case -3:                                                      %iflob
            sMsgId = 1040;                                             %iflob
            break;                                                     %iflob
      }                                                                %iflob
                                                                       %iflob
      if ( rc < 0 )                                                    %iflob
      {                                                                %iflob
         X_Issue_Message_VChar( pX_Ids,                                %iflob
                                pX_Pro,                                %iflob
                                pX_Fun,                                %iflob
                                pX_Ids->vchStandardMessageFile,        %iflob
                                "DCM9899",                             %iflob
                                X_TEXT_NOID(sMsgId));                  %iflob
      }                                                                %iflob
                                                                       %iflob
      if ( pX_Ids->chFatalError == YES || rc < 0 )                     %iflob
      {                                                                %iflob
         if (pX_DBM->chWhereRDML == NO)                                %iflob
         {                                                             %iflob
            X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS);          %iflob
         }                                                             %iflob
         return;                                                       %iflob
      }                                                                %iflob
                                                                       %iflob
      if ( X_DBM_IS_USING_NATIVE_IO )                                  %iflob
      {                                                                %iflob
         /* Close cursor as we need to handle each record independently */ %iflob
         %lobfetchclose
      }                                                                %iflob
   }                                                                   %iflob

   /* Execute virtual code */                                        %ifvcpjf
                                                                     %ifvcpjf
   X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_PARMS);              %ifvcpjf
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)         %ifvcpjf
      return;                                                        %ifvcpjf

   /* Save the @@RRNO and @@UPID */

   if ( fHasRRNO )
   {
      X_Vec_Get_as_Double(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Fld,
                          X_V_%@RRNOxxxx,
                          &(pG->dLastRRNO[pG->sFileNo]));

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID )
      {
         X_Vec_Get_as_Double(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@UPID,
                             &(pG->dLastUPID[pG->sFileNo]));
      }
#endif

      /* Return @@RRNO if requested */

      if ( pX_DBM->chRetRRNO == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      X_V_%@RRNOxxxx,
                      pX_DBM->pX_Fld,
                      pX_DBM->sRetRRNO);
   }

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( (!fHasUPID) && (X_OAM_Save_Current_Record(X_OAM_STANDARD_PARMS) != TRUE) )
   {
      return;
   }
#endif

   /* Run after read trigger ..... */                                 %rdtrig
   strcpy(pG->X_Trigger.vchOper,"AFTRED");                            %rdtrig
   X_OAM_Read_Triggers(X_OAM_STANDARD_PARMS);                         %rdtrig
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_OKAY) != 0)                 %rdtrig
      return;                                                         %rdtrig

   /* ---------------------------------------------------- */
   /* Map the OAM field vectors to the group field vectors */
   /* ---------------------------------------------------- */

   for (i = 0; i < X_TOTAL_FIELDS; i++)
   {
      if (pCurr->X_DBM_FldsUsed[i] == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      i,
                      pX_DBM->pX_Fld,
                      pCurr->X_DBM_FldsIndex[i]);
   }

   strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

   /* ------------------------------------------------ */
   /* Make Group field usage info available externally */
   /* ------------------------------------------------ */

   if ( pX_DBM->scGrpFlds )
   {
      pX_Ids->pchIOMUsedGrpFlds = pCurr->X_DBM_UsedGrpFlds;
   }

   /* Reverse data if SREV used */                                    %ifsrev
   if (X_LANGUAGE_IS_RLTB)                                            %ifsrev
   {                                                                  %ifsrev
      for (i = 0; i < pX_DBM->scGrpFlds; i++)                         %ifsrev
      {                                                               %ifsrev
         %srevdout
               X_Reverse_String(pX_Ids,pX_Pro,pX_Fun,                 %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].pField,   %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].sByteLen);%ifsrev
      }                                                               %ifsrev
   }                                                                  %ifsrev

   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Update_Request                               */
/* Description  : UPDATE row(s) request                              */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Update_Request(X_OAM_STANDARD_ARGS)
{
   struct X_DBM_FLDINDEX   *pCurr;
   X_SHORT  sStringLength;
   X_VCHAR  vchString[(X_MAX_UPID_FIELD_LEN * 2) + 2 + 1];
   X_SHORT  i;
   X_SHORT  j;
   X_LONG   lRowCount;
   X_SQLDA *pSqlda;
   X_SHORT  sSqlda;
   X_PVCHAR pvchRRNO = X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_RRN );
   X_BOOL   fError;
   X_BOOL  fCrossedUpdateCheck = TRUE;

   /* Abort if read-only file */                                       %ifrdonly
   {                                                                   %ifrdonly
      X_PVCHAR avchParms[3];                                           %ifrdonly
                                                                       %ifrdonly
      avchParms[0] = "UPDATE";                                         %ifrdonly
      avchParms[1] = ErrTxt1;                                          %ifrdonly
      avchParms[2] = ErrTxt2;                                          %ifrdonly
                                                                       %ifrdonly
      X_Issue_Message_VChar_Ptrs( pX_Ids, pX_Pro, pX_Fun,              %ifrdonly
                                  pX_Ids->vchStandardMessageFile,      %ifrdonly
                                  "IOM0052", 3, avchParms );           %ifrdonly
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);                 %ifrdonly
      return;                                                          %ifrdonly
   }                                                                   %ifrdonly
                                                                       %ifrdonly
/* Update always requires primary key or RRNO column */
#if defined(X_DBM_NO_PKEY)
   if ( !fHasRRNO )
   {
      X_Fatal_Error(pX_Ids,
                    pX_Pro,
                    pX_Fun,
                    "OAM for table %tablexxxx",
                    X_TEXT(842));
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      return;
   }
#endif

   strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

   /* -------------------------------- */
   /* Check if allowed to update first */
   /* -------------------------------- */

   if (pG->chUpdateAuthChecked != YES)
   {
      pG->chAuthorised = X_Check_Authority(pX_Ids,
                                           pX_Pro,
                                           pX_Fun,
                                           "%tablexxxx",
                                           "%fulllibxx",
                                           X_OBJECT_TYPE_FILE,
                                           X_OBJECT_AUTH_CHANGE_DATA);

      if (pG->chAuthorised == NO)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0010",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }
      else
         pG->chUpdateAuthChecked = YES;
   }

   /* ------------------------------- */
   /* Set current field index pointer */
   /* ------------------------------- */

   X_Search_FldIndex (X_OAM_STANDARD_PARMS);
   pCurr = pG->pCurrFldIndex;

   /* ------------------------------------------------------------- */
   /* If no keys or where condition specified, then update last row */
   /* read using @@RRNO from previous read or WITH_RRN vector ..... */
   /* ------------------------------------------------------------- */

   if ((pX_DBM->scKeyFlds == 0) && (pX_DBM->scWhere == 0) && (pX_DBM->chWhereRDML == NO))
   {
      /* If WITH_RRN specified use this vector as the update key */
      /* Otherwise use the last RRNO from a previous FETCH       */

      if (pX_DBM->chWithRRNO == YES)
      {
         if ( !fHasRRNO )
         {
            X_Fatal_Error(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          "OAM for table %tablexxxx",
                          X_TEXT(842));
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            return;
         }
         else
         {
            X_Vec_Get_as_Double(pX_Ids,
                                pX_Pro,
                                pX_Fun,
                                pX_DBM->pX_Fld,
                                pX_DBM->sWithRRNO,
                                &(pG->dLastRRNO[pG->sFileNo]));
#ifdef X_OAM_UPID_REQUIRED
            if ( fHasUPID )
            {
               pG->dLastUPID[pG->sFileNo] = 0.0;
            }
#endif
         }
         fCrossedUpdateCheck = FALSE;
      }

      /* Check that a previous record has been read */
      fError = FALSE;
      if ( fHasRRNO )
      {
         if (pG->dLastRRNO[pG->sFileNo] == 0.0) fError = TRUE;
      }

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
      if ( !fHasUPID )
      {
         if (pG->fLastSaved[pG->sFileNo] == FALSE) fError = TRUE;
      }
#endif

      if ( fError )
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0015",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
         return;
      }

      if ( !X_DBM_IS_USING_NATIVE_IO )
      {
         /* ---------------------------- */
         /* Use ODBC / ORACLE / SQLCLI   */
         /* ---------------------------- */
         /* Build the required SELECT statement using the RRNO (or PKEY) */

         strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );

         if ( fHasRRNO )
         {
#ifdef X_DATABASE_ORACLE
            sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = :0", X_DBM_SqlTableName, pvchRRNO );
#else
            sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = ?", X_DBM_SqlTableName, pvchRRNO );
#endif
            pX_Ids->chOAMRqsType = X_INVARIANT_SELECT;
         }
         else
         {
#ifdef X_OAM_REPLACE_RRN_WITH_PKEY_REQUIRED
            /* Append table name and where clause of primary key from last record read */

            X_OAM_Add_Table_Name(X_OAM_STANDARD_PARMS);
            X_OAM_Build_Primary_Key_Where(X_OAM_STANDARD_PARMS,TRUE,FALSE,TRUE);
            if (pX_Ids->chFatalError == YES)
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
               return;
            }

            pX_Ids->chOAMRqsType = X_VARIANT_SELECT;
            pX_Ids->fX_DBM_PrepareParams = FALSE; /* Because RRN not in SQL */
#endif
         }

         /* Prepare the required SELECT statement */

         X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }

         /* --------------------- */
         /* Get appropriate SQLDA */
         /* --------------------- */
         sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
         if ( sSqlda < 0 ) return;

         /* Open the cursor associated with the prepared SELECT */

         if ( fHasRRNO )
         {
            /* Only one column to be processed (RRNO) */
            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) 1, 0, pSqlda )

            InsertRRNParms.xdVal  = pG->dLastRRNO[pG->sFileNo];
            InsertRRNParms.pSqlda = pSqlda;
            InsertRRNParms.pX_Fld = pX_Fld;
            X_DBM_OP( lDummyRetcode, X_DBM_INSERT_RRN, pX_NULL, 0, &InsertRRNParms )
         }

#ifdef X_DATABASE_ODBC
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )
#endif

         X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, pX_DBM->sCursorID, pSqlda )

         /* Always set SQLDANo back to default for fetch */
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }

         /* Attempt to fetch a matching row */

         X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )
      }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
      else                                                            %ifntv
      {                                                               %ifntv
         /* ---------------------------- */                           %ifntv
         /* Use iSeries Native IO        */                           %ifntv
         /* ---------------------------- */                           %ifntv
         /* Read by relative record number */                         %ifntv
         pG->pX_Native_Update->fLock        = TRUE;                   %ifntv
         X_OAM_Native_Fetch_RRN( X_OAM_STANDARD_PARMS );              %ifntv
      }                                                               %ifntv
#endif                                                                %ifntv

      if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
       || (pX_Ids->chFatalError == YES))
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lFetchCode;
         return;
      }

      /* If the record is no longer present */

      if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0016",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
      }


      if ( !X_DBM_IS_USING_NATIVE_IO )
      {
         /* ---------------------------- */
         /* Use ODBC / ORACLE / SQLCLI   */
         /* ---------------------------- */
         /* Close the cursor associated with the prepared SELECT */

         X_DBM_OP( pG->lReturnCode, X_DBM_CLOSE_CURSOR, pX_NULL, pX_DBM->sCursorID, pX_NULL )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }
      }

      if (strcmp(pX_DBM->vchReturnCode,X_DBM_NO_RECORD) == 0)
      {
         return;
      }

      if ( !X_DBM_IS_USING_NATIVE_IO )
      {
         /* ---------------------------- */
         /* Use ODBC / ORACLE / SQLCLI   */
         /* ---------------------------- */

         /* Map fields from the Sqlda structure */

         X_DBM_OP( lDummyRetcode, X_DBM_MAP_FROM_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSqlda )
      }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
      else                                                            %ifntv
      {                                                               %ifntv
         /* ---------------------------- */                           %ifntv
         /* Use iSeries Native IO        */                           %ifntv
         /* ---------------------------- */                           %ifntv
         /* Map from record buffer to OAM */                          %ifntv
         X_DBM_OP_NATIVE_MAP(lDummyRetcode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Update, pG->pX_Fld, &sX_Zero) %ifntv
      }                                                               %ifntv
#endif                                                                %ifntv

      /* Execute virtual code */                                     %ifvcpjf
                                                                     %ifvcpjf
      X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_PARMS);           %ifvcpjf
      if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)      %ifvcpjf
      {                                                              %ifvcpjf
#if defined(X_OPERATING_SYSTEM_ISERIES)                       %ifntv %ifvcpjf
         if ( pX_DBM->fUseNativeIO )                          %ifntv %ifvcpjf
         {                                                    %ifntv %ifvcpjf
            /* ---------------------------- */                %ifntv %ifvcpjf
            /* Use iSeries Native IO        */                %ifntv %ifvcpjf
            /* ---------------------------- */                %ifntv %ifvcpjf
            /* Unlock the record */                           %ifntv %ifvcpjf
            X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update) %ifntv %ifvcpjf
         }                                                    %ifntv %ifvcpjf
#endif                                                        %ifntv %ifvcpjf
         return;                                                     %ifvcpjf
	   }                                                              %ifvcpjf

      fError = FALSE;

#ifdef X_OAM_UPID_REQUIRED
   if ( fHasUPID )
   {
      /* Determine if the @@UPID field has changed */

      X_Vec_Get_as_Double(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Fld,
                          X_V_%@UPID,
                          &(pG->dThisUPID));
      if (fCrossedUpdateCheck
       && (pG->dThisUPID != pG->dLastUPID[pG->sFileNo])) fError = TRUE;
   }
#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   else
   {
#endif
#endif
#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( fCrossedUpdateCheck )
   {
      /* Compare fields to see if any have changed */
      if (X_OAM_Compare_Current_Record(X_OAM_STANDARD_PARMS))  fError = TRUE;
   }
#ifdef X_OAM_UPID_REQUIRED
   } /* else */
#endif
#endif

      if ( fError )
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0017",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
         if ( pX_DBM->fUseNativeIO )                                  %ifntv
         {                                                            %ifntv
            /* ---------------------------- */                        %ifntv
            /* Use iSeries Native IO        */                        %ifntv
            /* ---------------------------- */                        %ifntv
            /* Unlock the record */                                   %ifntv
            X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update) %ifntv
         }                                                            %ifntv
#endif                                                                %ifntv
         return;
      }

      {
         /* Save the before update field details */                     %uptbch
         *(pG->pX_Prev) = *(pG->pX_Curr);                               %uptbch
      }

      /* Map the group field vectors to the OAM field vectors */

      for (i = 0; i < X_TOTAL_FIELDS; i++)
      {
         if (pCurr->X_DBM_FldsUsed[i] == YES)
            X_Vec_Assign(pX_Ids,
                         pX_Pro,
                         pX_Fun,
                         pX_DBM->pX_Fld,
                         pCurr->X_DBM_FldsIndex[i],
                         pX_Fld,
                         i);
      }

      /* Reverse data if SREV used */                                 %ifsrev
      if (X_LANGUAGE_IS_RLTB)                                         %ifsrev
      {                                                               %ifsrev
         %srevdin
      }                                                               %ifsrev

      /* Set date/time stamps */                                    %ifstmp
                                                                    %ifstmp
      X_OAM_Stamp_Attributes(X_OAM_STANDARD_PARMS,                  %ifstmp
                             X_DBM_UPDATE_OPERATION);               %ifstmp
                                                                    %ifstmp
      /* Execute virtual code */                                    %ifvc
                                                                    %ifvc
      X_OAM_Virtual_Code_Before_Write(X_OAM_STANDARD_PARMS);        %ifvc

      {
         /* Perform all update validation checks */

         X_OAM_Validation_Checks(X_OAM_STANDARD_PARMS,
                                 X_DBM_UPDATE_OPERATION);
         if (strcmp(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR) == 0)
         {
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
            if ( pX_DBM->fUseNativeIO )                               %ifntv
            {                                                         %ifntv
               /* ---------------------------- */                     %ifntv
               /* Use iSeries Native IO        */                     %ifntv
               /* ---------------------------- */                     %ifntv
               /* Unlock the record */                                %ifntv
               X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update) %ifntv
            }                                                         %ifntv
#endif                                                                %ifntv
            return;
         }

         /* Run before update trigger ..... */                          %uptrig
         strcpy(pG->X_Trigger.vchOper,"BEFUPD");                        %uptrig
         %RUNFT *BEFUPD2
      }

      /* If only validation checks are to be performed then return */

      if (pX_DBM->chValOnly == YES)
      {
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
         if ( pX_DBM->fUseNativeIO )                                  %ifntv
         {                                                            %ifntv
            /* ---------------------------- */                        %ifntv
            /* Use iSeries Native IO        */                        %ifntv
            /* ---------------------------- */                        %ifntv
            /* Unlock the record */                                   %ifntv
            X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update) %ifntv
         }                                                            %ifntv
#endif                                                                %ifntv
         strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);
         return;
      }

      if ( !X_DBM_IS_USING_NATIVE_IO )
      {
         /* ---------------------------- */
         /* Use ODBC / ORACLE / SQLCLI   */
         /* ---------------------------- */
         /* Build the required UPDATE statement using RRNO (or PKEY) */

         strcpy(pG->vchSqlStmnt,X_DBM_UpdateFlds);

         if ( fHasRRNO )
         {
#ifdef X_DATABASE_ORACLE
            sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt), " WHERE %s = :0", pvchRRNO );
#else
            sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt), " WHERE %s = ?", pvchRRNO );
#endif
#ifdef X_OAM_UPID_REQUIRED
            if ( fHasUPID )
            {
               /* Append the UPID (must be done before UPID is incremented) */

               X_Set_Vchar_from_Double(pX_Ids,pX_Pro,pX_Fun,pG->dThisUPID,vchString,
                                       sizeof(vchString),X_L_X_UPID,X_D_X_UPID);

               sprintf(pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),
                       " AND %s = %s",X_DBM_UPIDNativeName,vchString);
               pX_Ids->chOAMRqsType = X_VARIANT_UPDATE;
            }
            else
#endif
            {
               pX_Ids->chOAMRqsType = X_INVARIANT_UPDATE;
            }
         }
#ifdef X_OAM_REPLACE_RRN_WITH_PKEY_REQUIRED
         else
         {
            /* Append where clause of primary key from last record read.               */
            /* Note: there is a small window btn previous read and this update where   */
            /* an update may have occurred (as we don't specify all fields on file in  */
            /* the where clause -- the equivalent of specify X_UPID in where clause)   */

            X_OAM_Build_Primary_Key_Where(X_OAM_STANDARD_PARMS,TRUE,FALSE,TRUE);
            if (pX_Ids->chFatalError == YES)
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
               return;
            }
            pX_Ids->chOAMRqsType = X_VARIANT_UPDATE;
         }
#endif

         /* Prepare the required UPDATE statement */

         AVOID_JOURNALING(pG->vchSqlStmnt)                           %ifncmt

         X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }

#ifdef X_OAM_UPID_REQUIRED
         if ( fHasUPID )
         {
            /* Increment @@UPID before update */

            pG->dThisUPID++;
            X_Vec_Set_from_Double(pX_Ids,
                                  pX_Pro,
                                  pX_Fun,
                                  pX_Fld,
                                  X_V_%@UPID,
                                  pG->dThisUPID);
         }
#endif

         /* --------------------- */
         /* Get appropriate SQLDA */
         /* --------------------- */
         sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_UPDATE,TRUE);

         if ( sSqlda < 0 ) return;

         /* ------------------------------------------------------ */
         /* Map fields to the Sqlda structure before actual update */
         /* ------------------------------------------------------ */
         
         if ( fIdentity )
         {
            /* Skip mapping the first field (RRNO) */
            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) ( X_TOTAL_REAL_NON_LOB_FIELDS - 1 ), 0, pSqlda )

            X_DBM_OP( lDummyRetcode, X_DBM_MAP_TO_TABLE_NO_RRNO, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSqlda )
         }
         else if ( fAutoRRN )
         {
            /* Skip mapping the first field (RRNO) */
            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) ( X_TOTAL_REAL_NON_LOB_FIELDS - (fHasUPID ? 1 : 2) ), 0, pSqlda )

            X_DBM_OP( lDummyRetcode, X_DBM_MAP_TO_TABLE_NO_RRNO, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSqlda )
         }
         else
         {
            /* All columns are used as this is an UPDATE WHERE @@RRNO = ? */
            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_TOTAL_REAL_NON_LOB_FIELDS, 0, pSqlda )

            X_DBM_OP( lDummyRetcode, X_DBM_MAP_TO_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSqlda )
         }

         /* Execute the prepared UPDATE statement */

         X_DBM_OP( pG->lReturnCode, X_DBM_EXECUTE_ROWCOUNT, (X_PVCHAR) (&lRowCount), pX_DBM->sCursorID, pSqlda )

         if ( X_DBMS_INFO_IS_DUPLICATE_ROW(pG->lReturnCode) )
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
            X_Issue_Message_Vec(pX_Ids,
                                pX_Pro,
                                pX_Fun,
                                pX_Ids->vchStandardMessageFile,
                                "IOM0025",
                                pX_Fld,
                                2,
                                X_DBM_FilLibVecs);

            X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS);
            return;
         }

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }

         /* If no rows updated, determine whether row deleted or updated */
         if (lRowCount < 1)
         {
            if ( !fHasUPID ) /* When updating without UPID, row must have been deleted */
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
               X_Issue_Message_Vec(pX_Ids,
                                   pX_Pro,
                                   pX_Fun,
                                   pX_Ids->vchStandardMessageFile,
                                   "IOM0016",
                                   pX_Fld,
                                   2,
                                   X_DBM_FilLibVecs);
            }
            else
            {
               /* Build the required SELECT statement using the RRNO */

               strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
#ifdef X_DATABASE_ORACLE
               sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = :0", X_DBM_SqlTableName, pvchRRNO );
#else
               sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = ?", X_DBM_SqlTableName, pvchRRNO );
#endif

              /* Prepare the required SELECT statement */

               pX_Ids->chOAMRqsType = X_INVARIANT_SELECT;

               X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

               if (pG->lReturnCode != X_DBMS_INFO_OKAY)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lReturnCode;
                  return;
               }

               /* --------------------- */
               /* Get appropriate SQLDA */
               /* --------------------- */
               sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
               if ( sSqlda < 0 ) return;

               /* Open the cursor associated with the prepared SELECT */

               /* Only one column to be processed (RRNO) */
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) 1, 0, pSqlda )

               InsertRRNParms.xdVal  = pG->dLastRRNO[pG->sFileNo];
               InsertRRNParms.pSqlda = pSqlda;
               InsertRRNParms.pX_Fld = pX_Fld;
               X_DBM_OP( lDummyRetcode, X_DBM_INSERT_RRN, pX_NULL, 0, &InsertRRNParms )


#ifdef X_DATABASE_ODBC
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )
#endif

               X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, pX_DBM->sCursorID, pSqlda )

               /* Always set SQLDANo back to default for fetch */
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )

               if (pG->lReturnCode != X_DBMS_INFO_OKAY)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lReturnCode;
                  return;
               }

               /* Attempt to fetch a matching row */

               X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )

               if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
                   || (pX_Ids->chFatalError == YES))
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lFetchCode;
               }

               /* If the record is no longer present */

               else if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
                  X_Issue_Message_Vec(pX_Ids,
                                      pX_Pro,
                                      pX_Fun,
                                      pX_Ids->vchStandardMessageFile,
                                      "IOM0016",
                                      pX_Fld,
                                      2,
                                      X_DBM_FilLibVecs);
               }
               /* Close the cursor associated with the prepared SELECT */

               X_DBM_OP( pG->lReturnCode, X_DBM_CLOSE_CURSOR, pX_NULL, pX_DBM->sCursorID, pX_NULL )

               if (pG->lReturnCode != X_DBMS_INFO_OKAY)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lReturnCode;
                  return;
               }

               if ((strcmp(pX_DBM->vchReturnCode,X_DBM_NO_RECORD) == 0)
                   || (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0))
                  return;

               /* If we get this far, we've had a crossed update */
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
                  X_Issue_Message_Vec(pX_Ids,
                                      pX_Pro,
                                      pX_Fun,
                                      pX_Ids->vchStandardMessageFile,
                                      "IOM0017",
                                      pX_Fld,
                                      2,
                                      X_DBM_FilLibVecs);

                  return;
               }
            } /* endif !fHasUPID */
         } /* if no rows updated */
      }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
      else                                                            %ifntv
      {                                                               %ifntv
         /* ---------------------------- */                           %ifntv
         /* Use iSeries Native IO        */                           %ifntv
         /* ---------------------------- */                           %ifntv
#ifdef X_OAM_UPID_REQUIRED                                            %ifntv
         if ( fHasUPID )                                              %ifntv
         {                                                            %ifntv
            /* Increment @@UPID before update */                      %ifntv
            pG->dThisUPID++;                                          %ifntv
            X_Vec_Set_from_Double(pX_Ids,                             %ifntv
                                  pX_Pro,                             %ifntv
                                  pX_Fun,                             %ifntv
                                  pX_Fld,                             %ifntv
                                  X_V_%@UPID,                         %ifntv
                                  pG->dThisUPID);                     %ifntv
         }                                                            %ifntv
#endif                                                                %ifntv
                                                                      %ifntv
         /* Map from OAM to record buffer */                          %ifntv
         X_DBM_OP_NATIVE_MAP(lDummyRetcode, X_DBM_MAP_OAM_TO_NATIVE_2, pG->pX_Native_Update, pG->pX_Fld, &sX_Zero) %ifntv
                                                                      %ifntv
         /* Update the record */                                      %ifntv
         X_DBM_OP_NATIVE_CONTROL(pG->lReturnCode, X_DBM_NATIVE_UPDATE_2, pG->pX_Native_Update) %ifntv
                                                                      %ifntv
         if ( X_DBMS_INFO_IS_DUPLICATE_ROW(pG->lReturnCode) )         %ifntv
         {                                                            %ifntv
            strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);     %ifntv
            X_Issue_Message_Vec(pX_Ids,                               %ifntv
                                pX_Pro,                               %ifntv
                                pX_Fun,                               %ifntv
                                pX_Ids->vchStandardMessageFile,       %ifntv
                                "IOM0025",                            %ifntv
                                pX_Fld,                               %ifntv
                                2,                                    %ifntv
                                X_DBM_FilLibVecs);                    %ifntv
                                                                      %ifntv
            X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS);               %ifntv
                                                                      %ifntv
            return;                                                   %ifntv
         }                                                            %ifntv
      }                                                               %ifntv
#endif                                                                %ifntv

      %lobupdate

      /* ------------------------------------------------- */
      /* If we get this far, we've had a successful update */
      /* ------------------------------------------------- */

      strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID )
      {
         pG->dLastUPID[pG->sFileNo] = pG->dThisUPID;
      }
#endif

      if ( fHasRRNO )
      {
         /* Return @@RRNO if requested */

         if (pX_DBM->chRetRRNO == YES)
            X_Vec_Assign(pX_Ids,
                         pX_Pro,
                         pX_Fun,
                         pX_Fld,
                         X_V_%@RRNOxxxx,
                         pX_DBM->pX_Fld,
                         pX_DBM->sRetRRNO);
      }

      /* Execute batch control logic */                              %ifbch
      X_OAM_Update_Batch_Control(X_OAM_STANDARD_PARMS,               %ifbch
                                 X_DBM_UPDATE_OPERATION);            %ifbch
      if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)      %ifbch
         return;                                                     %ifbch

      /* Issue the database COMMIT */

      if ( !(X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS)) ) return;

      /* Drop High Speed Key entries if enabled */

      if (pX_Ids->fHSKCEnabled)
         X_HSKC_Drop(pX_Ids, pX_Pro, pX_Fun, "%sqltablex");

      /* Run after update trigger */                                 %uptrig
      strcpy(pG->X_Trigger.vchOper,"AFTUPD");                        %uptrig
      %RUNFT *AFTUPD2

      return;
   }

   /* -------------------------------------------------------- */
   /* If keys are specified then build the WHERE from the keys */
   /* -------------------------------------------------------- */

   /* Check if authorised to read the file first */

   if (pG->chReadAuthChecked != YES)
   {
      pG->chAuthorised = X_Check_Authority(pX_Ids,
                                           pX_Pro,
                                           pX_Fun,
                                           "%tablexxxx",
                                           "%fulllibxx",
                                           X_OBJECT_TYPE_FILE,
                                           X_OBJECT_AUTH_READ_DATA);
      if (pG->chAuthorised == NO)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0009",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }
      else
         pG->chReadAuthChecked = YES;
   }

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* Build the required SELECT statement */

      strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
      X_OAM_Add_Table_Name(X_OAM_STANDARD_PARMS);

      /* Build WHERE according to keys passed in key field vectors */

      if (pX_DBM->scKeyFlds > 0)
         strcat(pG->vchSqlStmnt," WHERE ");

      for (i = 0; i < pX_DBM->scKeyFlds; i++)
      {
         if (i > 0) strcat(pG->vchSqlStmnt," AND ");

         %where

         strcat(pG->vchSqlStmnt," = ");

         j = pX_DBM->psKeyFlds[i];

         if ( !X_OAM_Add_Value_To_Stmnt(X_OAM_STANDARD_PARMS, j, i) )
         {
            return;
         }
      }

      /* Add any WHERE condition if it involves only "real" fields */

      if (pX_DBM->scWhere > 0)
      {
         if (i > 0)
            strcat(pG->vchSqlStmnt," AND ");
         else
            strcat(pG->vchSqlStmnt," WHERE ");
         X_OAM_Build_Where(X_OAM_STANDARD_PARMS);
         if (pX_Ids->chFatalError == YES)
         {
            strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
            return;
         }
      }

      /* Build ORDER BY according to table/index keys */

      %orderby

      /* Prepare the required SELECT statement */

      pX_Ids->chOAMRqsType = X_VARIANT_SELECT;
      pX_Ids->fX_DBM_PrepareParams = FALSE; /* Because RRN not in SQL */

      X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }

      /* --------------------- */
      /* Get appropriate SQLDA */
      /* --------------------- */
      sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
      if ( sSqlda < 0 ) return;

      /* Open the cursor associated with the prepared SELECT */

      X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, pX_DBM->sCursorID, pSqlda )

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }

      /* Attempt to fetch a matching row */

      X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use iSeries Native IO        */                              %ifntv
      /* ---------------------------- */                              %ifntv
      X_OAM_Native_Fetch_First( X_OAM_STANDARD_PARMS );               %ifntv
                                                                      %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
    || (pX_Ids->chFatalError == YES))
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lFetchCode;
      return;
   }

   /* Set the appropriate return code */

   if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
      if (pX_DBM->chMsgReqd == YES)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0005",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
      }

      /* Close the cursor associated with the prepared SELECT */

      if (pX_DBM->chWhereRDML == NO)
      {
         X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS);
      }
      return;
   }
   else
      strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* Map fields from the Sqlda structure */

      X_DBM_OP( lDummyRetcode, X_DBM_MAP_FROM_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use iSeries Native IO        */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Map from record buffer to OAM */                             %ifntv
      X_DBM_OP_NATIVE_MAP(pG->lFetchCode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Curr, pG->pX_Fld, &sX_Zero) %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   /* Execute virtual code */                                      %ifvcpjf
                                                                   %ifvcpjf
   X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_PARMS);            %ifvcpjf
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)       %ifvcpjf
   {                                                               %ifvcpjf
      return;                                                      %ifvcpjf
   }                                                               %ifvcpjf

   /* Save the @@RRNO and @@UPID */

   if ( fHasRRNO )
   {
      X_Vec_Get_as_Double(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Fld,
                          X_V_%@RRNOxxxx,
                          &(pG->dLastRRNO[pG->sFileNo]));

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID )
      {
         X_Vec_Get_as_Double(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@UPID,
                             &(pG->dLastUPID[pG->sFileNo]));
      }
#endif

      /* Return @@RRNO if requested */

      if ( pX_DBM->chRetRRNO == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      X_V_%@RRNOxxxx,
                      pX_DBM->pX_Fld,
                      pX_DBM->sRetRRNO);
   }

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( (!fHasUPID) && (X_OAM_Save_Current_Record(X_OAM_STANDARD_PARMS) != TRUE) )
   {
      return;
   }
#endif

   /* Save the before update field details */                     %uptbch
   *(pG->pX_Prev) = *(pG->pX_Curr);                               %uptbch

   /* ---------------------------------------------------- */
   /* Map the OAM field vectors to the group field vectors */
   /* if the WHERE to be evaluated in the RDML .....       */
   /* ---------------------------------------------------- */

   if (pX_DBM->chWhereRDML == YES)
   {
      for (i = 0; i < X_TOTAL_FIELDS; i++)
      {
         if (pCurr->X_DBM_FldsUsed[i] == YES)
            X_Vec_Assign(pX_Ids,
                         pX_Pro,
                         pX_Fun,
                         pX_Fld,
                         i,
                         pX_DBM->pX_Fld,
                         pCurr->X_DBM_FldsIndex[i]);
      }

      /* Reverse data if SREV used */                                 %ifsrev
      if (X_LANGUAGE_IS_RLTB)                                         %ifsrev
      {                                                               %ifsrev
         for (i = 0; i < pX_DBM->scGrpFlds; i++)                      %ifsrev
         {                                                            %ifsrev
            %srevdout
                  X_Reverse_String(pX_Ids,pX_Pro,pX_Fun,              %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].pField,   %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].sByteLen);%ifsrev
         }                                                            %ifsrev
      }                                                               %ifsrev
   }

   strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

   /* -------------------------------------------------------- */
   /* If there is no WHERE condition to be tested in the RDML  */
   /* function, then call X_OAM_Update_Next_Request repeatedly */
   /* until end of file.                                       */
   /* -------------------------------------------------------- */

   if (pX_DBM->chWhereRDML == NO)
   {
      pX_DBM->chActionRow = YES;

      while(memcmp(pX_DBM->vchReturnCode,X_DBM_OKAY,2) == 0)
      {
         X_OAM_Update_Next_Request(X_OAM_STANDARD_PARMS);
      }

      /* Reset return code if no more records */
      if (memcmp(pX_DBM->vchReturnCode,X_DBM_NO_RECORD,2) == 0)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);
      }

      X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS);
   }

   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Update_Next_Request                          */
/* Description  : UPDATE_NEXT row request                            */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Update_Next_Request(X_OAM_STANDARD_ARGS)
{
   X_SHORT sCursorID;
   X_SHORT i;
   struct X_DBM_FLDINDEX *pCurr;
   X_VCHAR  vchString[(X_MAX_UPID_FIELD_LEN * 2) + 2 + 1];
   X_LONG lRowCount;
   X_SQLDA *pUpdateSqlda;
   X_SHORT  sUpdateSqlda;
   X_SQLDA *pSelectSqlda;
   X_SHORT  sSelectSqlda;
   X_PVCHAR pvchRRNO = X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_RRN );
   X_BOOL fError;

/* Update always requires primary key or RRNO column */
#if defined(X_DBM_NO_PKEY)
   if ( !fHasRRNO )
   {
      X_Fatal_Error(pX_Ids,
                    pX_Pro,
                    pX_Fun,
                    "OAM for table %tablexxxx",
                    X_TEXT(842));
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      return;
   }
#endif

   /* ------------------------------- */
   /* Set current field index pointer */
   /* ------------------------------- */

   {
      X_Search_FldIndex (X_OAM_STANDARD_PARMS);
      pCurr = pG->pCurrFldIndex;
   }

   /* ---------------------------- */
   /* If this row is to be updated */
   /* ---------------------------- */

   if (pX_DBM->chActionRow == YES)
   {
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
      if ( pX_DBM->fUseNativeIO )                                     %ifntv
      {                                                               %ifntv
         /* ---------------------------- */                           %ifntv
         /* Use iSeries Native IO        */                           %ifntv
         /* ---------------------------- */                           %ifntv
         /* Read by relative record number */                         %ifntv
         pG->pX_Native_Update->fLock        = TRUE;                   %ifntv
         X_OAM_Native_Fetch_RRN( X_OAM_STANDARD_PARMS );              %ifntv
                                                                      %ifntv
         if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)             %ifntv
         {                                                            %ifntv
            /* iSeries compatibility issue - this is what L4iS does */ %ifntv
            strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);            %ifntv
            X_Issue_Message_Vec(pX_Ids,                               %ifntv
                                pX_Pro,                               %ifntv
                                pX_Fun,                               %ifntv
                                pX_Ids->vchStandardMessageFile,       %ifntv
                                "IOM0016",                            %ifntv
                                pX_Fld,                               %ifntv
                                2,                                    %ifntv
                                X_DBM_FilLibVecs);                    %ifntv
            return;                                                   %ifntv
         }                                                            %ifntv
         else                                                         %ifntv
         {                                                            %ifntv
            const X_BOOL fCrossedUpdateCheck = TRUE;                  %ifntv
                                                                      %ifntv
            /* Map from record buffer to OAM */                       %ifntv
            X_DBM_OP_NATIVE_MAP(pG->lFetchCode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Update, pG->pX_Fld, &sX_Zero) %ifntv
                                                                      %ifntv
            fError = FALSE;                                           %ifntv
#ifdef X_OAM_UPID_REQUIRED                                            %ifntv
            if ( fHasUPID )                                           %ifntv
            {                                                         %ifntv
               /* Determine if the @@UPID field has changed */        %ifntv
                                                                      %ifntv
               X_Vec_Get_as_Double(pX_Ids,                            %ifntv
                                   pX_Pro,                            %ifntv
                                   pX_Fun,                            %ifntv
                                   pX_Fld,                            %ifntv
                                   X_V_%@UPID,                        %ifntv
                                   &(pG->dThisUPID));                 %ifntv
               if (fCrossedUpdateCheck                                %ifntv
                && (pG->dThisUPID != pG->dLastUPID[pG->sFileNo])) fError = TRUE; %ifntv
            }                                                         %ifntv
#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED                                %ifntv
            else                                                      %ifntv
            {                                                         %ifntv
#endif                                                                %ifntv
#endif                                                                %ifntv
#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED                                %ifntv
            if ( fCrossedUpdateCheck )                                %ifntv
            {                                                         %ifntv
               /* Compare fields to see if any have changed */        %ifntv
               if (X_OAM_Compare_Current_Record(X_OAM_STANDARD_PARMS))  fError = TRUE; %ifntv
            }                                                         %ifntv
#ifdef X_OAM_UPID_REQUIRED                                            %ifntv
            } /* else */                                              %ifntv
#endif                                                                %ifntv
#endif                                                                %ifntv
            if ( fError )                                             %ifntv
            {                                                         %ifntv
               strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);  %ifntv
               X_Issue_Message_Vec(pX_Ids,                            %ifntv
                                   pX_Pro,                            %ifntv
                                   pX_Fun,                            %ifntv
                                   pX_Ids->vchStandardMessageFile,    %ifntv
                                   "IOM0017",                         %ifntv
                                   pX_Fld,                            %ifntv
                                   2,                                 %ifntv
                                   X_DBM_FilLibVecs);                 %ifntv
                                                                      %ifntv
               /* Unlock the record */                                %ifntv
               X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update) %ifntv
               return;                                                %ifntv
            }                                                         %ifntv
         }                                                            %ifntv
      }                                                               %ifntv
#endif                                                                %ifntv

      /* Update the last row read using the last @@RRNO or PKEY read */

      /* Map the group field vectors to the OAM field vectors */

      for (i = 0; i < X_TOTAL_FIELDS; i++)
      {
         if (pCurr->X_DBM_FldsUsed[i] == YES)
            X_Vec_Assign(pX_Ids,
                         pX_Pro,
                         pX_Fun,
                         pX_DBM->pX_Fld,
                         pCurr->X_DBM_FldsIndex[i],
                         pX_Fld,
                         i);
      }

      /* Reverse data if SREV used */                                 %ifsrev
      if (X_LANGUAGE_IS_RLTB)                                         %ifsrev
      {                                                               %ifsrev
         %srevdin
      }                                                               %ifsrev

      /* Set date/time stamps */                                    %ifstmp
                                                                    %ifstmp
      X_OAM_Stamp_Attributes(X_OAM_STANDARD_PARMS,                  %ifstmp
                             X_DBM_UPDATE_OPERATION);               %ifstmp
                                                                    %ifstmp
      /* Execute virtual code */                                    %ifvc
                                                                    %ifvc
      X_OAM_Virtual_Code_Before_Write(X_OAM_STANDARD_PARMS);        %ifvc

      {
         /* Perform all update validation checks */

         X_OAM_Validation_Checks(X_OAM_STANDARD_PARMS,
                                 X_DBM_UPDATE_OPERATION);
         if (strcmp(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR) == 0)
         {
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
            if ( pX_DBM->fUseNativeIO )                               %ifntv
            {                                                         %ifntv
               /* ---------------------------- */                     %ifntv
               /* Use iSeries Native IO        */                     %ifntv
               /* ---------------------------- */                     %ifntv
               /* Unlock the record */                                %ifntv
               X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update) %ifntv
            }                                                         %ifntv
#endif                                                                %ifntv
            return;
         }

         /* Run before update trigger */                                %uptrig
         strcpy(pG->X_Trigger.vchOper,"BEFUPD");                        %uptrig
         %RUNFT *BEFUPD2
      }

      /* If only validation checks to be performed then don't update */

      if (pX_DBM->chValOnly == YES)
      {
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
         if ( pX_DBM->fUseNativeIO )                                  %ifntv
         {                                                            %ifntv
            /* ---------------------------- */                        %ifntv
            /* Use iSeries Native IO        */                        %ifntv
            /* ---------------------------- */                        %ifntv
            /* Unlock the record */                                   %ifntv
            X_DBM_OP_NATIVE_CONTROL_UNLOCK(pG->lFetchCode, pG->pX_Native_Update) %ifntv
         }                                                            %ifntv
#endif                                                                %ifntv
         strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);
      }
      else
      {

         if ( !X_DBM_IS_USING_NATIVE_IO )
         {
            /* ---------------------------- */
            /* Use ODBC / ORACLE / SQLCLI   */
            /* ---------------------------- */
            /* Build the required UPDATE statement using RRNO */

            strcpy(pG->vchSqlStmnt,X_DBM_UpdateFlds);

            if ( fHasRRNO )
            {
#ifdef X_DATABASE_ORACLE
               sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt)," WHERE %s = :0", pvchRRNO );
#else
               sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt)," WHERE %s = ?", pvchRRNO );
#endif
#ifdef X_OAM_UPID_REQUIRED
               if ( fHasUPID )
               {
                  /* Append the UPID */
                  X_Set_Vchar_from_Double(pX_Ids,pX_Pro,pX_Fun,pG->dLastUPID[pG->sFileNo],
                                          vchString,sizeof(vchString),X_L_X_UPID,X_D_X_UPID);

                  sprintf(pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),
                          " AND %s = %s",X_DBM_UPIDNativeName,vchString);
                  pX_Ids->chOAMRqsType = X_VARIANT_UPDATE;
               }
               else
#endif
               {
                  pX_Ids->chOAMRqsType = X_INVARIANT_UPDATE;
               }
            }
#ifdef X_OAM_REPLACE_RRN_WITH_PKEY_REQUIRED
            else
            {
               /* Append where clause of primary key from last record read                */
               /* Note there is a small window btn previous read and this delete where    */
               /* an update may have occurred (as we don't specify all fields on file in  */
               /* the where clause -- the equivalent of specify X_UPID in where clause)   */

               X_OAM_Build_Primary_Key_Where(X_OAM_STANDARD_PARMS,TRUE,FALSE,TRUE);
               if (pX_Ids->chFatalError == YES)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  return;
               }
               pX_Ids->chOAMRqsType = X_VARIANT_UPDATE;
            }
#endif

            /* Prepare the required UPDATE statement */

            AVOID_JOURNALING(pG->vchSqlStmnt)                        %ifncmt

            X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &sCursorID )

            if (pG->lReturnCode != X_DBMS_INFO_OKAY)
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
               pX_Ids->lLastErrorCode = pG->lReturnCode;
               return;
            }

#ifdef X_OAM_UPID_REQUIRED
            if ( fHasUPID )
            {
               /* Increment @@UPID before update */

               pG->dLastUPID[pG->sFileNo]++;
               X_Vec_Set_from_Double(pX_Ids,
                                     pX_Pro,
                                     pX_Fun,
                                     pX_Fld,
                                     X_V_%@UPID,
                                     pG->dLastUPID[pG->sFileNo]);
            }
#endif
            /* --------------------- */
            /* Get appropriate SQLDA */
            /* --------------------- */
            sUpdateSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pUpdateSqlda,X_SQLDA_UPDATE,TRUE);

            if ( sUpdateSqlda < 0 ) return;

            /* ------------------------------------------------------ */
            /* Map fields to the Sqlda structure before actual update */
            /* ------------------------------------------------------ */

            if ( fIdentity )
            {
               /* Skip mapping the first field (RRNO) */
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) ( X_TOTAL_REAL_NON_LOB_FIELDS - 1 ), 0, pUpdateSqlda )

               X_DBM_OP( lDummyRetcode, X_DBM_MAP_TO_TABLE_NO_RRNO, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pUpdateSqlda )
            }
            else if ( fAutoRRN )
            {
               /* Skip mapping the first field (RRNO) */
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) ( X_TOTAL_REAL_NON_LOB_FIELDS - (fHasUPID ? 1 : 2) ), 0, pUpdateSqlda )

               X_DBM_OP( lDummyRetcode, X_DBM_MAP_TO_TABLE_NO_RRNO, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pUpdateSqlda )
            }
            else
            {
               /* All columns are used as this is an UPDATE WHERE @@RRNO = ? */
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_TOTAL_REAL_NON_LOB_FIELDS, 0, pUpdateSqlda )

               X_DBM_OP( lDummyRetcode, X_DBM_MAP_TO_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pUpdateSqlda )
            }

            /* Execute the prepared UPDATE statement */

            X_DBM_OP( pG->lReturnCode, X_DBM_EXECUTE_ROWCOUNT, (X_PVCHAR) (&lRowCount), sCursorID, pUpdateSqlda )

            if ( X_DBMS_INFO_IS_DUPLICATE_ROW(pG->lReturnCode) )
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
               X_Issue_Message_Vec(pX_Ids,
                                   pX_Pro,
                                   pX_Fun,
                                   pX_Ids->vchStandardMessageFile,
                                   "IOM0025",
                                   pX_Fld,
                                   2,
                                   X_DBM_FilLibVecs);

               X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS);

               return;
            }

            if (pG->lReturnCode != X_DBMS_INFO_OKAY)
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
               pX_Ids->lLastErrorCode = pG->lReturnCode;
               return;
            }

            /* If no rows updated, determine whether row deleted or updated */
            /* This processing is not necessary where updating without UPID */
            /* as there is no crossed update checking and missing rows are ok */
#ifdef X_OAM_UPID_REQUIRED
            if ( fHasUPID && lRowCount < 1)
            {
               X_SHORT sCursorID2;

               /* Build the required SELECT statement using the RRNO */

               strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
#ifdef X_DATABASE_ORACLE
               sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = :0", X_DBM_SqlTableName, pvchRRNO );
#else
               sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = ?", X_DBM_SqlTableName, pvchRRNO );
#endif

               /* Prepare the required SELECT statement */

               pX_Ids->chOAMRqsType = X_INVARIANT_SELECT;

               X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &sCursorID2 )

               if (pG->lReturnCode != X_DBMS_INFO_OKAY)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lReturnCode;
                  return;
               }

               /* --------------------- */
               /* Get appropriate SQLDA */
               /* --------------------- */
               sSelectSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSelectSqlda,X_SQLDA_SEL_DEL,FALSE);
               if ( sSelectSqlda < 0 ) return;

               /* Open the cursor associated with the prepared SELECT */

               /* Only one column to be processed (RRNO) */
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) 1, 0, pSelectSqlda )

               InsertRRNParms.xdVal  = pG->dLastRRNO[pG->sFileNo];
               InsertRRNParms.pSqlda = pSelectSqlda;
               InsertRRNParms.pX_Fld = pX_Fld;
               X_DBM_OP( lDummyRetcode, X_DBM_INSERT_RRN, pX_NULL, 0, &InsertRRNParms )

#ifdef X_DATABASE_ODBC
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSelectSqlda )
#endif

               X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, sCursorID2, pSelectSqlda )

               /* Always set SQLDANo back to default for fetch */
               X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSelectSqlda )

               if (pG->lReturnCode != X_DBMS_INFO_OKAY)
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lReturnCode;
                  return;
               }

               /* Attempt to fetch a matching row */

               X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, sCursorID2, pSelectSqlda )

               /* Close the cursor associated with the prepared SELECT */

               X_DBM_OP( pG->lReturnCode, X_DBM_CLOSE_CURSOR, pX_NULL, sCursorID2, pX_NULL )

               if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
                   || (pG->lReturnCode < X_DBMS_INFO_OKAY)
                   || (pX_Ids->chFatalError == YES))
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
                  pX_Ids->lLastErrorCode = pG->lFetchCode;
                  return;
               }

               /* If the record is no longer present */

               else if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
               {
                  /* Do not cause an error, simply move to next record */
                  pG->lReturnCode = X_DBMS_INFO_OKAY;
                }

               /* If we get this far, we've had a crossed update */

               else
               {
                  strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
                  X_Issue_Message_Vec(pX_Ids,
                                      pX_Pro,
                                      pX_Fun,
                                      pX_Ids->vchStandardMessageFile,
                                      "IOM0017",
                                      pX_Fld,
                                      2,
                                      X_DBM_FilLibVecs);
                  return;
               }
            } /* if no rows updated */
#endif /* X_OAM_UPID_REQURIRED */
         }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
         else                                                         %ifntv
         {                                                            %ifntv
            /* ---------------------------- */                        %ifntv
            /* Use iSeries Native IO        */                        %ifntv
            /* ---------------------------- */                        %ifntv
#ifdef X_OAM_UPID_REQUIRED                                            %ifntv
            if ( fHasUPID )                                           %ifntv
            {                                                         %ifntv
               /* Increment @@UPID before update */                   %ifntv
                                                                      %ifntv
               pG->dLastUPID[pG->sFileNo]++;                          %ifntv
               X_Vec_Set_from_Double(pX_Ids,                          %ifntv
                                     pX_Pro,                          %ifntv
                                     pX_Fun,                          %ifntv
                                     pX_Fld,                          %ifntv
                                     X_V_%@UPID,                      %ifntv
                                     pG->dLastUPID[pG->sFileNo]);     %ifntv
            }                                                         %ifntv
#endif                                                                %ifntv
            /* Map from OAM to record buffer */                       %ifntv
            X_DBM_OP_NATIVE_MAP(pG->lFetchCode, X_DBM_MAP_OAM_TO_NATIVE_2, pG->pX_Native_Update, pG->pX_Fld, &sX_Zero) %ifntv
            /* Update the record */                                   %ifntv
            X_DBM_OP_NATIVE_CONTROL(pG->lReturnCode, X_DBM_NATIVE_UPDATE_2, pG->pX_Native_Update) %ifntv
                                                                      %ifntv
            if ( X_DBMS_INFO_IS_DUPLICATE_ROW(pG->lReturnCode) )      %ifntv
            {                                                         %ifntv
               strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);  %ifntv
               X_Issue_Message_Vec(pX_Ids,                            %ifntv
                                   pX_Pro,                            %ifntv
                                   pX_Fun,                            %ifntv
                                   pX_Ids->vchStandardMessageFile,    %ifntv
                                   "IOM0025",                         %ifntv
                                   pX_Fld,                            %ifntv
                                   2,                                 %ifntv
                                   X_DBM_FilLibVecs);                 %ifntv
                                                                      %ifntv
               X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS);            %ifntv
                                                                      %ifntv
               return;                                                %ifntv
            }                                                         %ifntv
         }                                                            %ifntv
#endif                                                                %ifntv

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return;
      }

      /* Setup pG->dThisUPID correctly */
      pG->dThisUPID = pG->dLastUPID[pG->sFileNo];       %iflob
      %lobupdatenext

      /* ------------------------------------------------- */
      /* If we get this far, we've had a successful update */
      /* ------------------------------------------------- */

      strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

      /* Execute batch control logic */                              %ifbch
      X_OAM_Update_Batch_Control(X_OAM_STANDARD_PARMS,               %ifbch
                                 X_DBM_UPDATE_OPERATION);            %ifbch
      if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)      %ifbch
         return;                                                     %ifbch

      /* Issue the database COMMIT */

      if ( !(X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS)) ) return;

      /* Drop High Speed Key entries if enabled */

      if (pX_Ids->fHSKCEnabled)
         X_HSKC_Drop(pX_Ids, pX_Pro, pX_Fun, "%sqltablex");

      /* Run after update trigger */                                 %uptrig
      strcpy(pG->X_Trigger.vchOper,"AFTUPD");                        %uptrig
      %RUNFT *AFTUPD2
      }
   }

   /* ----------------------------------------------------- */
   /* FETCH the next row using the cursor previously opened */
   /* ----------------------------------------------------- */

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */

      /* --------------------- */
      /* Get appropriate SQLDA */
      /* --------------------- */
      sSelectSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSelectSqlda,X_SQLDA_SEL_DEL,TRUE);
      if ( sSelectSqlda < 0 ) return;

      /* Attempt to fetch a matching row */

      X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSelectSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use iSeries Native IO        */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Read next record   */                                        %ifntv
      X_OAM_Native_Fetch_Next( X_OAM_STANDARD_PARMS );                %ifntv
                                                                      %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
    || (pX_Ids->chFatalError == YES))
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lFetchCode;
      return;
   }

   /* Set the appropriate return code */

   if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
      return;
   }

   strcpy(pX_DBM->vchReturnCode,X_DBM_OKAY);

   if ( !X_DBM_IS_USING_NATIVE_IO )
   {
      /* ---------------------------- */
      /* Use ODBC / ORACLE / SQLCLI   */
      /* ---------------------------- */
      /* Map fields from the Sqlda structure */

      X_DBM_OP( lDummyRetcode, X_DBM_MAP_FROM_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSelectSqlda )
   }
#if defined(X_OPERATING_SYSTEM_ISERIES)                               %ifntv
   else                                                               %ifntv
   {                                                                  %ifntv
      /* ---------------------------- */                              %ifntv
      /* Use iSeries Native IO        */                              %ifntv
      /* ---------------------------- */                              %ifntv
      /* Map from record buffer to OAM */                             %ifntv
      X_DBM_OP_NATIVE_MAP(pG->lFetchCode, X_DBM_MAP_NATIVE_TO_OAM_2, pG->pX_Native_Curr, pG->pX_Fld, &sX_Zero) %ifntv
   }                                                                  %ifntv
#endif                                                                %ifntv

   /* Execute virtual code */                                        %ifvcpjf
                                                                     %ifvcpjf
   X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_PARMS);              %ifvcpjf
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)         %ifvcpjf
      return;                                                        %ifvcpjf

   /* Save the @@RRNO and @@UPID */

   if ( fHasRRNO )
   {
      X_Vec_Get_as_Double(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Fld,
                          X_V_%@RRNOxxxx,
                          &(pG->dLastRRNO[pG->sFileNo]));

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID )
      {
         X_Vec_Get_as_Double(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@UPID,
                             &(pG->dLastUPID[pG->sFileNo]));
      }
#endif

      /* Return @@RRNO if requested */

      if ( pX_DBM->chRetRRNO == YES)
         X_Vec_Assign(pX_Ids,
                      pX_Pro,
                      pX_Fun,
                      pX_Fld,
                      X_V_%@RRNOxxxx,
                      pX_DBM->pX_Fld,
                      pX_DBM->sRetRRNO);
   }

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( (!fHasUPID) && (X_OAM_Save_Current_Record(X_OAM_STANDARD_PARMS) != TRUE) )
   {
      return;
   }
#endif

   /* Save the before update field details */                     %uptbch
   *(pG->pX_Prev) = *(pG->pX_Curr);                               %uptbch

   /* ---------------------------------------------------- */
   /* Map the OAM field vectors to the group field vectors */
   /* if the WHERE to be evaluated in the RDML .....       */
   /* ---------------------------------------------------- */

   if (pX_DBM->chWhereRDML == YES)
   {
      for (i = 0; i < X_TOTAL_FIELDS; i++)
      {
         if (pCurr->X_DBM_FldsUsed[i] == YES)
            X_Vec_Assign(pX_Ids,
                         pX_Pro,
                         pX_Fun,
                         pX_Fld,
                         i,
                         pX_DBM->pX_Fld,
                         pCurr->X_DBM_FldsIndex[i]);
      }

      /* Reverse data if SREV used */                                 %ifsrev
      if (X_LANGUAGE_IS_RLTB)                                         %ifsrev
      {                                                               %ifsrev
         for (i = 0; i < pX_DBM->scGrpFlds; i++)                      %ifsrev
         {                                                            %ifsrev
            %srevdout
                  X_Reverse_String(pX_Ids,pX_Pro,pX_Fun,              %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].pField,   %ifsrev
                       pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].sByteLen);%ifsrev
         }                                                            %ifsrev
      }                                                               %ifsrev

   }

   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_EVALUATE)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Validation_Checks                            */
/* Description  : Perform all the dictionary and file level          */
/*                validation checks.                                 */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                chType       - type of operation (A/U/D)           */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Validation_Checks(X_OAM_STANDARD_ARGS,
                                        X_TYPE_FLAG   chType)
{

   X_YES_NO chError  = NO;
   X_CHAR   chAction = NO;
   struct X_DBM_FLDINDEX *pCurr = pG->pCurrFldIndex;
   X_VCHAR vchField[X_OBJECT_NAME_LEN + 1];                            %iflob
   X_PVCHAR avchParms[4];                                              %iflob

   /* ------------------------------------------------------- */
   /* Perform any dictionary and file level validation checks */
   /* ------------------------------------------------------- */

   %check

   /* If any validation errors issue message */

   if (chError == YES)
   {
      if (pX_DBM->chMsgReqd == YES)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0030",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
      }
      strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
   }

   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_EXECUTE)))%ifatrg
/* ================================================================= */%ifatrg
/*                                                                   */%ifatrg
/* Function     : X_OAM_Test_Trigger_Return                          */%ifatrg
/* Description  : This function will test the return code            */%ifatrg
/*                from a trigger function.                           */%ifatrg
/*                                                                   */%ifatrg
/* Arguments    : pX_Ids       - standard system def. structure      */%ifatrg
/*                pX_Pro       - standard process defn. structure    */%ifatrg
/*                pX_Fun       - standard function defn. structure   */%ifatrg
/*                pX_Fld       - standard field defn. structure      */%ifatrg
/*                pX_DBM       - standard DBM defn. structure        */%ifatrg
/*                pG           - standard global info. structure     */%ifatrg
/*                pvchTrigFun  - trigger function name               */%ifatrg
/*                                                                   */%ifatrg
/* ================================================================= */%ifatrg
                                                                      %ifatrg
O_VOID_FUNCTION X_OAM_Test_Trigger_Return(X_OAM_STANDARD_ARGS,        %ifatrg
                                          X_PVCHAR pvchTrigFun)       %ifatrg
{                                                                     %ifatrg
                                                                      %ifatrg
                                                                      %ifatrg
   /* ----------------------------------------------------------- */  %ifatrg
   /* If the trigger ended with an error then set the return code */  %ifatrg
   /* accordingly ......                                          */  %ifatrg
   /* ----------------------------------------------------------- */  %ifatrg
                                                                      %ifatrg
   if (pX_Ids->chFatalError == 'Y')                                   %ifatrg
   {                                                                  %ifatrg
      X_VCHAR vchTriggerFunction[X_FUNCTION_NAME_LEN+1];              %ifatrg
                                                                      %ifatrg
      strcpy(vchTriggerFunction,pvchTrigFun);                         %ifatrg
      X_FUNRTR_Locate(pX_Ids,                                         %ifatrg
                      pX_Pro,                                         %ifatrg
                      pX_Fun,                                         %ifatrg
                      vchTriggerFunction,                             %ifatrg
                      vchTriggerFunction);                            %ifatrg
      X_Issue_Message_VChar(pX_Ids,                                   %ifatrg
                            pX_Pro,                                   %ifatrg
                            pX_Fun,                                   %ifatrg
                            pX_Ids->vchStandardMessageFile,           %ifatrg
                            "IOM0038",                                %ifatrg
                            vchTriggerFunction);                      %ifatrg
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);                %ifatrg
      return;                                                         %ifatrg
   }                                                                  %ifatrg
                                                                      %ifatrg
   if (strcmp(pG->X_Trigger.vchRetc,X_DBM_OKAY) != 0)                 %ifatrg
   {                                                                  %ifatrg
      if (((strcmp(pG->X_Trigger.vchOper,"BEFINS") == 0)              %ifatrg
        || (strcmp(pG->X_Trigger.vchOper,"BEFUPD") == 0)              %ifatrg
        || (strcmp(pG->X_Trigger.vchOper,"BEFDLT") == 0))             %ifatrg
       && (strcmp(pG->X_Trigger.vchRetc,X_DBM_VALIDATION_ERROR) == 0))%ifatrg
      {                                                               %ifatrg
         strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);        %ifatrg
      }                                                               %ifatrg
      else                                                            %ifatrg
      {                                                               %ifatrg
         X_VCHAR vchTriggerFunction[X_FUNCTION_NAME_LEN+1];           %ifatrg
                                                                      %ifatrg
         strcpy(vchTriggerFunction,pvchTrigFun);                      %ifatrg
         X_FUNRTR_Locate(pX_Ids,                                      %ifatrg
                         pX_Pro,                                      %ifatrg
                         pX_Fun,                                      %ifatrg
                         vchTriggerFunction,                          %ifatrg
                         vchTriggerFunction);                         %ifatrg
         X_Issue_Message_VChar(pX_Ids,                                %ifatrg
                               pX_Pro,                                %ifatrg
                               pX_Fun,                                %ifatrg
                               pX_Ids->vchStandardMessageFile,        %ifatrg
                               "IOM0038",                             %ifatrg
                               vchTriggerFunction);                   %ifatrg
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);             %ifatrg
      }                                                               %ifatrg
   }                                                                  %ifatrg
                                                                      %ifatrg
   return;                                                            %ifatrg
}                                                                     %ifatrg
                                                                      %ifatrg
#endif                                                                %ifatrg
                                                                      %ifatrg
                                                                      %ifatrg
#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_EXECUTE)))%rdtrig
/* ================================================================= */%rdtrig
/*                                                                   */%rdtrig
/* Function     : X_OAM_Read_Triggers                                */%rdtrig
/* Description  : This function will perform before & after          */%rdtrig
/*                read triggers.                                     */%rdtrig
/*                                                                   */%rdtrig
/* Arguments    : pX_Ids       - standard system def. structure      */%rdtrig
/*                pX_Pro       - standard process defn. structure    */%rdtrig
/*                pX_Fun       - standard function defn. structure   */%rdtrig
/*                pX_Fld       - standard field defn. structure      */%rdtrig
/*                pX_DBM       - standard DBM defn. structure        */%rdtrig
/*                pG           - standard global info. structure     */%rdtrig
/*                                                                   */%rdtrig
/* ================================================================= */%rdtrig
                                                                      %rdtrig
O_VOID_FUNCTION X_OAM_Read_Triggers(X_OAM_STANDARD_ARGS)              %rdtrig
{                                                                     %rdtrig                                                                      %ifatrg
                                                                      %rdtrig
   if (strcmp(pG->X_Trigger.vchOper,"BEFRED") == 0)                   %rdtrig
   {                                                                  %rdtrig
      %RUNFT *BEFRED0
   }                                                                  %rdtrig
   else                                                               %rdtrig
   {                                                                  %rdtrig
      %RUNFT *AFTRED1
   }                                                                  %rdtrig
                                                                      %rdtrig
   return;                                                            %rdtrig
}                                                                     %rdtrig
                                                                      %rdtrig
#endif                                                                %rdtrig
                                                                      %rdtrig
                                                                      %rdtrig
#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_EXECUTE)))%ifvcpjf
/* ================================================================= */%ifvcpjf
/*                                                                   */%ifvcpjf
/* Function     : X_OAM_Virtual_Code_After_Read                      */%ifvcpjf
/* Description  : Execute virtual code after reading "real" fields   */%ifvcpjf
/*                from the table.                                    */%ifvcpjf
/*                                                                   */%ifvcpjf
/* Arguments    : pX_Ids       - standard system def. structure      */%ifvcpjf
/*                pX_Pro       - standard process defn. structure    */%ifvcpjf
/*                pX_Fun       - standard function defn. structure   */%ifvcpjf
/*                pX_Fld       - standard field defn. structure      */%ifvcpjf
/*                pX_DBM       - standard DBM defn. structure        */%ifvcpjf
/*                pG           - standard global info. structure     */%ifvcpjf
/*                                                                   */%ifvcpjf
/* ================================================================= */%ifvcpjf
                                                                       %ifvcpjf
O_VOID_FUNCTION X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_ARGS)     %ifvcpjf
{                                                                      %ifvcpjf
                                                                       %ifvcpjf
   X_VCHAR  vchPJF_Column_Function[55+1];                              %ifpjf
   X_SHORT  sPJF_Col_Fun_Tgt_Vec[1];                                   %ifpjf
#if defined(X_OPERATING_SYSTEM_ISERIES)                                %ifpjf
   X_SHORT  sPJF_Col_Fun_Src_Vec[1];                                   %ifpjf
#endif                                                                 %ifpjf
   X_CHAR   chAction;                                                  %ifpjf
   X_YES_NO chReturn;                                                  %ifpjf
   X_USHORT i;                                                         %ifpjf
   X_USHORT j;                                                         %ifpjf
   X_USHORT p;                                                         %ifpjf
   X_PDICTIONARY_FIELD pField;                                         %ifpjf
   X_YES_NO chUsed;                                                    %ifpjf
   struct X_DBM_FLDINDEX *pCurr = pG->pCurrFldIndex;                   %ifpjf
                                                                       %ifpjf
   X_VCHAR  vchWorkDate[8+1];                                          %ifvc
   X_VCHAR  vchWorkDate2[8+1];                                         %ifvc
   X_SHORT  sWorkLen;                                                  %ifvc
                                                                       %ifvc
   /* -------------------------------------------------------- */      %ifpjf
   /* Check if authorised to read the file                     */      %ifpjf
   /* -------------------------------------------------------- */      %ifpjf
   %pjfaut
                                                                       %ifpjf
   /* -------------------------------------------------------- */      %ifpjf
   /* Before Virtuals Predetermined Join Field Derivation Code */      %ifpjf
   /* -------------------------------------------------------- */      %ifpjf
   %pjfbef
                                                                       %ifvc
   /* ------------------------------------------------------- */       %ifvc
   /* Execute the code to derive "virtual" from "real" fields.*/       %ifvc
   /* ------------------------------------------------------- */       %ifvc
   %vcainp
                                                                       %ifpjf
   /* -------------------------------------------------------- */      %ifpjf
   /* After Virtuals Predetermined Join Field Derivation Code  */      %ifpjf
   /* -------------------------------------------------------- */      %ifpjf
   %pjfaft
                                                                       %ifvcpjf
   return;                                                             %ifvcpjf
}                                                                      %ifvcpjf
                                                                       %ifvcpjf
#endif                                                                 %ifvcpjf
                                                                       %ifvc
                                                                       %ifvc
#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_EXECUTE)))%ifvc
/* ================================================================= */%ifvc
/*                                                                   */%ifvc
/* Function     : X_OAM_Virtual_Code_Before_Write                    */%ifvc
/* Description  : Execute virtual code before writing "real" fields  */%ifvc
/*                to the table.                                      */%ifvc
/*                                                                   */%ifvc
/* Arguments    : pX_Ids       - standard system def. structure      */%ifvc
/*                pX_Pro       - standard process defn. structure    */%ifvc
/*                pX_Fun       - standard function defn. structure   */%ifvc
/*                pX_Fld       - standard field defn. structure      */%ifvc
/*                pX_DBM       - standard DBM defn. structure        */%ifvc
/*                pG           - standard global info. structure     */%ifvc
/*                                                                   */%ifvc
/* ================================================================= */%ifvc
                                                                       %ifvc
O_VOID_FUNCTION X_OAM_Virtual_Code_Before_Write(X_OAM_STANDARD_ARGS)   %ifvc
{                                                                      %ifvc
                                                                       %ifvc
   X_VCHAR vchWorkDate[8+1];                                           %ifvc
   X_VCHAR vchWorkDate2[8+1];                                          %ifvc
   X_SHORT sWorkLen;                                                   %ifvc
                                                                       %ifvc
   /* ------------------------------------------------------- */       %ifvc
   /* Execute the code to derive "real" from "virtual" fields */       %ifvc
   /* ------------------------------------------------------- */       %ifvc
                                                                       %ifvc
   %vcbout
                                                                       %ifvc
   return;                                                             %ifvc
}                                                                      %ifvc
                                                                       %ifvc
#endif                                                                 %ifvc
                                                                       %ifvc
                                                                       %ifvc
#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_EXECUTE)))%ifstmp
/* ================================================================= */%ifstmp
/*                                                                   */%ifstmp
/* Function     : X_OAM_Stamp_Attributes                             */%ifstmp
/* Description  : Automatically "stamp" certain fields during INSERT */%ifstmp
/*                or UPDATE operations.                              */%ifstmp
/*                                                                   */%ifstmp
/* Arguments    : pX_Ids       - standard system def. structure      */%ifstmp
/*                pX_Pro       - standard process defn. structure    */%ifstmp
/*                pX_Fun       - standard function defn. structure   */%ifstmp
/*                pX_Fld       - standard field defn. structure      */%ifstmp
/*                pX_DBM       - standard DBM defn. structure        */%ifstmp
/*                pG           - standard global info. structure     */%ifstmp
/*                chType       - type of operation (A/U)             */%ifstmp
/*                                                                   */%ifstmp
/* ================================================================= */%ifstmp
                                                                       %ifstmp
O_VOID_FUNCTION X_OAM_Stamp_Attributes(X_OAM_STANDARD_ARGS,            %ifstmp
                                       X_TYPE_FLAG   chType)           %ifstmp
{                                                                      %ifstmp
                                                                       %ifstmp
   /* --------------------------------------------- */                 %ifstmp
   /* "Stamp" fields for INSERT or UPDATE operation */                 %ifstmp
   /* --------------------------------------------- */                 %ifstmp
                                                                       %ifstmp
   %stamp
                                                                       %ifstmp
   return;                                                             %ifstmp
}                                                                      %ifstmp
                                                                       %ifstmp
#endif                                                                 %ifstmp
                                                                       %ifstmp
                                                                       %ifstmp
#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_COMMON)))%ifbch
/* ================================================================= */ %ifbch
/*                                                                   */ %ifbch
/* Function     : X_OAM_Update_Batch_Control                         */ %ifbch
/* Description  : Update details of a file under batch control.      */ %ifbch
/*                                                                   */ %ifbch
/* Arguments    : pX_Ids       - standard system def. structure      */ %ifbch
/*                pX_Pro       - standard process defn. structure    */ %ifbch
/*                pX_Fun       - standard function defn. structure   */ %ifbch
/*                pX_Fld       - standard field defn. structure      */ %ifbch
/*                pX_DBM       - standard DBM defn. structure        */ %ifbch
/*                pG           - standard global info. structure     */ %ifbch
/*                chType       - type of operation (A/U/D)           */ %ifbch
/*                                                                   */ %ifbch
/* ================================================================= */ %ifbch
                                                                        %ifbch
O_VOID_FUNCTION X_OAM_Update_Batch_Control(X_OAM_STANDARD_ARGS,         %ifbch
                                           X_TYPE_FLAG   chType)        %ifbch
{                                                                       %ifbch
                                                                        %ifbch
   X_CHAR   chActiveIOMUpdateConnection;                                %ifbch
   X_YES_NO chFirstBatch = YES;                                         %ifbch
   X_YES_NO chAction = YES;                                             %ifbch
   X_CHAR   chOperType = chType;                                        %ifbch
                                                                        %ifbch
   /* ---------- */                                                     %ifbch
   /* Initialize */                                                     %ifbch
   /* ---------- */                                                     %ifbch
                                                                        %ifbch
   chActiveIOMUpdateConnection = pX_Ids->chActiveIOMUpdateConnection;   %ifbch
                                                                        %ifbch
   if ( !X_DBM_IS_USING_NATIVE_IO )                                     %ifbch
   {                                                                    %ifbch
      %BchAll
   }                                                                    %ifbch
                                                                        %ifbch
   /* -------------------------------------------------- */             %ifbch
   /* If this is a system application table, change type */             %ifbch
   /* -------------------------------------------------- */             %ifbch
                                                                        %ifbch
   if ( pX_DBM->chSystem == YES )                                       %ifbch
   {                                                                    %ifbch
      switch ( chType )                                                 %ifbch
      {                                                                 %ifbch
         case X_DBM_INSERT_OPERATION:                                   %ifbch
            chType = X_DBM_INSERT_SYSRRN_OPERATION;                     %ifbch
            break;                                                      %ifbch
         case X_DBM_UPDATE_OPERATION:                                   %ifbch
            chType = X_DBM_UPDATE_SYSRRN_OPERATION;                     %ifbch
            break;                                                      %ifbch
      }                                                                 %ifbch
   }                                                                    %ifbch
                                                                        %ifbch
   /* ------------------------------------- */                          %ifbch
   /* Update the batch control file details */                          %ifbch
   /* ------------------------------------- */                          %ifbch
                                                                        %ifbch
   %UPDTB
                                                                        %ifbch
   if (chAction == NO) strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR); %ifbch
                                                                        %ifbch
   /* ---------- */                                                     %ifbch
   /* Terminate  */                                                     %ifbch
   /* ---------- */                                                     %ifbch
                                                                        %ifbch
   pX_Ids->chActiveIOMUpdateConnection = chActiveIOMUpdateConnection;   %ifbch
                                                                        %ifbch
   return;                                                              %ifbch
}                                                                       %ifbch
                                                                        %ifbch
#endif                                                                  %ifbch
                                                                        %ifbch

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_EXECUTE)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Set_Defaults                                 */
/* Description  : Set field default values.                          */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Set_Defaults(X_OAM_STANDARD_ARGS)
{

   struct X_DBM_FLDINDEX *pCurr = pG->pCurrFldIndex;

   %deflt

   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_COMMON)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Build_Where                                  */
/* Description  : Build an SQL WHERE condition.                      */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Build_Where(X_OAM_STANDARD_ARGS)
{

   X_SHORT  sStringLength;
   X_PVCHAR pvchString;
   X_ULONG  ulRetLen;
   X_VCHAR  vchSQLName[X_VARIABLE_NAME_LEN+1];
   X_SHORT  i;
   X_SHORT  j;
   X_SHORT  k;
   X_SHORT  sNameVec;                                                 %ifdtts
   X_VCHAR  vchFormat[2 + 1] = X_ENCODE_FORMAT_SQL_WITH_SUTC; /* Default - could be any format */

   strcat(pG->vchSqlStmnt,"(");

   for (i = 0; i < pX_DBM->scWhere; i++)
   {
      switch(pX_DBM->pWhere[i].chOper)
      {
         case X_DBM_WHERE_OB:
            strcat(pG->vchSqlStmnt,"(");
            break;
         case X_DBM_WHERE_CB:
            strcat(pG->vchSqlStmnt,")");
            break;
         case X_DBM_WHERE_AD:
            strcat(pG->vchSqlStmnt," + ");
            break;
         case X_DBM_WHERE_SU:
            strcat(pG->vchSqlStmnt," - ");
            break;
         case X_DBM_WHERE_MU:
            strcat(pG->vchSqlStmnt," * ");
            break;
         case X_DBM_WHERE_DV:
            strcat(pG->vchSqlStmnt," / ");
            break;
         case X_DBM_WHERE_EQ:
            {
               if ((i + 1 < pX_DBM->scWhere) && (pX_DBM->pWhere[i + 1].chOper == X_DBM_WHERE_SQLNULL))
               {
                  strcat(pG->vchSqlStmnt, " IS NULL ");
               }
               else
               {
                  strcat(pG->vchSqlStmnt," = ");
               }
            }
            break;
         case X_DBM_WHERE_NE:
            {
               if ((i + 1 < pX_DBM->scWhere) && (pX_DBM->pWhere[i + 1].chOper == X_DBM_WHERE_SQLNULL))
               {
                  strcat(pG->vchSqlStmnt, " IS NOT NULL ");
               }
               else
               {
                  strcat(pG->vchSqlStmnt," <> ");
               }
            }
            break;
         case X_DBM_WHERE_LT:
            strcat(pG->vchSqlStmnt," < ");
            break;
         case X_DBM_WHERE_LE:
            strcat(pG->vchSqlStmnt," <= ");
            break;
         case X_DBM_WHERE_GT:
            strcat(pG->vchSqlStmnt," > ");
            break;
         case X_DBM_WHERE_GE:
            strcat(pG->vchSqlStmnt," >= ");
            break;
         case X_DBM_WHERE_AN:
            strcat(pG->vchSqlStmnt," AND ");
            break;
         case X_DBM_WHERE_OR:
            strcat(pG->vchSqlStmnt," OR ");
            break;
         case X_DBM_WHERE_SQLNULL:
            break;
         case X_DBM_WHERE_NAME:
            {
               j = i;

               X_Search_Where_FldIndex( X_OAM_STANDARD_PARMS, &j );

               if ( fHasRRNO )
               {
                  if ( ( j == -1 ) || ( j == 0 ) || ( j > X_DBM_FLDMAP_COLUMNS ) )
                  {
                     X_Get_Valid_SQL_Name( pX_Ids, pX_Pro, pX_Fun,
                                           pX_DBM->pX_Fld[pX_DBM->pWhere[i].sField].fchName2,
                                           vchSQLName );

                     strcat( pG->vchSqlStmnt, vchSQLName );
                     sNameVec = i;                                    %ifdtts
                  }
                  else
                  {
                     sNameVec = j;                                    %ifdtts
                     j--;

                     strcat( pG->vchSqlStmnt, pX_Columns[j].vchColumn );
                  }
               }
               else
               {
                  if ( ( j == -1 ) || ( j > X_DBM_FLDMAP_COLUMNS ) )
                  {
                     X_Get_Valid_SQL_Name( pX_Ids, pX_Pro, pX_Fun,
                                           pX_DBM->pX_Fld[pX_DBM->pWhere[i].sField].fchName2,
                                           vchSQLName );

                     strcat( pG->vchSqlStmnt, vchSQLName );
                     sNameVec = i;                                    %ifdtts
                  }
                  else
                  {
                     strcat( pG->vchSqlStmnt, pX_Columns[j].vchColumn );
                     sNameVec = j;                                    %ifdtts
                  }
               }
            }
            break;
         case X_DBM_WHERE_VALUE:
            /* If datetime, value must be in same timezone */
            /* (UTC or local) as X_DBM_WHERE_NAME.         */
            k = pX_DBM->pWhere[i].sField;
            if (X_VECTOR_FIELD_IS_STORED_UTC(pX_Fld,sNameVec))   %ifdtts
            {                                                    %ifdtts
               strcpy(vchFormat,X_ENCODE_FORMAT_SQL_WITH_UTC);   %ifdtts
            }                                                    %ifdtts
            else                                                 %ifdtts
            {                                                    %ifdtts
               strcpy(vchFormat,X_ENCODE_FORMAT_SQL_WITH_LOCAL); %ifdtts
            }                                                    %ifdtts

            X_Vec_Encode_as_String( pX_Ids,
                                    pX_Pro,
                                    pX_Fun,
                                    pX_DBM->pX_Fld,
                                    k,
                                    X_DBM_DECIMAL_EDIT_CODE,
                                    pX_NULL,
                                    &ulRetLen,
                                    &pvchString,
                                    &VarCharTemp, 
                                    pX_NULL,
                                    vchFormat);

            if (pX_Ids->chFatalError == YES)
            {
               strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
               return;
            }

            if ( ( X_VECTOR_STORED_AS_NUMERIC(pX_DBM->pX_Fld, k) )
             &&  (pX_DBM->pX_Fld[k].sDec == 0) )
            {
               strcat(pG->vchSqlStmnt, pvchString);

               if ( X_VECTOR_STORED_AS_FLOAT(pX_DBM->pX_Fld, k) == FALSE )  %ifRDMLX_File
               {
                  strcat(pG->vchSqlStmnt, ".0");
               }
            }
            else
            {
               if ( X_VECTOR_IS_DATE_TIME_TIMESTAMP(sNameVec) )        %ifdtts
               {                                                       %ifdtts
                  X_VCHAR vchString[50 + 1];                           %ifdtts
                  X_LONG  lDummy;                                      %ifdtts
                  strncpy(vchString,pvchString,sizeof(vchString));     %ifdtts
                  vchString[sizeof(vchString) - 1] = END_OF_STRING;    %ifdtts
                  X_DBM_OP( lDummy,                                    %ifdtts
                            X_DBM_FORMAT_DATETIME_LITERAL,             %ifdtts
                            vchString,                                 %ifdtts
                            sizeof(vchString),                         %ifdtts
                            pX_NULL );                                 %ifdtts
                  if (pX_Ids->chFatalError == YES)                     %ifdtts
                  {                                                    %ifdtts
                     strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR); %ifdtts
                     return;                                           %ifdtts
                  }                                                    %ifdtts
                                                                       %ifdtts
                  strcat(pG->vchSqlStmnt, vchString);                  %ifdtts
               }                                                       %ifdtts
               else                                                    %ifdtts
               {
                  /* Reverse data if SREV used */                                      %ifsrev
                  if (X_LANGUAGE_IS_RLTB)                                              %ifsrev
                  {                                                                    %ifsrev
                     %srevkey
                        X_VAR_VarChar_Reverse(pX_Ids, pX_Pro, pX_Fun, &VarCharTemp);   %ifsrev
                  }                                                                    %ifsrev
                  X_VAR_VarChar_Quote(pX_Ids, pX_Pro, pX_Fun, &VarCharTemp, TRUE);

                  X_VAR_VarChar_GetAsVchar(pX_Ids, pX_Pro, pX_Fun, &VarCharTemp, &pvchString );
                  strcat(pG->vchSqlStmnt, pvchString);
               }
            }
            break;
         default:
            break;
      }
   }

   strcat(pG->vchSqlStmnt,")");

   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_COMMON)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Add_Table_Name                               */
/* Description  : Add the correct table/view name to SELECT          */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Add_Table_Name(X_OAM_STANDARD_ARGS)
{

   %selfile

   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_COMMON)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Get_Updated_Stmnt                            */
/* Description  : Setup and return the correct requested statement.  */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                sOption      - the requested updated statement.    */
/*                                                                   */
/* ================================================================= */

X_PVCHAR_FUNCTION X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_ARGS, X_SHORT sOption )
{
   %updatedstmnt

   pvchReturn = "";
   if ( sIndex != -1 )
   {
      if ( sOption == GET_STMNT_SELECT )
      {
         pvchReturn = pG->UpdatedStmnt[sIndex].pvchSelect;
      }
      else if ( sOption == GET_STMNT_ORDER )
      {
         pvchReturn = pG->UpdatedStmnt[sIndex].pvchOrder;
      }
      else if ( sOption == GET_STMNT_BCKORD )
      {
         pvchReturn = pG->UpdatedStmnt[sIndex].pvchBckOrd;
      }
      else if ( fHasRRNO && sOption == GET_STMNT_RRN )
      {
         pvchReturn = pG->UpdatedStmnt[sIndex].pvchRRN;
      }
   }

   return pvchReturn;

}

/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Add_Value_To_Stmnt                           */
/* Description  : Add value to the SQL statement.                    */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                sVec         - Field vector (in pX_DBM->pX_Fld.    */
/*                i            - Index into psKeyFields. Used by srev*/
/*                                                                   */
/* ================================================================= */

O_BOOL_FUNCTION X_OAM_Add_Value_To_Stmnt(X_OAM_STANDARD_ARGS, X_SHORT sVecOnlyUseToResolve, X_SHORT i )
{
   X_PVCHAR pvchString;
   X_ULONG  ulRetLen;
   X_PVCHAR pvchEnd = pG->vchSqlStmnt + strlen(pG->vchSqlStmnt);
   X_VCHAR  vchFormat[2 + 1] = X_ENCODE_FORMAT_SQL_WITH_SUTC; /* Default - could be any format */

   /* -------------------------------------------------------------------------------------- */
   /* The value may be an evaluation variable from a rule, trigger, etc. so resolve it first */
   /* -------------------------------------------------------------------------------------- */

   struct X_FLD *pFld  = X_VECTOR_RESOLVE_FIELD_ADDRESS( pX_Ids, pX_Pro, pX_Fun, pX_DBM->pX_Fld, sVecOnlyUseToResolve );

   /* If value is NULL, return No Record (NR) */         %ifRDMLX_File
                                                         %ifRDMLX_File
   if ( X_VECTOR_FIELD_IS_SQL_NULL( pFld, 0 ) )          %ifRDMLX_File
   {                                                     %ifRDMLX_File
      strcpy(pX_DBM->vchReturnCode, X_DBM_NO_RECORD);    %ifRDMLX_File
      return FALSE;                                      %ifRDMLX_File
   }                                                     %ifRDMLX_File

   if (X_VECTOR_FIELD_IS_STORED_UTC( pFld, 0 ) )         %ifdtts
   {                                                     %ifdtts
      strcpy(vchFormat,X_ENCODE_FORMAT_SQL_WITH_UTC);    %ifdtts
   }                                                     %ifdtts
   else                                                  %ifdtts
   {                                                     %ifdtts
      strcpy(vchFormat,X_ENCODE_FORMAT_SQL_WITH_LOCAL);  %ifdtts
   }                                                     %ifdtts

   X_Vec_Encode_as_String( pX_Ids,
                           pX_Pro,
                           pX_Fun,
                           pX_DBM->pX_Fld,
                           sVecOnlyUseToResolve,
                           X_DBM_DECIMAL_EDIT_CODE,
                           pX_NULL,
                           &ulRetLen,
                           &pvchString,
                           &VarCharTemp, 
                           pX_NULL,
                           vchFormat ); 

   if (pX_Ids->chFatalError == YES)
   {
      strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
      return FALSE;
   }

   /* If numeric key, ensure correct decimal for SQL */

   if ( X_VECTOR_STORED_AS_NUMERIC( pFld, 0 ) )
   {
      strcpy(pvchEnd, pvchString);

      if (pFld[0].sDec == 0)
      {
         if ( X_VECTOR_STORED_AS_FLOAT(pFld, 0) == FALSE )  %ifRDMLX_File
         {
            strcat(pvchEnd, ".0");
         }
      }
      else
      {
         X_PVCHAR pvchPoint;

         if ((pvchPoint = strchr(pvchEnd, pX_Ids->chDecimalPoint)) != 0)
         {
            *pvchPoint = '.';
         }
      }
   }

   /* else if an alphanumeric key, quote the value */

   else
   {
      if (fDateTime)                                                          %ifdtts
      {                                                                       %ifdtts
         X_VCHAR vchString[50 + 1];                                           %ifdtts
         X_LONG  lDummy;                                                      %ifdtts
         /* Reset to default immediately */                                   %ifdtts
         fDateTime = FALSE;                                                   %ifdtts
         strncpy(vchString,pvchString,sizeof(vchString));                     %ifdtts
         vchString[sizeof(vchString) - 1] = END_OF_STRING;                    %ifdtts
         X_DBM_OP( lDummy,                                                    %ifdtts
                   X_DBM_FORMAT_DATETIME_LITERAL,                             %ifdtts
                   vchString,                                                 %ifdtts
                   sizeof(vchString),                                         %ifdtts
                   pX_NULL );                                                 %ifdtts
         if (pX_Ids->chFatalError == YES)                                     %ifdtts
         {                                                                    %ifdtts
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);                  %ifdtts
            return FALSE;                                                     %ifdtts
         }                                                                    %ifdtts
         strcat(pvchEnd, vchString);                                          %ifdtts
      }                                                                       %ifdtts
      else                                                                    %ifdtts
      {
         /* Reverse data if SREV used ..... */                                %ifsrev
         if (X_LANGUAGE_IS_RLTB)                                              %ifsrev
         {                                                                    %ifsrev
            %srevkey
               X_VAR_VarChar_Reverse(pX_Ids, pX_Pro, pX_Fun, &VarCharTemp);   %ifsrev
         }                                                                    %ifsrev
                                                                              %ifsrev
         X_VAR_VarChar_Quote(pX_Ids, pX_Pro, pX_Fun, &VarCharTemp, TRUE);
         if (pX_Ids->chFatalError == YES)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            return FALSE;
         }

         X_VAR_VarChar_GetAsVchar(pX_Ids, pX_Pro, pX_Fun, &VarCharTemp, &pvchString );
         strcpy(pvchEnd, pvchString);
      }
   }

   return TRUE;
}

#endif

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_COMMON)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Replace_RRNO                                 */
/* Description  : Created a copy of the given string and replace     */
/*                the RRNO to the native RRN function and the        */
/*                object name.                                       */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Replace_RRNO( X_OAM_STANDARD_ARGS,
                                    X_PVCHAR *  ppvchCopy,
                                    X_PVCHAR    pvchSource,
                                    X_PVCHAR    pvchRealName,
                                    X_PVCHAR    pvchObject )
{
   X_PVCHAR pRRN;
   X_LONG   lSrcLength = strlen( pvchSource ) + 1;
   X_PVCHAR pvchName;
   X_SHORT  sObjLength;

   if ( X_DBMS_INFO_USE_INTERNAL_NAMES )
   {
      pvchName = pvchRealName;
   }
   else
   {
      pvchName = pvchObject;
   }

   sObjLength = strlen( pvchName );

   *ppvchCopy = X_PDF_Allocate_Memory( pX_Ids, pX_NULL, pX_NULL, lSrcLength );

   strcpy( *ppvchCopy, pvchSource );

   pRRN = strstr( *ppvchCopy, "RRN()" );
   while ( pRRN )
   {
      memcpy( pRRN + 4, pvchName, sObjLength );
      memcpy( pRRN + 4 + sObjLength, ")", 1 );

      pRRN = strstr( pRRN + sObjLength, "RRN()" );
   }

}

#endif

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_COMMON)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Build_Start_Key                              */
/* Description  : Add the correct WHERE condition for a *STARTKEY    */
/*                in a SELECT for physical/logical file keys         */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Build_Start_Key(X_OAM_STANDARD_ARGS)
{

   X_SHORT  sStringLength;
   X_VCHAR  vchString[(X_MAX_UPID_FIELD_LEN * 2) + 2 + 1];
   X_SHORT  i;
   X_SHORT  j;
   X_SHORT  k;

   /* Iterate for each group of key fields */

   for (j = 0; j < pX_DBM->scKeyFlds; j++)
   {
      if (j == 0) strcat(pG->vchSqlStmnt," ((");
      else strcat(pG->vchSqlStmnt," OR (");

      for (i = 0; i <= j; i++)
      {
         X_PVCHAR pvchTemp;

         if (i > 0) strcat(pG->vchSqlStmnt," AND ");

         %where

         /* If generic searching use the LIKE predicate */

         k = pX_DBM->psKeyFlds[i];

         if ( ( pX_DBM->chGeneric == YES )
          && ( i == ( pX_DBM->scKeyFlds - 1 ) ) )
         {
            if ( ( X_VECTOR_STORED_AS_ALPHA( pX_DBM->pX_Fld, k) ) || ( X_VECTOR_STORED_AS_CHAR( pX_DBM->pX_Fld, k) )  )
            {
               X_VCHAR vchEscape[11 + 1]; /* Allow for DBCS escape char */

               struct X_CTD_DBMS_INFO * pDBMSInfo = 
                              ((X_DBM_V3_OR_LATER && pX_DBM->pDatabase) ? pX_DBM->pDatabase->pDBMSInfo : pX_Ids->pUserDBMSInfo);

               strcat(pG->vchSqlStmnt," LIKE ");

               pvchTemp = pG->vchSqlStmnt + strlen(pG->vchSqlStmnt);

               if ( !X_OAM_Add_Value_To_Stmnt(X_OAM_STANDARD_PARMS, k, i) )
               {
                  return;
               }

               /* Set the pattern */

               pvchTemp[strlen(pvchTemp) - 1] = END_OF_STRING;
               X_Remove_Blanks(pX_Ids,pX_Pro,pX_Fun,
                               pvchTemp,X_STRIP_BLANKS_TRAILING);

               /* Must escape wildcards in data to be same as 400 */
               X_EscapeSQLWildcards_2( pX_Ids,
                                       pX_Pro,
                                       pX_Fun,
                                       pDBMSInfo,
                                       pvchTemp,
                                       sizeof(pG->vchSqlStmnt) - (pvchTemp - pG->vchSqlStmnt),
                                       TRUE,
                                       TRUE,
                                       TRUE,
                                       pX_DBM->pX_Fld[k].chDBCS,
                                       vchEscape,
                                       sizeof(vchEscape) );
               strcat(pvchTemp, "%\'");

               if ( vchEscape[0] != END_OF_STRING )
               {
                  strcat(pvchTemp," ");
                  strcat(pvchTemp, vchEscape);
               }
            }
            else if ( X_VECTOR_STORED_AS_PACKED( pX_DBM->pX_Fld, k)  || X_VECTOR_STORED_AS_SIGNED( pX_DBM->pX_Fld, k) ||
                         X_VECTOR_STORED_AS_INTEGER( pX_DBM->pX_Fld, k) )
 
            {
               /* TN: Generic Numeric */

               %gennum            
            }
            else
            {
               X_Fatal_Error( pX_Ids,
                              pX_Pro,
                              pX_Fun,
                              "X_OAM_Build_Start_Key",
                              "Field %s is not supported by *GENERIC",
                              (pX_DBM->pX_Fld)[ k ].fchName2);
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
               return ;
            }
         }
         /* Set > or < in condition for last key */

         else if (i == j)
         {
            %startkey

            if (i == (pX_DBM->scKeyFlds - 1))
               strcat(pG->vchSqlStmnt,"= ");
            else
               strcat(pG->vchSqlStmnt," ");

            if ( !X_OAM_Add_Value_To_Stmnt(X_OAM_STANDARD_PARMS, k, i) )
            {
               return;
            }

         }

         else
         {
            strcat(pG->vchSqlStmnt," = ");
            if ( !X_OAM_Add_Value_To_Stmnt(X_OAM_STANDARD_PARMS, k, i) )
            {
               return;
            }
         }
      }

      strcat(pG->vchSqlStmnt,")");

   }

   if (j != 0) strcat(pG->vchSqlStmnt,")");

   return;
}

#endif

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_COMMON)))
#ifdef X_OAM_REPLACE_RRN_WITH_PKEY_REQUIRED
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Build_Primary_Key_Where                      */
/* Description  : Add the correct WHERE condition for the primary    */
/*                key, given the values in pG->pLastRec              */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                fMatch       - TRUE if key should match, False if  */
/*                               we are excluding primary key -- also*/
/*                               does not put WHERE on front.        */
/*                fLOB         - FALSE if should use pG->vchSqlStmnt */
/*                               TRUE  if pG->vchLOBSqlStmnt         */
/*                fUseSavedRec - TRUE if should use pG->pLastRec     */
/*                             - FALSE if should use X_DBM_Current   */
/*                                                                   */
/* ================================================================= */
O_VOID_FUNCTION X_OAM_Build_Primary_Key_Where(X_OAM_STANDARD_ARGS, 
                                              X_BOOL fMatch, 
                                              X_BOOL fLOB,
                                              X_BOOL fUseSavedRec)
{
   X_SHORT  sStringLength;
   X_VCHAR  vchTempPKey[ sizeof(X_FLDDATA) ];
   X_PVCHAR pvchString;
   X_ULONG  ulRetLen;
   X_PVCHAR pvchEnd;
   X_SHORT  i; /* pG->pX_Fld vector */
   X_SHORT  j; /* Index to key arrays */
   X_PVCHAR pvchStmnt = ( fLOB ? pG->vchLOBSqlStmnt : pG->vchSqlStmnt ); %iflob
   X_PVCHAR pvchStmnt = pG->vchSqlStmnt;                                 %ifnlob

   /* -------------------------------------------------------------- */
   /* Note that this routine does not need to resolve evaulation     */
   /* vectors because the fields are ALWAYS actual fields.           */
   /* RG: 2/8/2004                                                   */
   /* -------------------------------------------------------------- */

   if ( fUseSavedRec )
   {
      %setxvarptr1
      %ifxvar
   }
   for (j = 0; j < X_DBM_PrimKeysCount; j++)
   {
      i = X_DBM_PKeyVecs[j];

      if ( j == 0 )
      {
         if ( fMatch ) strcat(pvchStmnt," WHERE ");
      }
      else
      {
         strcat(pvchStmnt," AND ");
      }

      %pkeywhere

      strcat(pvchStmnt,( fMatch ? " = " : " <> " ));

      pvchEnd = pvchStmnt + strlen(pvchStmnt);

      if ( fUseSavedRec )
      {
         /* Backup data from pG->pX_Fld[i] into vchTempPKey temporarily          */
         /* Copy data from pG->pLastRec into pG->pX_Fld[i] for SQL creation      */

         memcpy( vchTempPKey, pG->pX_Fld[i].pField, pG->pX_Fld[i].sByteLen );

         memcpy( pG->pX_Fld[i].pField,
                 &(((X_PVCHAR)((pG->pLastRec[pG->sFileNo])))[X_DBM_PKeyOffsets[j]]),
                 pG->pX_Fld[i].sByteLen );
      }

      X_Vec_Encode_as_String( pX_Ids,
                              pX_Pro,
                              pX_Fun,
                              pG->pX_Fld,
                              i,
                              X_DBM_DECIMAL_EDIT_CODE,
                              pX_NULL,
                              &ulRetLen,
                              &pvchString,
                              &VarCharTemp, 
                              pX_NULL,
                              X_ENCODE_FORMAT_SQL_WITH_SUTC); /* Use SUTC for Datetime */

      if ( fUseSavedRec )
      {
         /* Restore data from pG->vchTempPKey back into pG->pX_Fld[i] */
         memcpy( pG->pX_Fld[i].pField, vchTempPKey, pG->pX_Fld[i].sByteLen );
      }

      if (pX_Ids->chFatalError == YES)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }

      /* If numeric key, ensure correct decimal for SQL */

      if ( X_VECTOR_STORED_AS_NUMERIC(pG->pX_Fld, i) )
      {
         strcpy(pvchEnd, pvchString);

         if (pG->pX_Fld[i].sDec == 0)
         {
            if ( X_VECTOR_STORED_AS_FLOAT(pG->pX_Fld, i) == FALSE )  %ifRDMLX_File
            {
               strcat(pvchEnd, ".0");
            }
         }
         else
         {
            X_PVCHAR pvchPoint;

            if ((pvchPoint = strchr(pvchEnd, pX_Ids->chDecimalPoint)) != 0)
            {
               *pvchPoint = '.';
            }
         }
      }

      /* else if an alphanumeric key, quote the value */

      else
      {
         if (fDateTime)                                                          %ifdtts
         {                                                                       %ifdtts
            X_VCHAR vchString[50 + 1];                                           %ifdtts
            X_LONG  lDummy;                                                      %ifdtts
            /* Reset to default immediately */                                   %ifdtts
            fDateTime = FALSE;                                                   %ifdtts
            strncpy(vchString,pvchString,sizeof(vchString));                     %ifdtts
            vchString[sizeof(vchString) - 1] = END_OF_STRING;                    %ifdtts
            X_DBM_OP( lDummy,                                                    %ifdtts
                      X_DBM_FORMAT_DATETIME_LITERAL,                             %ifdtts
                      vchString,                                                 %ifdtts
                      sizeof(vchString),                                         %ifdtts
                      pX_NULL );                                                 %ifdtts
            if (pX_Ids->chFatalError == YES)                                     %ifdtts
            {                                                                    %ifdtts
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);                  %ifdtts
               return;                                                           %ifdtts
            }                                                                    %ifdtts
            strcat(pvchEnd, vchString);                                          %ifdtts
         }                                                                       %ifdtts
         else                                                                    %ifdtts
         {
            /* Reverse data if SREV used */                                      %ifsrev
            if (X_LANGUAGE_IS_RLTB)                                              %ifsrev
            {                                                                    %ifsrev
               %srevkeypg
                  X_VAR_VarChar_Reverse(pX_Ids, pX_Pro, pX_Fun, &VarCharTemp);   %ifsrev
            }                                                                    %ifsrev
                                                                                 %ifsrev
            X_VAR_VarChar_Quote(pX_Ids, pX_Pro, pX_Fun, &VarCharTemp, TRUE);
            if (pX_Ids->chFatalError == YES)
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
               return;
            }

            X_VAR_VarChar_GetAsVchar(pX_Ids, pX_Pro, pX_Fun, &VarCharTemp, &pvchString );
            strcpy(pvchEnd, pvchString);
         }
      }
   }

   return;
}

#endif

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Save_Current_Record                          */
/* Description  : Save the current record.                           */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_BOOL_FUNCTION X_OAM_Save_Current_Record(X_OAM_STANDARD_ARGS)
{
   X_BOOL fReturn = TRUE;

   pG->fLastSaved[pG->sFileNo] = TRUE;

   if ( !pG->pLastRec[pG->sFileNo] )
   {
      pG->pLastRec[pG->sFileNo] = X_PDF_Allocate_Memory(pX_Ids, pX_Pro, pX_Fun, sizeof(X_DBM_Current));
      if (pX_Ids->chFatalError == YES)
      {
         strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
         fReturn = FALSE;
      }

      pG->pLastRecX_VAR[pG->sFileNo] = X_PDF_Allocate_Memory(pX_Ids, pX_Pro, pX_Fun, sizeof(struct X_DBM_SAVED_X_VAR)); %ifxvar
      if (pX_Ids->chFatalError == YES)                                                                            %ifxvar
      {                                                                                                           %ifxvar
         X_PDF_Free_Memory(pX_Ids, pX_Pro, pX_Fun, pG->pLastRec[pG->sFileNo]);                                    %ifxvar
         pG->pLastRec[pG->sFileNo] = pX_NULL;                                                                     %ifxvar
                                                                                                                  %ifxvar
         strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);                                                        %ifxvar
         fReturn = FALSE;                                                                                         %ifxvar
      }                                                                                                           %ifxvar
      else                                                                                                        %ifxvar
      {                                                                                                           %ifxvar
         memset(pG->pLastRecX_VAR[pG->sFileNo], LOVAL, sizeof(struct X_DBM_SAVED_X_VAR));                         %ifxvar
      }                                                                                                           %ifxvar
   }

   if (fReturn)
   {
      *pG->pLastRec[pG->sFileNo] = X_DBM_Current;
      %ifxvar
      %savelastxvar
   }

   return fReturn;
}

/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Compare_Current_Record                       */
/* Description  : Compare the current record with the last saved     */
/*                record.                                            */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_BOOL_FUNCTION X_OAM_Compare_Current_Record(X_OAM_STANDARD_ARGS)
{
   X_BOOL fReturn = TRUE;

   %setxvarptr2
   %ifxvar
   fReturn = ((memcmp(pG->pLastRec[pG->sFileNo], &X_DBM_Current, sizeof(X_DBM_Current)) != 0)
             %cmplastxvar
             || (FALSE));
   return fReturn;
}

/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Deallocate_X_Var                             */
/* Description  : Free pLastRecX_VAR memory.                         */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_BOOL_FUNCTION X_OAM_Deallocate_X_Var(X_OAM_STANDARD_ARGS)
{
   X_BOOL fReturn = TRUE;

   if ( pG->pLastRec[pG->sFileNo] )
   {
      X_PDF_Free_Memory(pX_Ids, pX_Pro, pX_Fun, pG->pLastRec[pG->sFileNo]);
      pG->pLastRec[pG->sFileNo] = pX_NULL;
                                                                                 %ifxvar
      %dellastxvar
                                                                                 %ifxvar
      X_PDF_Free_Memory(pX_Ids, pX_Pro, pX_Fun, pG->pLastRecX_VAR[pG->sFileNo]); %ifxvar
      pG->pLastRecX_VAR[pG->sFileNo] = pX_NULL;                                  %ifxvar
   }

   return fReturn;
}

#endif /* defined(X_OAM_SAVE_CURR_RECORD_REQUIRED)           */
#endif /*  ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_COMMON))) */

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_INIT)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_OAM_Initialisation                               */
/* Description  : Perform OAM initialisation.                        */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Initialisation(X_OAM_STANDARD_ARGS)
{

   X_SHORT i;

   /* Set the correct language */

   for (i = 0; i < X_DBM_TOTAL_LANGUAGES; i++)
   {
      if (strcmp(X_Lang[i].vchLangCode,pX_Ids->vchLangCode) == 0)
      {
         pG->sLang = i;
         break;
      }
   }

   X_VARCHAR_INIT( &VarCharTemp )

   %ll2init

   /* Initialise all the variables */

   X_Vec_Init_Group(pX_Ids,
                    pX_Pro,
                    pX_Fun,
                    pX_Fld,
                    X_TOTAL_FIELDS,
                    sX_FldVecs);

   %init

   strcpy(pG->X_Trigger.vchRetc,"ER");                                %ifatrg


   return;
}

#endif

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_EXECUTE)))
%vcsbr
#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_INIT)))
/*===================================================================*/
/* Function     : X_Create_OAM_Field_Instance                        */
/* Description  : Create a Windows 3.1 instance for OAM fields       */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pG           - standard global info. structure     */
/*                                                                   */
/*===================================================================*/

O_VOID_FUNCTION X_Create_OAM_Field_Instance(struct X_IDS *pX_Ids,
                                            struct GLOBAL_INFO *pG)
{


   /* -------------------------------- */
   /* If not invoked under Windows 3.1 */
   /* -------------------------------- */

#if !(defined(X_OPERATING_SYSTEM_WIN31))

    X_Fatal_Error (pX_Ids,
                   pX_NULL,
                   pX_NULL,
                   "X_Create_OAM_Field_Instance",
                   X_TEXT(292));
    return;
#endif

   /* ------------------------------- */
   /* Allocate current field map area */
   /* and X_RRNO field area.          */
   /* ------------------------------- */

   pG->pX_Curr = (struct X_DBM_FLDMAP *) X_PDF_Allocate_Memory(
                                                 pX_Ids,
                                                 pX_NULL,
                                                 pX_NULL,
                                        (X_LONG) sizeof(struct X_DBM_FLDMAP));
   if (pX_Ids->chFatalError == YES) return;

#if !defined(X_DBM_AUTO_RRNO) && !defined(X_DBM_IDENTITY_COLUMN)

   pG->pX_RRNO = (X_DICTIONARY_PACKED *) X_PDF_Allocate_Memory(
                                              pX_Ids,
                                              pX_NULL,
                                              pX_NULL,
                                              (X_LONG) sizeof(X_RRNO));
   if (pX_Ids->chFatalError == YES) return;

#endif

   /* ----------------------------------------------------------- */
   /* Allocate X_FLD structure for the current field mapping area */
   /* and copy the X_Fld "template" data.                         */
   /* ----------------------------------------------------------- */

   pG->pX_Fld = (struct X_FLD *) X_PDF_Allocate_Memory(
                                              pX_Ids,
                                              pX_NULL,
                                              pX_NULL,
                                              (X_LONG) sizeof(X_Fld));
   if (pX_Ids->chFatalError == YES) return;

   memcpy(pG->pX_Fld, &X_Fld, sizeof(X_Fld));

   /* ------------------------------------ */
   /* Set correct addresses for all fields */
   /* ------------------------------------ */

   %instcode


   /* -------------------------------- */                             %ifprev
   /* Allocate previous field map area */                             %ifprev
   /* -------------------------------- */                             %ifprev
                                                                      %ifprev
   pG->pX_Prev = (struct X_DBM_FLDMAP *) X_PDF_Allocate_Memory(       %ifprev
                                                 pX_Ids,              %ifprev
                                                 pX_NULL,             %ifprev
                                                 pX_NULL,             %ifprev
                              %ifprev   (X_LONG) sizeof(struct X_DBM_FLDMAP));
   if (pX_Ids->chFatalError == YES) return;                           %ifprev
                                                                      %ifprev
                                                                      %ifprev
   /* ------------------------------------------------------------ */ %ifprev
   /* Allocate X_FLD structure for the previous field mapping area */ %ifprev
   /* and copy the X_FldPrev "template" data.                      */ %ifprev
   /* ------------------------------------------------------------ */ %ifprev
                                                                      %ifprev
   pG->pX_FldPrev = (struct X_FLD *) X_PDF_Allocate_Memory(           %ifprev
                                              pX_Ids,                 %ifprev
                                              pX_NULL,                %ifprev
                                              pX_NULL,                %ifprev
                                              (X_LONG) sizeof(X_Fld));%ifprev
   if (pX_Ids->chFatalError == YES) return;                           %ifprev
                                                                      %ifprev
   memcpy(pG->pX_FldPrev, &X_FldPrev, sizeof(X_FldPrev));             %ifprev
                                                                      %ifprev
   /* ------------------------------------ */                         %ifprev
   /* Set correct addresses for all fields */                         %ifprev
   /* ------------------------------------ */                         %ifprev
                                                                      %ifprev
   %previnst
                                                                      %ifprev
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_INIT)))
/*===================================================================*/
/* Function     : X_Destroy_OAM_Field_Instance                       */
/* Description  : Destroy Windows 3.1 instance for OAM fields        */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pG           - standard global info. structure     */
/*                                                                   */
/*===================================================================*/

O_VOID_FUNCTION X_Destroy_OAM_Field_Instance(struct X_IDS *pX_Ids,
                                             struct GLOBAL_INFO *pG)
{

   /* -------------------------------- */
   /* If not invoked under Windows 3.1 */
   /* -------------------------------- */

#if !(defined(X_OPERATING_SYSTEM_WIN31))

   X_Fatal_Error (pX_Ids,
                  pX_NULL,
                  pX_NULL,
                  "X_Destroy_OAM_Field_Instance",
                  X_TEXT(292));
   return;
#endif

   /* ------------------------------------------- */
   /* Deallocate all field map areas if allocated */
   /* ------------------------------------------- */

   if (pG->pX_Fld == pX_NULL) return;

   if (pG->pX_Curr != pX_NULL)
   {
      X_PDF_Free_Memory (pX_Ids,pX_NULL,pX_NULL,(X_PVOID)pG->pX_Curr);
      pG->pX_Curr = pX_NULL;
   }

   if (pG->pX_RRNO != pX_NULL)
   {
      X_PDF_Free_Memory (pX_Ids,pX_NULL,pX_NULL,(X_PVOID)pG->pX_RRNO);
      pG->pX_RRNO = pX_NULL;
   }

   if (pG->pX_Fld != pX_NULL)
   {
      X_PDF_Free_Memory (pX_Ids,pX_NULL,pX_NULL,(X_PVOID)pG->pX_Fld);
      pG->pX_Fld = pX_NULL;
   }
                                                                      %ifprev
   if (pG->pX_Prev != pX_NULL)                                        %ifprev
   {                                                                  %ifprev
      X_PDF_Free_Memory (pX_Ids,pX_NULL,pX_NULL,(X_PVOID)pG->pX_Prev);%ifprev
      pG->pX_Prev = pX_NULL;                                          %ifprev
   }                                                                  %ifprev
                                                                      %ifprev
   if (pG->pX_FldPrev != pX_NULL)                                     %ifprev
   {                                                                  %ifprev
      X_PDF_Free_Memory (pX_Ids,pX_NULL,pX_NULL,                      %ifprev
                        (X_PVOID)pG->pX_FldPrev);                     %ifprev
      pG->pX_FldPrev = pX_NULL;                                       %ifprev
   }                                                                  %ifprev
                                                                      %ifprev
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_COMMON)))%ifbch
/*===================================================================*/%ifbch
/* Function     : X_Create_Batch_Field_Instance                      */%ifbch
/* Description  : Create a Windows 3.1 instance for batch control    */%ifbch
/*                                                                   */%ifbch
/* Arguments    : pX_Ids       - standard system def. structure      */%ifbch
/*                pG           - standard global info. structure     */%ifbch
/*                                                                   */%ifbch
/*===================================================================*/%ifbch
                                                                       %ifbch
O_VOID_FUNCTION X_Create_Batch_Field_Instance(struct X_IDS *pX_Ids,    %ifbch
                                              struct GLOBAL_INFO *pG)  %ifbch
{                                                                      %ifbch
                                                                       %ifbch
   /* -------------------------------- */                              %ifbch
   /* If not invoked under Windows 3.1 */                              %ifbch
   /* -------------------------------- */                              %ifbch
                                                                       %ifbch
#if !(defined(X_OPERATING_SYSTEM_WIN31))                               %ifbch
                                                                       %ifbch
    X_Fatal_Error (pX_Ids,                                             %ifbch
                   pX_NULL,                                            %ifbch
                   pX_NULL,                                            %ifbch
                   "X_Create_Batch_Field_Instance",                    %ifbch
                   X_TEXT(292));                                       %ifbch
    return;                                                            %ifbch
#endif                                                                 %ifbch
                                                                       %ifbch
   /* ----------------------------------------------------- */         %ifbch
   /* Allocate batch control field map area, batch control  */         %ifbch
   /* field structure and copy the X_Fld_%s "template" data */         %ifbch
   /* ----------------------------------------------------- */         %ifbch
                                                                       %ifbch
   %BchAlloc
                                                                       %ifbch
   /* ------------------------------------ */                          %ifbch
   /* Set correct addresses for all fields */                          %ifbch
   /* ------------------------------------ */                          %ifbch
                                                                       %ifbch
   %bchinst
                                                                       %ifbch
}                                                                      %ifbch
                                                                       %ifbch
#endif                                                                 %ifbch
                                                                       %ifbch
                                                                       %ifbch
#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_COMMON)))%ifbch
/*===================================================================*/%ifbch
/* Function     : X_Destroy_Batch_Field_Instance                     */%ifbch
/* Description  : Destroy Windows 3.1 instance for Batch Control     */%ifbch
/*                                                                   */%ifbch
/* Arguments    : pX_Ids       - standard system def. structure      */%ifbch
/*                pG           - standard global info. structure     */%ifbch
/*                                                                   */%ifbch
/*===================================================================*/%ifbch
                                                                       %ifbch
O_VOID_FUNCTION X_Destroy_Batch_Field_Instance(struct X_IDS *pX_Ids,   %ifbch
                                               struct GLOBAL_INFO *pG) %ifbch
{                                                                      %ifbch
                                                                       %ifbch
   /* -------------------------------- */                              %ifbch
   /* If not invoked under Windows 3.1 */                              %ifbch
   /* -------------------------------- */                              %ifbch
                                                                       %ifbch
#if !(defined(X_OPERATING_SYSTEM_WIN31))                               %ifbch
                                                                       %ifbch
   X_Fatal_Error (pX_Ids,                                              %ifbch
                  pX_NULL,                                             %ifbch
                  pX_NULL,                                             %ifbch
                  "X_Destroy_Batch_Field_Instance",                    %ifbch
                  X_TEXT(292));                                        %ifbch
   return;                                                             %ifbch
#endif                                                                 %ifbch
                                                                       %ifbch
   /* ----------------------------------------------------- */         %ifbch
   /* Deallocate all batch control field areas if allocated */         %ifbch
   /* ----------------------------------------------------- */         %ifbch
                                                                       %ifbch
   %BchDestroy
                                                                       %ifbch
}                                                                      %ifbch
                                                                       %ifbch
#endif                                                                 %ifbch

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_INIT)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_Search_FldIndex                                  */
/* Description  : Search/Allocate the FldIndex chain of structures   */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_Search_FldIndex( X_OAM_STANDARD_ARGS )
{

   struct X_DBM_FLDINDEX *pCurr = pFirstFldIndex;
   struct X_DBM_FLDINDEX *pPrev = pX_NULL;
   X_FCHAR fchGrpFieldName[X_OBJECT_NAME_LEN];
   X_FCHAR fchFieldName[X_OBJECT_NAME_LEN];
   X_SHORT i;
   X_SHORT j;

   while ( pCurr )
   {
      if ( (pCurr->pX_FunCaller == pX_Fun)
        && (pCurr->sSequence == pX_DBM->sSequence) ) break;
      pPrev = pCurr;
      pCurr = pCurr->pNextFldIndex;
   }

   /* -------------------------- */
   /* A new node to be allocated */
   /* -------------------------- */

   if (pCurr == pX_NULL)
   {
      pCurr = (struct X_DBM_FLDINDEX *) X_PDF_Allocate_Memory
                                             (pX_Ids,
                                              pX_Pro,
                                              pX_Fun,
                                              sizeof(struct X_DBM_FLDINDEX));

      if (pX_Ids->chFatalError == YES) return;

      memset( pCurr, LOVAL, sizeof(struct X_DBM_FLDINDEX) );

      /* --------------------------------------------------------- */
      /* Allocate space for array of Y/N to indicate whether field */
      /* used on file to match pX_DBM->psGrpFlds for external use. */
      /* --------------------------------------------------------- */
      if ( pX_DBM->scGrpFlds )
      {
         pCurr->X_DBM_UsedGrpFlds = (X_PYES_NO) X_PDF_Allocate_Memory
                                                (pX_Ids,
                                                 pX_Pro,
                                                 pX_Fun,
                                                 pX_DBM->scGrpFlds);
      }

      if (pX_Ids->chFatalError == YES) return;

      pCurr->pX_FunCaller  = pX_Fun;
      pCurr->sSequence     = pX_DBM->sSequence;
      pCurr->pNextFldIndex = pX_NULL;

      if (pPrev == pX_NULL)
         pFirstFldIndex = pCurr;
      else
         pPrev->pNextFldIndex = pCurr;

      /* ------------------------------------------------------ */
      /* Set X_DBM_FldsUsed, X_DBM_FldsIndex, X_DBM_UsedGrpFlds */
      /* according to the fields provided                       */
      /* ------------------------------------------------------ */

      memset(pCurr->X_DBM_FldsUsed,NO,X_TOTAL_FIELDS);
      memset(pCurr->X_DBM_UsedGrpFlds,NO,pX_DBM->scGrpFlds);

      for (j = 0; j < X_TOTAL_FIELDS; j++)
      {
         for (i = 0; i < pX_DBM->scGrpFlds; i++)
         {
            /* ----------------------------------------------------------- */
            /* Compare the names with @#$ substituted                      */
            /* This is allowed on VL because a Field differring by only    */
            /* @#$_ in any one character is not allowed in the SQL Table   */
            /* as they all map to _. See CCS109172 for requirement         */
            /* ----------------------------------------------------------- */

            memcpy(fchGrpFieldName, pX_DBM->pX_Fld[pX_DBM->psGrpFlds[i]].fchName2, X_OBJECT_NAME_LEN);
            X_PDF_ReplaceSpecialChars(pX_Ids, fchGrpFieldName);

            memcpy(fchFieldName,    pX_Fld[j].fchName2, X_OBJECT_NAME_LEN);
            X_PDF_ReplaceSpecialChars(pX_Ids, fchFieldName);

            if (memcmp(fchGrpFieldName, fchFieldName,X_OBJECT_NAME_LEN) == 0)
            {
               pCurr->X_DBM_FldsUsed[j] = YES;
               pCurr->X_DBM_UsedGrpFlds[i] = YES;
               pCurr->X_DBM_FldsIndex[j] = pX_DBM->psGrpFlds[i];
               break;
            }
         }
      }


   }

   /* ----------------------------------- */
   /* Set the current field index pointer */
   /* ----------------------------------- */

   pG->pCurrFldIndex = pCurr;


   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_INIT)))
/* ================================================================= */
/*                                                                   */
/* Function     : X_Search_Where_FldIndex                            */
/* Description  : Search / Allocate the <Where> FldIndex chain       */
/*                of structures                                      */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_Search_Where_FldIndex( X_OAM_STANDARD_ARGS, X_SHORT * psIndex )
{
   struct X_DBM_FLDINDEX   *  pCurr = pG->pWhereFldIndex;

   X_SHORT  i;

   while ( pCurr )
   {
      if ( ( pCurr->pX_FunCaller == pX_Fun )
        && ( pCurr->sSequence == pX_DBM->sSequence ) )
      {
         break;
      }

      pCurr = pCurr->pNextFldIndex;
   }

   /* -------------------------- */
   /* A new node to be allocated */
   /* -------------------------- */

   if ( pCurr == pX_NULL )
   {
      pCurr = (struct X_DBM_FLDINDEX *) X_PDF_Allocate_Memory( pX_Ids,
                                                               pX_Pro,
                                                               pX_Fun,
                                                               sizeof(struct X_DBM_FLDINDEX) );

      if ( pX_Ids->chFatalError == YES ) return;

      memset( pCurr, LOVAL, sizeof(struct X_DBM_FLDINDEX) );

      pCurr->X_DBM_WhereFldsUsed  = X_PDF_Allocate_Memory( pX_Ids,
                                                           pX_Pro,
                                                           pX_Fun,
                                                           sizeof( X_CHAR ) * pX_DBM->scWhere );

      if ( pX_Ids->chFatalError == YES ) return;

      pCurr->X_DBM_WhereFldsIndex = X_PDF_Allocate_Memory( pX_Ids,
                                                           pX_Pro,
                                                           pX_Fun,
                                                           sizeof( X_SHORT ) * pX_DBM->scWhere );

      if ( pX_Ids->chFatalError == YES ) return;

      memset( pCurr->X_DBM_WhereFldsUsed, NO, sizeof( X_CHAR ) * pX_DBM->scWhere );

      pCurr->pX_FunCaller  = pX_Fun;
      pCurr->sSequence     = pX_DBM->sSequence;
      pCurr->pNextFldIndex = pG->pWhereFldIndex;

      pG->pWhereFldIndex = pCurr;
   }

   if ( pCurr->X_DBM_WhereFldsUsed[*psIndex] != YES )
   {
      X_PVCHAR    pvchWhereField = pX_DBM->pX_Fld[pX_DBM->pWhere[*psIndex].sField].fchName2;

      pCurr->X_DBM_WhereFldsUsed[*psIndex]   = YES;
      pCurr->X_DBM_WhereFldsIndex[*psIndex]  = -1;

      for ( i = 0; i < X_TOTAL_FIELDS; i++ )
      {
         if ( !memcmp( pvchWhereField, pX_Fld[i].fchName2, X_OBJECT_NAME_LEN ) )
         {
            pCurr->X_DBM_WhereFldsIndex[*psIndex]  = i;
            break;
         }
      }
   }

   *psIndex = pCurr->X_DBM_WhereFldsIndex[*psIndex];

   return;
}

#endif


   #if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_INIT)))
/*===================================================================*/
/* Function     : X_Deallocate_FldIndex                              */
/* Description  : Deallocate FldIndex list                           */
/*===================================================================*/

O_VOID_FUNCTION X_Deallocate_FldIndex( struct X_IDS * pX_Ids,
                                       struct X_FUN * pX_FunOnly )
{

   struct X_DBM_FLDINDEX * pCurr = pFirstFldIndex;
   struct X_DBM_FLDINDEX * pFree;

   /* ------------------------------------------------------------ */
   /* Deallocate some or all of the field index areas in the chain */
   /* ------------------------------------------------------------ */

   if ( pX_FunOnly )
   {
       struct X_DBM_FLDINDEX ** ppPrev = &(pFirstFldIndex);

       while ( pCurr )
       {
          if ( pCurr->pX_FunCaller == pX_FunOnly )
          {
             *(ppPrev) = pCurr->pNextFldIndex;
             pFree = pCurr;
             pCurr = pCurr->pNextFldIndex;
             if ( pFree->X_DBM_UsedGrpFlds )
             {
                X_PDF_Free_Memory (pX_Ids, pX_NULL, pX_NULL,(X_PVOID) pFree->X_DBM_UsedGrpFlds);
             }
             X_PDF_Free_Memory (pX_Ids, pX_NULL, pX_NULL,(X_PVOID) pFree);
          }
          else
          {
             ppPrev = &(pCurr->pNextFldIndex);
             pCurr  = pCurr->pNextFldIndex;
          }
       }

   }
   else
   {

       while ( pCurr )
       {
          pFree = pCurr;
          pCurr = pFree->pNextFldIndex;
          if ( pFree->X_DBM_UsedGrpFlds )
          {
             X_PDF_Free_Memory (pX_Ids, pX_NULL, pX_NULL,(X_PVOID) pFree->X_DBM_UsedGrpFlds);
          }
          X_PDF_Free_Memory (pX_Ids, pX_NULL, pX_NULL,(X_PVOID) pFree);
       }

       pFirstFldIndex = pX_NULL;
   }

   return;


}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_INIT)))
/*===================================================================*/
/* Function     : X_Deallocate_WhereFldIndex                         */
/* Description  : Deallocate Where FldIndex list                     */
/*===================================================================*/

O_VOID_FUNCTION X_Deallocate_WhereFldIndex( struct X_IDS       *  pX_Ids,
                                            struct GLOBAL_INFO *  pG,
                                            struct X_FUN       *  pX_FunOnly )
{
   struct X_DBM_FLDINDEX * pCurr = pG->pWhereFldIndex;
   struct X_DBM_FLDINDEX * pPrev = pX_NULL;
   struct X_DBM_FLDINDEX * pFree;

   /* ------------------------------------------------------------ */
   /* Deallocate some or all of the field index areas in the chain */
   /* ------------------------------------------------------------ */

   if ( pX_FunOnly )
   {
      while ( pCurr )
      {
         if ( pCurr->pX_FunCaller == pX_FunOnly )
         {
            pFree = pCurr;
            pCurr = pCurr->pNextFldIndex;
            if ( pPrev )
            {
               pPrev->pNextFldIndex = pCurr;
            }

            if ( pFree->X_DBM_WhereFldsUsed )
            {
               X_PDF_Free_Memory( pX_Ids, pX_NULL, pX_NULL,(X_PVOID) pFree->X_DBM_WhereFldsUsed );
            }

            if ( pFree->X_DBM_WhereFldsIndex )
            {
               X_PDF_Free_Memory( pX_Ids, pX_NULL, pX_NULL,(X_PVOID) pFree->X_DBM_WhereFldsIndex );
            }

            X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL,(X_PVOID) pFree);
         }
         else
         {
            if ( !pPrev )
            {
               pPrev = pCurr;
            }

            pCurr = pCurr->pNextFldIndex;
         }
      }

      pG->pWhereFldIndex = pPrev;
   }
   else
   {
      while ( pCurr )
      {
         pFree = pCurr;
         pCurr = pFree->pNextFldIndex;

         if ( pFree->X_DBM_WhereFldsUsed )
         {
            X_PDF_Free_Memory( pX_Ids, pX_NULL, pX_NULL,(X_PVOID) pFree->X_DBM_WhereFldsUsed );
         }

         if ( pFree->X_DBM_WhereFldsIndex )
         {
            X_PDF_Free_Memory( pX_Ids, pX_NULL, pX_NULL,(X_PVOID) pFree->X_DBM_WhereFldsIndex );
         }

         X_PDF_Free_Memory( pX_Ids, pX_NULL, pX_NULL, (X_PVOID)pFree );
      }
   }

   return;
}

#endif


#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_INIT)))

/*===================================================================*/
/* Function     : X_OAM_Output_record_To_File                        */
/* Description  : Unload the table data to a file.                   */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                pFile        - Output file desciptor.              */
/*                                                                   */
/* ================================================================= */

O_BOOL_FUNCTION X_OAM_Output_record_To_File(X_OAM_STANDARD_ARGS, FILE * pFile)
{
   %outputrecord
}

/*===================================================================*/
/* Function     : X_OAM_Unload_Data                                  */
/* Description  : Unload the table data to a file.                   */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Unload_Data(X_OAM_STANDARD_ARGS)
{

   struct X_DBM_FLDINDEX   *pCurr;
   X_LONG   lRecords = 0;
   X_SHORT  i;
   FILE     *pFile;
   X_SQLDA *pSqlda;
   X_SHORT  sSqlda;
   const X_BOOL fCurrent = FALSE;

   if ( X_DBM_RECORD_SIZE > 32767 )
   {
      X_Issue_Message_VChar( pX_Ids, pX_Pro, pX_Fun, pX_Ids->vchStandardMessageFile, "DCM9899", X_TEXT_NOID(925));
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      return;
   }

#if defined(X_DBM_PCOTHER)
   /* Unloading PC Other Files is not supported at the moment     */
   /* Code change required is to use the X_FILE_COLUMN structure  */
   /* rather than the X_FILE_FIELD structure for PC Other Files.  */
   /* Matching code change would be required in Load_Data.        */
   {
      X_Issue_Message_VChar( pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "DCM9899",
                             X_TEXT_NOID(834));
      strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
      return;
   }
#endif

   /* Initialise vchBaseLOBDir to same directory as .dat file */        %iflob
   if ( X_OAM_UNLOAD_LOBS(pX_DBM) )                                     %iflob
   {                                                                    %iflob
      X_BOOL fSucceeded;                                                %iflob
      X_OAM_SET_LOB_BASE_DIR(fSucceeded)                                %iflob
                                                                        %iflob
      if ( !fSucceeded)                                                 %iflob
      {                                                                 %iflob
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);               %iflob
         return;                                                        %iflob
      }                                                                 %iflob
   }                                                                    %iflob

   if ( fHasRRNO )
   {
      /* Set the @@RRNO and @@UPID .....                               */

      pG->dLastRRNO[pG->sFileNo] = 0.0;

#ifdef X_OAM_UPID_REQUIRED
      if ( fHasUPID ) pG->dLastUPID[pG->sFileNo] = 0.0;
#endif
   }

#ifdef X_OAM_SAVE_CURR_RECORD_REQUIRED
   if ( !fHasUPID )
   {
      pG->fLastSaved[pG->sFileNo] = FALSE;
   }
#endif
   /* ------------------------------------------ */
   /* Check if authorised to read the file first */
   /* ------------------------------------------ */

   if (pG->chReadAuthChecked != YES)
   {
      pG->chAuthorised = X_Check_Authority(pX_Ids,
                                           pX_Pro,
                                           pX_Fun,
                                           "%tablexxxx",
                                           "%fulllibxx",
                                           X_OBJECT_TYPE_FILE,
                                           X_OBJECT_AUTH_READ_DATA);
      if (pG->chAuthorised == NO)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0009",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
         strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
         return;
      }
      else
         pG->chReadAuthChecked = YES;
   }

   /* ------------------------------- */
   /* Set current field index pointer */
   /* ------------------------------- */

   X_Search_FldIndex (X_OAM_STANDARD_PARMS);
   pCurr = pG->pCurrFldIndex;

   /* --------------------------------------------------------- */              %iflob
   /* If the flag to unload BLOB/CLOB fields is not  Y, Set LOB */              %iflob
   /* fields to unused so we can set them to their defaults     */              %iflob
   /* --------------------------------------------------------- */              %iflob
   memset(pCurr->X_DBM_FldsUsed,YES,sizeof(pCurr->X_DBM_FldsUsed));             %iflob
   if ( !X_OAM_UNLOAD_LOBS(pX_DBM) )                                            %iflob
   {                                                                            %iflob
      for ( i = 0; i < X_TOTAL_FIELDS; i++ )                                    %iflob
      {                                                                         %iflob
         if ( X_VECTOR_STORED_AS_LOB(pX_Fld,i) ) pCurr->X_DBM_FldsUsed[i] = NO; %iflob
      }                                                                         %iflob
      X_OAM_Set_Defaults(X_OAM_STANDARD_PARMS);                                 %iflob
   }                                                                            %iflob
                                                                                %iflob
   /* ----------------------------------- */
   /* Build the required SELECT statement */
   /* ----------------------------------- */

   strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
   X_OAM_Add_Table_Name(X_OAM_STANDARD_PARMS);

   /* -------------------------------------------- */
   /* Build ORDER BY according to table/index keys */
   /* -------------------------------------------- */

   %orderby

   /* ------------------------------------- */
   /* Prepare the required SELECT statement */
   /* ------------------------------------- */

   pX_Ids->chOAMRqsType = X_VARIANT_SELECT;
   pX_Ids->fX_DBM_PrepareParams = FALSE; /* Because RRN not in SQL */

   X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

   if (pG->lReturnCode != X_DBMS_INFO_OKAY)
   {
      strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
      return;
   }

   if ( X_OAM_UNLOAD_LOBS(pX_DBM) )                                   %iflob
   {                                                                  %iflob
      /* -------------------------------------------- */              %iflob
      /* Copy where and order by to LOB SQL statement */              %iflob
      /* -------------------------------------------- */              %iflob
      %lobfetchinit
   }                                                                  %iflob
                                                                      %iflob
   /* --------------------- */
   /* Get appropriate SQLDA */
   /* --------------------- */
   sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
   if ( sSqlda < 0 ) return;

   /* --------------------------------------------------- */
   /* Open the cursor associated with the prepared SELECT */
   /* --------------------------------------------------- */

   X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, pX_DBM->sCursorID, pSqlda )

   if (pG->lReturnCode != X_DBMS_INFO_OKAY)
   {
      strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
      return;
   }

   /* ------------------------------------ */
   /* Write header information to the file */
   /* ------------------------------------ */

   pFile = fopen(pX_DBM->pvchFile, "w+b");
   fwrite(&X_File_Header, sizeof(X_DATA_FILE_HEADER_EX), 1, pFile);

   for (i = 0; i < X_DBM_FLDMAP_COLUMNS; i++)
   {
      X_SHORT_PLATFORM_TO_NETWORK_ENDIAN(X_Fields[i].sByteLen);
      X_SHORT_PLATFORM_TO_NETWORK_ENDIAN(X_Fields[i].sLength);
      X_SHORT_PLATFORM_TO_NETWORK_ENDIAN(X_Fields[i].sDecimal);
      X_ULONG_PLATFORM_TO_NETWORK_ENDIAN(X_Fields[i].lReserve1);
      X_LONG_PLATFORM_TO_NETWORK_ENDIAN(X_Fields[i].lReserve2);
      X_SHORT_PLATFORM_TO_NETWORK_ENDIAN(*(X_SHORT *)(X_Fields[i].vchReserve3 + 2));
      fwrite(&X_Fields[i], sizeof(X_DATA_FILE_COLUMN_EX), 1, pFile);
   }

   /* ---------------------------------- */
   /* Write record by record to the file */
   /* ---------------------------------- */

   while (1)
   {

      /* ------------------------------- */
      /* Attempt to fetch a matching row */
      /* ------------------------------- */

      X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )

      if ((pG->lFetchCode < X_DBMS_INFO_OKAY) || (pX_Ids->chFatalError == YES))
      {
         strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
         break;
      }

      if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
         break;

      /* ---------------------------------------------- */
      /* Map fields from the Sqlda structure after read */
      /* ---------------------------------------------- */

      X_DBM_OP( lDummyRetcode, X_DBM_MAP_FROM_TABLE_2, (X_PVCHAR) pX_Fld, X_DBM_MAP_SKIP_LOBS, pSqlda )

      if ( fHasRRNO )
      {
         /* --------------------------------- */
         /* Save the @@RRNO and @@UPID fields */
         /* --------------------------------- */

         X_Vec_Get_as_Double(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@RRNOxxxx,
                             &(pG->dLastRRNO[pG->sFileNo]));

#ifdef X_OAM_UPID_REQUIRED
         if ( fHasUPID )
         {
            X_Vec_Get_as_Double(pX_Ids,
                                pX_Pro,
                                pX_Fun,
                                pX_Fld,
                                X_V_%@UPID,
                                &(pG->dLastUPID[pG->sFileNo]));
         }
#endif
      }


   if ( X_OAM_UNLOAD_LOBS(pX_DBM) )                                    %iflob
   {                                                                   %iflob
      X_SHORT rc = 0;                                                  %iflob
      X_VCHAR vchLOBDir[X_MAX_SIZE_LOB_FILE_NAME + 1] = "";            %iflob
      X_TYPE_FLAG chAttrib;                                            %iflob
      PX_LIST_VOID pX_List = pX_NULL;                                  %iflob
      X_SHORT sMsgId;                                                  %iflob
                                                                       %iflob
      %lobfetchfetch
      %lobfetchmap
                                                                       %iflob
      switch ( rc )                                                    %iflob
      {                                                                %iflob
         case -1:                                                      %iflob
            sMsgId = 1038;                                             %iflob
            break;                                                     %iflob
                                                                       %iflob
         case -2:                                                      %iflob
            sMsgId = 1039;                                             %iflob
            break;                                                     %iflob
                                                                       %iflob
         case -3:                                                      %iflob
            sMsgId = 1040;                                             %iflob
            break;                                                     %iflob
      }                                                                %iflob
                                                                       %iflob
      if ( rc < 0 )                                                    %iflob
      {                                                                %iflob
         X_Issue_Message_VChar( pX_Ids,                                %iflob
                                pX_Pro,                                %iflob
                                pX_Fun,                                %iflob
                                pX_Ids->vchStandardMessageFile,        %iflob
                                "DCM9899",                             %iflob
                                X_TEXT_NOID(sMsgId));                  %iflob
      }                                                                %iflob
                                                                       %iflob
      if ( pX_Ids->chFatalError == YES || rc < 0 )                     %iflob
      {                                                                %iflob
         /* Note BIF code closes the cursor(s) */                      %iflob
         return;                                                       %iflob
      }                                                                %iflob
   }                                                                   %iflob

   /* Execute virtual code */                                        %ifvcpjf
                                                                     %ifvcpjf
   X_OAM_Virtual_Code_After_Read(X_OAM_STANDARD_PARMS);              %ifvcpjf
   if (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0)         %ifvcpjf
   {                                                                 %ifvcpjf
      return;                                                        %ifvcpjf
   }                                                                 %ifvcpjf

      /* ----------------------------- */
      /* Write record data to the file */
      /* ----------------------------- */

      if (!X_OAM_Output_record_To_File(X_OAM_STANDARD_PARMS, pFile))
      {
         /* -------------------------------------------- */
         /* Error occurs during writing data to the file */
         /* -------------------------------------------- */

         strcpy(pX_DBM->vchReturnCode, X_DBM_NO_RECORD);
         break;
      }

      lRecords++;
   };

   /* ---------------------------------------------------- */
   /* Close the cursor associated with the prepared SELECT */
   /* ---------------------------------------------------- */

   X_OAM_Cursor_Close_Request(X_OAM_STANDARD_PARMS);

   /* ----------------------------------------------- */
   /* Update the number of records to the output file */
   /* ----------------------------------------------- */

   fseek(pFile, 0, SEEK_SET);
   X_File_Header.lRecords = lRecords;
   X_SHORT_PLATFORM_TO_NETWORK_ENDIAN(X_File_Header.sColumns);
   X_SHORT_PLATFORM_TO_NETWORK_ENDIAN(X_File_Header.sRecordSize);
   X_LONG_PLATFORM_TO_NETWORK_ENDIAN(X_File_Header.lVersion);
   X_LONG_PLATFORM_TO_NETWORK_ENDIAN(X_File_Header.lRecords);
   X_LONG_PLATFORM_TO_NETWORK_ENDIAN(X_File_Header.lBuildNumber);
   X_ULONG_PLATFORM_TO_NETWORK_ENDIAN(X_File_Header.lReserve1);
   X_LONG_PLATFORM_TO_NETWORK_ENDIAN(X_File_Header.lReserve2);
   fwrite(&X_File_Header, sizeof(X_DATA_FILE_HEADER_EX), 1, pFile);

   /* --------------------- */
   /* Close the output file */
   /* --------------------- */

   fclose(pFile);

   return;
}

#endif

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_INIT)))
/*===================================================================*/
/* Function     : X_OAM_Load_Data                                    */
/* Description  : Load data from a file to the table.                */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Load_Data(X_OAM_STANDARD_ARGS)
{
/* Call this macro on return after stacking autocommit flag */
#define X_OAM_LOAD_DATA_CLEANUP(_DELETE) \
   /* Close the file and clear up memory */ \
   fclose(pFile); \
   X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pColumns); \
   X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pvchRecord); \
   X_PDF_Deallocate_Mapping(pX_Ids, pX_NULL, pX_NULL, &pMapping); \
   X_PDF_Deallocate_OamHeader(pX_Ids, pX_NULL, pX_NULL, &pOamHeader); \
   if (pX_VarData) \
   { \
      for (i = 0; i < header.sColumns; i++) \
      { \
         if (pX_VarData[i].ulAllocLen) \
            X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pX_VarData[i].pvBuffer); \
      } \
      X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pX_VarData); \
   } \
   if ( X_PDF_CleanupLOBFilesTree( pX_Ids,pX_Pro,pX_Fun,&pvLOBTree,_DELETE,X_OAM_MISSING_LOB_HANDLING(pX_DBM) ) && _DELETE ) \
   { \
      X_PDF_ChangeFileAttrib( pX_Ids,pX_Pro,pX_Fun,pX_DBM->pvchFile,X_FILE_ATTRIB_READ_WRITE_USER ); \
      X_PDF_DeleteFlatFile( pX_Ids, pX_DBM->pvchFile ); \
   } \
   /* Restore the AutoCommit flag */ \
   pX_DBM->chAutoCommit = chOldAutoCommit; \
   /* Restore the HeavyTransaction flag */ \
   pX_Ids->fHeavyTransaction = fOldHeavyTransaction; \

   struct X_DBM_FLDINDEX   *pCurr;
   X_DATA_FILE_HEADER_EX   header;
   X_DATA_FILE_COLUMN_EX   *pColumns;
   X_DATA_MAPPING_EX       *pMapping;
   X_DATA_OAM_HEADER       *pOamHeader;
   X_PVOID                  pvLOBTree = pX_NULL;

   X_PVCHAR pvchRecord;
   X_CHAR   chOldAutoCommit;
   X_CHAR   chValidationError = NO;
   X_SHORT  i, j, sMapped;
   X_LONG   lDatOffset, lFldOffset, lByteLen;
   FILE     *pFile;
   X_SHORT  sInsertCount;
   X_BOOL   fOldHeavyTransaction;
   X_DATA_X_VAR   *  pX_VarData = pX_NULL;
   X_BOOL   fX_VarFound = FALSE;
   X_BOOL   fContinue = TRUE;
   X_SQLDA *pSqlda;
   X_SHORT  sSqlda = -1;

#if defined(X_DBM_PCOTHER)
   /* Loading PC Other Files is not supported at the moment */
   {
      X_Issue_Message_VChar( pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "DCM9899",
                             X_TEXT_NOID(834));
      strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
      return;
   }
#endif

   /* ---------------------------------------------------- */
   /* Check if authorised to insert rows in the file first */
   /* ---------------------------------------------------- */

   if (pG->chInsertAuthChecked != YES)
   {
      pG->chAuthorised = X_Check_Authority(pX_Ids,
                                           pX_Pro,
                                           pX_Fun,
                                           "%tablexxxx",
                                           "%fulllibxx",
                                           X_OBJECT_TYPE_FILE,
                                           X_OBJECT_AUTH_ADD_DATA);
      if (pG->chAuthorised == NO)
      {
         X_Issue_Message_Vec(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Ids->vchStandardMessageFile,
                             "IOM0011",
                             pX_Fld,
                             2,
                             X_DBM_FilLibVecs);
         strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
         return;
      }
      else
         pG->chInsertAuthChecked = YES;
   }

   /* ------------------------------- */
   /* Set current field index pointer */
   /* ------------------------------- */

   X_Search_FldIndex (X_OAM_STANDARD_PARMS);
   pCurr = pG->pCurrFldIndex;

   /* ----------------------------------- */
   /* Read header information of the file */
   /* ----------------------------------- */

   pFile = fopen(pX_DBM->pvchFile, "rb");
   if (!pFile)
   {
      strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
      return;
   }

   if (!fread(&header, sizeof(X_DATA_FILE_HEADER_EX), 1, pFile))
   {
      strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
      fclose(pFile);
      return;
   }

   X_SHORT_NETWORK_TO_PLATFORM_ENDIAN(header.sColumns);
   X_SHORT_NETWORK_TO_PLATFORM_ENDIAN(header.sRecordSize);
   X_LONG_NETWORK_TO_PLATFORM_ENDIAN(header.lRecords);
   X_LONG_NETWORK_TO_PLATFORM_ENDIAN(header.lVersion);
   X_LONG_NETWORK_TO_PLATFORM_ENDIAN(header.lBuildNumber);
   X_ULONG_PLATFORM_TO_NETWORK_ENDIAN(header.lReserve1);
   X_LONG_NETWORK_TO_PLATFORM_ENDIAN(header.lReserve2);

   if (!X_PDF_IsMappingPossibleEx(pX_Ids, pX_NULL, pX_NULL, &header, X_GetIdentificationPtr, pX_NULL, &pOamHeader))
   {
      fclose(pFile);
      strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
      return;
   }

   if ( header.lVersion == X_DATA_FILE_VERSION_LL2 )
   {
      pX_VarData = X_PDF_Allocate_Memory(pX_Ids, pX_NULL, pX_NULL, header.sColumns * sizeof(X_DATA_X_VAR));
      memset(pX_VarData, 0x00, header.sColumns * sizeof(X_DATA_X_VAR));
   }

   pMapping = X_PDF_Allocate_Mapping(pX_Ids, pX_NULL, pX_NULL, &header);
   if (pX_Ids->chFatalError == YES)
   {
      fclose(pFile);
      strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
      X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pX_VarData);
      X_PDF_Deallocate_OamHeader(pX_Ids, pX_NULL, pX_NULL, &pOamHeader);
      return;
   }
   else if (!pMapping)
   {
      fclose(pFile);
      strcpy(pX_DBM->vchReturnCode, X_DBM_NO_RECORD);
      X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pX_VarData);
      X_PDF_Deallocate_OamHeader(pX_Ids, pX_NULL, pX_NULL, &pOamHeader);
      return;
   }

   pvchRecord = X_PDF_Allocate_Memory(pX_Ids, pX_NULL, pX_NULL, header.sRecordSize);
   if (pX_Ids->chFatalError == YES)
   {
      fclose(pFile);
      strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
      X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pX_VarData);
      X_PDF_Deallocate_Mapping(pX_Ids, pX_NULL, pX_NULL, &pMapping);
      X_PDF_Deallocate_OamHeader(pX_Ids, pX_NULL, pX_NULL, &pOamHeader);
      return;
   }

   pColumns = X_PDF_Allocate_Memory(pX_Ids, pX_NULL, pX_NULL, header.sColumns * sizeof(X_DATA_FILE_COLUMN_EX));
   if (pX_Ids->chFatalError == YES)
   {
      fclose(pFile);
      strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
      X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pvchRecord);
      X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pX_VarData);
      X_PDF_Deallocate_Mapping(pX_Ids, pX_NULL, pX_NULL, &pMapping);
      X_PDF_Deallocate_OamHeader(pX_Ids, pX_NULL, pX_NULL, &pOamHeader);
      return;
   }

   /* Initialise vchBaseLOBDir to same directory as .dat file */        %iflob
   {                                                                    %iflob
      X_BOOL fSucceeded;                                                %iflob
      X_OAM_SET_LOB_BASE_DIR(fSucceeded)                                %iflob
                                                                        %iflob
      if ( !fSucceeded)                                                 %iflob
      {                                                                 %iflob
         fclose(pFile);                                                 %iflob
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);               %iflob
         X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pvchRecord);       %iflob
         X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pX_VarData);       %iflob
         X_PDF_Deallocate_Mapping(pX_Ids, pX_NULL, pX_NULL, &pMapping); %iflob
         X_PDF_Deallocate_OamHeader(pX_Ids, pX_NULL, pX_NULL, &pOamHeader); %iflob
         return;                                                        %iflob
      }                                                                 %iflob
   }                                                                    %iflob

   lDatOffset = 0;
   sMapped = 0;
   for (i = 0; i < header.sColumns; i++)
   {
      fread(pColumns + i, sizeof(X_DATA_FILE_COLUMN_EX), 1, pFile);

      X_SHORT_NETWORK_TO_PLATFORM_ENDIAN(pColumns[i].sByteLen);
      X_SHORT_NETWORK_TO_PLATFORM_ENDIAN(pColumns[i].sLength);
      X_SHORT_NETWORK_TO_PLATFORM_ENDIAN(pColumns[i].sDecimal);
      X_ULONG_PLATFORM_TO_NETWORK_ENDIAN(pColumns[i].lReserve1);
      X_LONG_NETWORK_TO_PLATFORM_ENDIAN(pColumns[i].lReserve2);

      if (pColumns[i].vchReserve3[0])
      {
         pColumns[i].sByteLen = 0;
         X_SHORT_NETWORK_TO_PLATFORM_ENDIAN(*(X_SHORT *)(pColumns[i].vchReserve3 + 2))
         lByteLen = *(X_SHORT *)(pColumns[i].vchReserve3 + 2);
         fX_VarFound = TRUE;
      }
      else
      {
         lByteLen = pColumns[i].sByteLen;
      }

      lFldOffset = 0;
      for (j = 0; j < X_DBM_FLDMAP_COLUMNS; j++)
      {
         if (X_PDF_IsValidMapping(pX_Ids, pX_Pro, pX_Fun, &header, pColumns + i, X_Fields + j))
         {
            pMapping[i].fMapped = TRUE;
            pMapping[i].pOamColumn = X_Fields + j;
            pMapping[i].pDatColumn = pColumns + i;
            pMapping[i].pvchOamBuffer = (X_PVCHAR)(&X_DBM_Current) + lFldOffset;
            pMapping[i].pvchDatBuffer = pvchRecord + lDatOffset;
            if ( (pColumns[i].vchReserve3[0]) && (lByteLen >= sizeof(XFIELDSTATE)))
            {
               pMapping[i].pXFieldState = (XFIELDSTATE *)pMapping[i].pvchDatBuffer;
               pMapping[i].pvchDatBuffer += sizeof(XFIELDSTATE);
            }

            sMapped++;
            break;
         }

         lFldOffset += X_Fields[j].sByteLen;
      }

      lDatOffset += lByteLen;
   }

   if ( (pX_Ids->chFatalError == YES) || (!sMapped))
   {
      fclose(pFile);
      if (pX_Ids->chFatalError == YES)
      {
         strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
      }

      X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pColumns);
      X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pvchRecord);
      X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pX_VarData);
      X_PDF_Deallocate_Mapping(pX_Ids, pX_NULL, pX_NULL, &pMapping);
      X_PDF_Deallocate_OamHeader(pX_Ids, pX_NULL, pX_NULL, &pOamHeader);
      return;
   }

   if (!fX_VarFound)
   {
      X_PDF_Free_Memory(pX_Ids, pX_NULL, pX_NULL, pX_VarData);
      pX_VarData = pX_NULL;
   }

   /* ----------------------- */
   /* Set the AutoCommit flag */
   /* ----------------------- */

   chOldAutoCommit = pX_DBM->chAutoCommit;
   pX_DBM->chAutoCommit = X_DBM_COMMIT_YES;

   /* ------------------------------ */
   /* Set the Heavy Transaction Flag */
   /* ------------------------------ */

   fOldHeavyTransaction = pX_Ids->fHeavyTransaction;
   pX_Ids->fHeavyTransaction = TRUE;

   /* -------------------------------------- */
   /* Copy the required INSERT SQL statement */
   /* -------------------------------------- */

   strcpy(pG->vchSqlStmnt, X_DBM_InsertFlds);
   pX_Ids->chOAMRqsType = X_INVARIANT_INSERT;

   /* ------------------------------------ */
   /* Insert record by record to the table */
   /* ------------------------------------ */

   sInsertCount = 0;
   if ( header.lVersion == X_DATA_FILE_VERSION )
   {
      memset(&X_DBM_Current, 0x00, sizeof(struct X_DBM_FLDMAP));
   }
   else
   {
      %ll2free
      X_Vec_Init_Group(pX_Ids, pX_Pro, pX_Fun, pX_Fld, X_TOTAL_FIELDS, sX_FldVecs);
   }

   while (1)
   {
      fread(pvchRecord, header.sRecordSize, 1, pFile);
      if (feof(pFile))
         break;

      if (fX_VarFound)
      {
         for (i = 0; i < header.sColumns; i++)
         {
            if (pColumns[i].lReserve1)
            {
               fread(&(pX_VarData[i].ulCurrLen), sizeof(X_ULONG), 1, pFile);
               if (feof(pFile))
               {
                  fContinue = FALSE;
                  break;
               }

               if (pX_VarData[i].ulCurrLen > 0)
               {
                  X_ULONG_NETWORK_TO_PLATFORM_ENDIAN(pX_VarData[i].ulCurrLen);

                  if (pX_VarData[i].ulCurrLen > pColumns[i].lReserve1)
                  {
                     strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
                     fContinue = FALSE;
                     break;
                  }

                  if (pMapping[i].fMapped)
                  {
                     if (!pX_VarData[i].ulAllocLen)
                     {
                        pX_VarData[i].ulAllocLen = pX_VarData[i].ulCurrLen + 1;
                        pX_VarData[i].pvBuffer = X_PDF_Allocate_Memory(pX_Ids, pX_NULL, pX_NULL, pX_VarData[i].ulAllocLen);
                     }
                     else if (pX_VarData[i].ulCurrLen >= pX_VarData[i].ulAllocLen)
                     {
                        pX_VarData[i].ulAllocLen = pX_VarData[i].ulCurrLen + 1;
                        pX_VarData[i].pvBuffer = X_PDF_ReAllocate_Memory(pX_Ids, pX_NULL, pX_NULL, pX_VarData[i].pvBuffer, pX_VarData[i].ulAllocLen);
                     }

                     fread(pX_VarData[i].pvBuffer, pX_VarData[i].ulCurrLen, 1, pFile);
                     if (feof(pFile))
                     {
                        fContinue = FALSE;
                        break;
                     }
                  }
                  else
                  {
                     fseek(pFile, pX_VarData[i].ulCurrLen, SEEK_CUR);
                  }
               }
            }
         }

         if (!fContinue)
            break;
      }

      /* ---------------------------- */
      /* Map file data and field data */
      /* ---------------------------- */

      X_PDF_ConvertMappedData_2(pX_Ids, pX_Pro, pX_Fun, &header, (X_DATA_MAPPING *)pMapping, pX_VarData, header.sColumns, pOamHeader); %ifnlob
      if ( !X_PDF_ConvertMappedData_3(pX_Ids, pX_Pro, pX_Fun, &header, (X_DATA_MAPPING *)pMapping, pX_VarData, header.sColumns, pOamHeader, vchBaseLOBDir, &pvLOBTree, X_OAM_MISSING_LOB_HANDLING(pX_DBM) ) ) %iflob
      {                                                                                   %iflob
         strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);                                %iflob
         X_OAM_LOAD_DATA_CLEANUP(FALSE)                                                   %iflob
         return;                                                                          %iflob
      }                                                                                   %iflob

      /* ----------------------------- */
      /* Perform any validation checks */
      /* ----------------------------- */

      if (pX_DBM->chTrigger == YES)
      {
         X_OAM_Validation_Checks(X_OAM_STANDARD_PARMS,
                                 X_DBM_INSERT_OPERATION);
         if (strcmp(pX_DBM->vchReturnCode, X_DBM_VALIDATION_ERROR) == 0)
         {
            chValidationError = YES;
            break;
         }
      }

      /* ------------------------- */                                   %intrig
      /* Run before insert trigger */                                   %intrig
      /* ------------------------- */                                   %intrig
                                                                        %intrig
      if (pX_DBM->chTrigger == YES)                                     %intrig
      {                                                                 %intrig
         strcpy(pG->X_Trigger.vchOper, "BEFINS");                       %intrig
                                                                        %intrig
         %RUNFT *BEFINS1
      }                                                                 %intrig

      if (sInsertCount == 0)
      {
         /* ------------------------------------- */
         /* Prepare the required INSERT statement */
         /* ------------------------------------- */

         AVOID_JOURNALING(pG->vchSqlStmnt) /* Always, regardless of whether file */
                                           /* is under commitment control.       */

         X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
            break;
         }

         /* --------------------- */
         /* Get appropriate SQLDA */
         /* --------------------- */
         sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_INSERT,TRUE);

         if ( sSqlda < 0 )
         {
            X_OAM_LOAD_DATA_CLEANUP(FALSE)
            return;
         }
      }

      /* Note: Further work reqiured to allow inserting of identity columns */
      /*       as other tables may have this value as a foreign key.        */
      if ( fHasRRNO )
      {
         if ( fHasUPID )
         {
            X_Vec_Set_from_Double(pX_Ids,
                                  pX_Pro,
                                  pX_Fun,
                                  pX_Fld,
                                  X_V_%@UPID,
                                  1.0);
         }

         if ( !fAutoRRN )
         {
            /* -------------------------------- */
            /* Set the @@RRNO and @@UPID fields */
            /* -------------------------------- */

            X_PDF_Get_RRNO_2(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@RRNOxxxx,
                             %qtablexxxxx,
                             (X_CHAR)(X_DBM_V4_OR_LATER ? pX_DBM->chSystem : NO));

            if (pX_Ids->chFatalError == YES)
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
               return;
            }

            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) (X_TOTAL_REAL_FIELDS - 1), 0, pSqlda )
         }
         else
         {
            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) (X_TOTAL_REAL_FIELDS - 2), 0, pSqlda )
         }
      }
      else
      {
#if defined(X_DBM_IDENTITY_COLUMN)
         /* Skip mapping the last field (identity column) */
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) (X_TOTAL_REAL_FIELDS - 1), 0, pSqlda )
#else
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_TOTAL_REAL_FIELDS, 0, pSqlda )
#endif
      }

      /* ------------------------------------------------------ */
      /* Map fields to the Sqlda structure before actual insert */
      /* ------------------------------------------------------ */

      if ( fAutoRRN || fIdentity)
      {
         X_DBM_OP( lDummyRetcode, X_DBM_MAP_TO_TABLE_NO_RRNO, (X_PVCHAR) pX_Fld, 0, pSqlda )
      }
      else
      {
         X_DBM_OP( lDummyRetcode, X_DBM_MAP_TO_TABLE_2, (X_PVCHAR) pX_Fld, 0, pSqlda )
      }

      /* ---------------------------------------------------------------------- */       %iflob
      /* Map additional LOB columns to the Sqlda structure before actual insert */       %iflob
      /* ---------------------------------------------------------------------- */       %iflob
                                                                                         %iflob
      if ( fHasRRNO )                                                                    %iflob
      {                                                                                  %iflob
         if ( !fAutoRRN )                                                                %iflob
         {                                                                               %iflob
            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) (X_TOTAL_REAL_FIELDS + X_TOTAL_ADDITIONAL_LOB_COLS - 1), 0, pSqlda ) %iflob
         }                                                                               %iflob
         else                                                                            %iflob
         {                                                                               %iflob
            X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) (X_TOTAL_REAL_FIELDS + X_TOTAL_ADDITIONAL_LOB_COLS - 2), 0, pSqlda ) %iflob
         }                                                                               %iflob
      }                                                                                  %iflob
#if defined(X_DBM_IDENTITY_COLUMN)                                                       %iflob
      else                                                                               %iflob
         /* Skip mapping the last field (identity column) */                             %iflob
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) (X_TOTAL_REAL_FIELDS + X_TOTAL_ADDITIONAL_LOB_COLS - 1), 0, pSqlda ) %iflob
#else                                                                                    %iflob
      else                                                                               %iflob
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_TOTAL_REAL_FIELDS + X_TOTAL_ADDITIONAL_LOB_COLS , 0, pSqlda ) %iflob
#endif                                                                                   %iflob
      %lobinsert
                                                                                         %iflob
      if ( pX_Ids->chFatalError == YES )                                                 %iflob
      {                                                                                  %iflob
         X_OAM_LOAD_DATA_CLEANUP(FALSE)                                                  %iflob
         return;                                                                         %iflob
      }                                                                                  %iflob

      /* ------------------------------------- */
      /* Execute the prepared INSERT statement */
      /* ------------------------------------- */

         X_DBM_OP( pG->lReturnCode, X_DBM_EXECUTE, pX_NULL, pX_DBM->sCursorID, pSqlda )

         /* Always set SQLDANo back to default */
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )

      /* ---------------------------------------- */
      /* Duplicate row is a validation error only */
      /* ---------------------------------------- */

      if ( X_DBMS_INFO_IS_DUPLICATE_ROW(pG->lReturnCode) )
      {
         if (pX_DBM->chDuplicate != YES)
         {
            X_Issue_Message_Vec(pX_Ids,
                                pX_Pro,
                                pX_Fun,
                                pX_Ids->vchStandardMessageFile,
                                "IOM0025",
                                pX_Fld,
                                2,
                                X_DBM_FilLibVecs);

            chValidationError = YES;
            break;
         }
      }
      else if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR);
         break;
      }

      strcpy(pX_DBM->vchReturnCode, X_DBM_OKAY);
      sInsertCount++;

      if ( fHasRRNO )
      {

         /* --------------------------------- */
         /* Save the @@RRNO and @@UPID fields */
         /* --------------------------------- */

         X_Vec_Get_as_Double(pX_Ids,
                             pX_Pro,
                             pX_Fun,
                             pX_Fld,
                             X_V_%@RRNOxxxx,
                             &(pG->dLastRRNO[pG->sFileNo]));
#ifdef X_OAM_UPID_REQUIRED
         if ( fHasUPID )
            X_Vec_Get_as_Double(pX_Ids,
                                pX_Pro,
                                pX_Fun,
                                pX_Fld,
                                X_V_%@UPID,
                                &(pG->dLastUPID[pG->sFileNo]));
#endif
      }

      /* --------------------------- */                                 %ifbch
      /* Execute batch control logic */                                 %ifbch
      /* --------------------------- */                                 %ifbch
                                                                        %ifbch
      if (pX_DBM->chTrigger == YES)                                     %ifbch
      {                                                                 %ifbch
         X_OAM_Update_Batch_Control(X_OAM_STANDARD_PARMS,               %ifbch
                                    X_DBM_INSERT_OPERATION);            %ifbch
         if (strcmp(pX_DBM->vchReturnCode, X_DBM_FATAL_ERROR) == 0)     %ifbch
            break;                                                      %ifbch
      }                                                                 %ifbch
                                                                        %ifbch
      /* ------------------------- */
      /* Issue the database COMMIT */
      /* ------------------------- */

      if ( (sInsertCount % COMMIT_LEVEL) == 0 )
      {
         sInsertCount = 0;
         pX_Ids->fHeavyTransaction = FALSE;
         if ( !(X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS)) ) break;
         pX_Ids->fHeavyTransaction = TRUE;
      }

      /* ------------------------ */                                    %intrig
      /* Run after insert trigger */                                    %intrig
      /* ------------------------ */                                    %intrig
                                                                        %intrig
      if (pX_DBM->chTrigger == YES)                                     %intrig
      {                                                                 %intrig
         strcpy(pG->X_Trigger.vchOper,"AFTINS");                        %intrig
                                                                        %intrig
         %RUNFT *AFTINS1
      }                                                                 %intrig
   } /* end while */

   /* ----------------------------------------------- */
   /* Issue the database COMMIT -- for any extra rows */
   /* ----------------------------------------------- */

   if ( sInsertCount >= 1 )
   {
      pX_Ids->fHeavyTransaction = FALSE;
      X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS);
   }

   /* ------------------------ */
   /* Set the validation error */
   /* ------------------------ */

   if (chValidationError == YES)
      strcpy(pX_DBM->vchReturnCode, X_DBM_VALIDATION_ERROR);

   /* If successful, and option is true, cleanup files */
   if ( X_OAM_LOAD_CLEANUP(pX_DBM) && 
        (strcmp(pX_DBM->vchReturnCode,X_DBM_OKAY) == 0) &&
        pX_Ids->chFatalError == NO )
   {
      X_OAM_LOAD_DATA_CLEANUP(TRUE)
   }
   else
   {
      X_OAM_LOAD_DATA_CLEANUP(FALSE)
   }

   return;
#undef X_OAM_LOAD_DATA_CLEANUP
}


#endif

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_INIT)))
/*===================================================================*/
/* Function     : X_OAM_Setup_Sqlda                                  */
/* Description  : Returns an index to an allocated SQLDA appropriate */
/*                for the caller. Should be called after PREPARE to  */
/*                store a valid cursor ID.                           */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                ppSqlda      - will be set to point to aSqlda[i]   */
/*                chType       - see x_dbmstr.h                      */
/*                fAllowMain   - set to TRUE except where we know a  */
/*                               second SQLDA is required for any    */
/*                               database category.                  */
/*                                                                   */
/* Returns:       index in aSqlda[] or -1 if no free SQLDA entries   */ 
/*                                                                   */
/* ================================================================= */

O_SHORT_FUNCTION X_OAM_Setup_Sqlda(X_OAM_STANDARD_ARGS,
                                  X_SQLDA **ppSqlda,
                                  X_TYPE_FLAG chType,
                                  X_BOOL fAllowMain)
{
   X_SHORT i;

   /* If initial entry is not allocated, allocate now. */
   if ( pG->aSqlda[0].chType == LOVAL )
   {
      strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
      strcat( pG->vchSqlStmnt, X_DBM_SqlTableName );

      X_DBM_OP( pG->lReturnCode, X_DBM_ALLOCATE_SQLDA, pG->vchSqlStmnt, FALSE, &(pG->aSqlda[0].pSqlda) ) %ifnRDMLX_File
      X_DBM_OP( pG->lReturnCode, X_DBM_ALLOCATE_SQLDA, pG->vchSqlStmnt, TRUE,  &(pG->aSqlda[0].pSqlda) ) %ifRDMLX_File

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pX_Ids->lLastErrorCode = pG->lReturnCode;
         return -1;
      }

      pG->aSqlda[0].chType = ( fIdentity || fAutoRRN ) ? X_SQLDA_SEL_DEL : X_SQLDA_ANY;
   }
   
   /* In simple case, just allow main SQLDA to be used */
   if ( fAllowMain && 
        ((chType == X_SQLDA_SEL_DEL) ||
        (pG->aSqlda[0].chType == X_SQLDA_ANY)) )                                  %ifnlob
        ((pG->aSqlda[0].chType == X_SQLDA_ANY) && (chType != X_SQLDA_INSERT))) )  %iflob
   {
      i = 0;
   }
   else
   {
      /* Now loop through the rest of the SQLDA and find the right one to use */
      for ( i = 1; i < pG->usMaxSqlda; i++ )
      {
         if ( pG->aSqlda[i].chType == LOVAL ||
              pG->aSqlda[i].chType == chType ||
              pG->aSqlda[i].chType == X_SQLDA_ANY ||                              %ifnlob
              (pG->aSqlda[i].chType == X_SQLDA_INS_UPD &&                         %ifnlob
               (chType == X_SQLDA_INSERT || chType == X_SQLDA_UPDATE)) )          %ifnlob
               /* With LOBs, X_SQLDA_ANY cannot be used for Insert */             %iflob
              (pG->aSqlda[i].chType == X_SQLDA_ANY && chType != X_SQLDA_INSERT) ) %iflob
         {
            break;
         }
      } /* end for */
   }

   if ( i >= pG->usMaxSqlda )
   {
      X_Fatal_Error(pX_Ids,
                    pX_Pro,
                    pX_Fun,
                    "OAM for table %tablexxxx",
                    "No appropriate SQLDA entry found. Database Request: %d. SQLDA Type: %c",
                    pX_DBM->sDBMRequest,
                    chType);
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      return -1;
   }

   /* Set the type if it was LOVAL */
   if ( pG->aSqlda[i].chType == LOVAL )
   {
      /* When identity/autorrn, a separate SQLDA must be used for insert/update and select/delete */
      /* When LOBS are involved, a separate SQLDA must always be used for INSERT */

      /* Two possible types of SQLDA if identity/rrn: SEL_DEL, INS_UPD */ %ifnlob
      /* One type of SQLDA if not identity/rrn: ANY                    */ %ifnlob
      if ( fIdentity || fAutoRRN )                                        %ifnlob
      {                                                                   %ifnlob
         switch (chType)                                                  %ifnlob
         {                                                                %ifnlob
            case X_SQLDA_INSERT:                                          %ifnlob
            case X_SQLDA_UPDATE:                                          %ifnlob
               pG->aSqlda[i].chType = X_SQLDA_INS_UPD;                    %ifnlob
               break;                                                     %ifnlob
                                                                          %ifnlob
            default:                                                      %ifnlob
               pG->aSqlda[i].chType = chType;                             %ifnlob
               break;                                                     %ifnlob
         }                                                                %ifnlob
      }                                                                   %ifnlob
      else                                                                %ifnlob
      {                                                                   %ifnlob
         pG->aSqlda[i].chType = X_SQLDA_ANY;                              %ifnlob
      }                                                                   %ifnlob
      /* Three possible types of SQLDA if identity/rrn: SEL_DEL, INSERT, UPDATE */ %iflob
      /* Two possible types of SQLDA if not identity/rrn: ANY, INSERT           */ %iflob
      if ( fIdentity || fAutoRRN || (chType == X_SQLDA_INSERT) )                   %iflob
      {                                                                            %iflob
         pG->aSqlda[i].chType = chType;                                            %iflob
      }                                                                            %iflob
      else                                                                         %iflob 
      {                                                                            %iflob
         pG->aSqlda[i].chType = X_SQLDA_ANY;                                       %iflob
      }                                                                            %iflob
   }

   /* Allocate the SQLDA on the fly if necessary */
   if ( !(pG->aSqlda[i].pSqlda) )
   {
      switch ( pG->aSqlda[i].chType )
      {
         case X_SQLDA_ANY:     /* Occurs if !( fIdentity || fAutoRRN ) */
         case X_SQLDA_SEL_DEL: /* Only occurs if ( fIdentity || fAutoRRN ), see above */
            strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
            strcat( pG->vchSqlStmnt, X_DBM_SqlTableName );
            break;

         case X_SQLDA_INSERT:  /* Occurs if LOBs, see above */
         case X_SQLDA_INS_UPD: /* Only occurs if ( fIdentity || fAutoRRN ), see above */
            strcpy(pG->vchSqlStmnt, X_DBM_InsertSelectFlds);
            break;

         case X_SQLDA_UPDATE: /* Only occurs if ( fIdentity || fAutoRRN ), see above */  %iflob
            strcpy(pG->vchSqlStmnt, X_DBM_UpdateSelectFlds);                             %iflob
            break;                                                                       %iflob
                                                                                         %iflob
         default:
            X_Fatal_Error(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          "OAM for table %tablexxxx",
                          "Invalid SQLDA type: %c",
                          pG->aSqlda[i].chType);
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            return -1;
      }

      if ( pG->aSqlda[i].chType != X_SQLDA_INSERT )                                          %iflob
      {
         X_DBM_OP( pG->lReturnCode, X_DBM_ALLOCATE_SQLDA, pG->vchSqlStmnt, FALSE, &(pG->aSqlda[i].pSqlda) ) %ifnRDMLX_File
         X_DBM_OP( pG->lReturnCode, X_DBM_ALLOCATE_SQLDA, pG->vchSqlStmnt, TRUE,  &(pG->aSqlda[i].pSqlda) ) %ifRDMLX_File
      }
      else                                                                                   %iflob
      {                                                                                      %iflob
         X_DBM_ALLOC_SQLDA_2_PARMS AllocSqldaParms;                                          %iflob
         AllocSqldaParms.pvchSqlStmnt = pG->vchSqlStmnt;                                     %iflob
         AllocSqldaParms.ppSqlda      = &(pG->aSqlda[i].pSqlda);                             %iflob
         AllocSqldaParms.fRDMLXFile   = TRUE; /* Always true if LOB fields */                %iflob
         AllocSqldaParms.scLOBColumns = X_TOTAL_REAL_FIELDS - X_TOTAL_REAL_NON_LOB_FIELDS;   %iflob
         AllocSqldaParms.psLOBColumns = X_DBM_InsertLOBColumns;                              %iflob
         X_DBM_OP( pG->lReturnCode, X_DBM_ALLOCATE_SQLDA_2, pX_NULL, 0, &AllocSqldaParms );  %iflob
      }                                                                                      %iflob

      if (pG->lReturnCode != X_DBMS_INFO_OKAY)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         pG->aSqlda[i].pSqlda = pX_NULL;
         return -1;
      }
   }

   *ppSqlda = pG->aSqlda[i].pSqlda;
   return i;
}

#endif

#if defined(X_OAM_HAS_LOB_SUPPORT)
#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_INIT)))
/*===================================================================*/
/* Function     : X_OAM_Update_LOB_Field                             */
/* Description  : Returns an index to an allocated SQLDA appropriate */
/*                for the caller. Should be called after PREPARE to  */
/*                store a valid cursor ID.                           */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                ppSqlda      - SQLDA for LOB field access          */
/*                sRequest     - X_DBM_UPDATE or X_DBM_UPDATE_NEXT   */
/*                                                                   */
/* Returns:       index in aSqlda[] or -1 if no free SQLDA entries   */ 
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Update_LOB_Field(X_OAM_STANDARD_ARGS,
                                       X_PVCHAR pvchUpdateStmnt, 
                                       X_SHORT  sVec,
                                       X_PVCHAR pvchField,
                                       X_PVCHAR pvchFileCol,
                                       X_PVCHAR pvchTstampCol,
                                       X_SQLDA *pSqlda,
                                       X_SHORT  sDBMRequest)
{
   X_SHORT  sCursorID;
   X_VCHAR  vchString[(X_MAX_UPID_FIELD_LEN * 2) + 2 + 1];
   X_PVCHAR pvchRRNO = X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_RRN );
   X_LONG   lRowCount;
   X_SHORT  rc;
   X_PVCHAR pvchTemp;
   X_DBM_MAP_FLD_PARMS MapFldParms;
   X_LONG              lDummyRetcode;
   X_SHORT  sFileCol = 0;
   X_SHORT  sLOBCol  = (pvchFileCol ? 1 : 0);
   X_SHORT  sSqlda;

   /* --------------------------- */
   /* Create the UPDATE statement */
   /* --------------------------- */
   strcpy( pG->vchLOBSqlStmnt, pvchUpdateStmnt );

   pX_Ids->chOAMRqsType = X_VARIANT_UPDATE;

   X_OAM_Add_Where_for_Current(X_OAM_STANDARD_PARMS, pG->vchLOBSqlStmnt, TRUE);
   if ( strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0 ) return;

#ifdef X_OAM_UPID_REQUIRED
   if ( fHasUPID )
   {
      /* Append the UPID (must be done before UPID is incremented) */

      X_Set_Vchar_from_Double(pX_Ids,pX_Pro,pX_Fun,pG->dThisUPID,vchString,
                              sizeof(vchString),X_L_X_UPID,X_D_X_UPID);

      sprintf(pG->vchLOBSqlStmnt + strlen(pG->vchLOBSqlStmnt),
              " AND %s = %s",X_DBM_UPIDNativeName,vchString);

      /* Increment @@UPID before update - This is deliberate as        */
      /* crossed updates can occur btn main & LOB updates.             */
      /* Assumes we can re-read rows we have written but not committed */

      pG->dThisUPID++;
      X_Vec_Set_from_Double(pX_Ids,
                            pX_Pro,
                            pX_Fun,
                            pX_Fld,
                            X_V_%@UPID,
                            pG->dThisUPID);

      /* ------------------------------ */
      /* Map data to appropriate column */
      /* ------------------------------ */
      MapFldParms.sSource = X_V_X_UPID;  /* Source Field */
      MapFldParms.sTarget = 0;           /* Target column */
      MapFldParms.pSqlda  = pSqlda;
      MapFldParms.pX_Fld  = pX_Fld;
      X_DBM_OP( lDummyRetcode, X_DBM_MAP_SINGLE_FLD_TO_TABLE, pX_NULL, 0, &MapFldParms);

      if ( pX_Ids->chFatalError == YES )
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }

      sFileCol++;
      sLOBCol++;
   }
#endif

   /* ------------------------------------- */
   /* Prepare the required UPDATE statement */
   /* ------------------------------------- */

   AVOID_JOURNALING(pG->vchLOBSqlStmnt)                           %ifncmt

   X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchLOBSqlStmnt, 0, &(sCursorID) )

   if (pG->lReturnCode != X_DBMS_INFO_OKAY)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lReturnCode;
      return;
   }

   /* --------------------------------------------------------- */
   /* Map LOB field to the Sqlda structure before actual update */
   /* --------------------------------------------------------- */
   MapFldParms.sSource = sVec;  /* Source Field */
   MapFldParms.sTarget = sLOBCol;           /* Target column */
   MapFldParms.pSqlda  = pSqlda;
   MapFldParms.pX_Fld  = pX_Fld;
   X_DBM_OP( lDummyRetcode, X_DBM_MAP_SINGLE_FLD_TO_TABLE, pX_NULL, 0, &MapFldParms);

   if ( pX_Ids->chFatalError == YES )
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      X_DBM_OP( pG->lReturnCode, X_DBM_FREE_STATEMENT, pX_NULL, sCursorID, pX_NULL );
      return;
   }

   /* --------------------------------------------------------------------------- */
   /* Generate where condition to exclude the existing row from filename checking */
   /* --------------------------------------------------------------------------- */
   if ( fHasRRNO )
   {
      X_Set_Vchar_from_Double(pX_Ids,pX_Pro,pX_Fun,pG->dLastRRNO[pG->sFileNo],vchString,
                              sizeof(vchString),15,0);

      sprintf(pG->vchLOBSqlStmnt, "%s <> %s", pvchRRNO, vchString);
   }
#ifdef X_OAM_REPLACE_RRN_WITH_PKEY_REQUIRED
   else
   {
      pG->vchLOBSqlStmnt[0] = END_OF_STRING;
      X_OAM_Build_Primary_Key_Where(X_OAM_STANDARD_PARMS,FALSE,TRUE,FALSE);
   }
#endif

   /* Only call X_Map_LOB_To_DBM for (Other) files with additional LOB columns */
   if ( pvchFileCol )
   {
      /* Map additional columns (filename, timestamp) to SQLDA */
      rc = X_Map_LOB_To_DBM( pX_Ids,pX_Pro,pX_Fun,pX_Fld,pX_DBM,pSqlda,pG->pvchTable,sVec,sFileCol,pvchFileCol,V_NOT_AVAILABLE,pvchTstampCol,pX_NULL,X_File_Header.vchTable,pvchField,pG->vchLOBSqlStmnt);

      if ( rc != 0 )
      {
         X_VCHAR vchField[X_OBJECT_NAME_LEN + 1];
         X_VCHAR  vchMesgId[X_MESSAGE_ID_LEN + 1];
         X_PVCHAR avchParms[4];

                                                                                                                                                                                                                                                                                                         
         strncpy(vchField,pX_Fld[sVec].fchName2,X_OBJECT_NAME_LEN);
         vchField[X_OBJECT_NAME_LEN] = END_OF_STRING;
         avchParms[0] = vchField;
         avchParms[1] = ErrTxt1;
         avchParms[2] = ErrTxt2;
         avchParms[3] = ((X_FLD_BLOB *)(pX_Fld[sVec].pField))->vchFileName;
                                                                                                                                                                                                                                                                                                         
         switch ( rc )
         {
            case -1:
               strcpy(vchMesgId,"IOM0048");
               break;
            case -2:
               strcpy(vchMesgId,"IOM0049");
               break;
            default:
               vchMesgId[0] = END_OF_STRING;
         } /* end switch */
                                                                                                                                                                                                                                                                                                         
         if ( vchMesgId[0] )
         {
            X_Issue_Message_VChar_Ptrs( pX_Ids, pX_Pro, pX_Fun, pX_Ids->vchStandardMessageFile, vchMesgId, 4, avchParms );
         }

         /* Because the UPDATE to the main file has already been processed, change VE to ER */
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);

         X_DBM_OP( pG->lReturnCode, X_DBM_FREE_STATEMENT, pX_NULL, sCursorID, pX_NULL );

         return;
      }
   }

   /* Execute the prepared UPDATE statement */

   X_DBM_OP( pG->lReturnCode, X_DBM_EXECUTE_ROWCOUNT, (X_PVCHAR) (&lRowCount), sCursorID, pSqlda )

   if ( X_DBMS_INFO_IS_DUPLICATE_ROW(pG->lReturnCode) )
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
      X_Issue_Message_Vec(pX_Ids,
                          pX_Pro,
                          pX_Fun,
                          pX_Ids->vchStandardMessageFile,
                          "IOM0025",
                          pX_Fld,
                          2,
                          X_DBM_FilLibVecs);

      X_OAM_Perform_Commit(X_OAM_STANDARD_PARMS);
      return;
   }

   if (pG->lReturnCode != X_DBMS_INFO_OKAY)
   {
      strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
      pX_Ids->lLastErrorCode = pG->lReturnCode;
      return;
   }

   /* If no rows updated, determine whether row deleted or updated */
   /* Processing varies for X_DBM_UPDATE or X_DBM_UPDATE_NEXT -    */
   /* If UPDATE_NEXT, not a problem if rows are missing.           */
   if (lRowCount < 1)
   {
      if ( !fHasUPID ) /* When updating without UPID, row must have been deleted */
      {
         if ( sDBMRequest == X_DBM_UPDATE )
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
            X_Issue_Message_Vec(pX_Ids,
                                pX_Pro,
                                pX_Fun,
                                pX_Ids->vchStandardMessageFile,
                                "IOM0016",
                                pX_Fld,
                                2,
                                X_DBM_FilLibVecs);
         }
      }
      else
      {
         /* Build the required SELECT statement using the RRNO */

         strcpy( pG->vchSqlStmnt, X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_SELECT ) );
#ifdef X_DATABASE_ORACLE
         sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = :0", X_DBM_SqlTableName, pvchRRNO );
#else
         sprintf( pG->vchSqlStmnt + strlen(pG->vchSqlStmnt),"%s WHERE %s = ?", X_DBM_SqlTableName, pvchRRNO );
#endif

        /* Prepare the required SELECT statement */

         pX_Ids->chOAMRqsType = X_INVARIANT_SELECT;

         X_DBM_OP( pG->lReturnCode, X_DBM_PREPARE_STMNT, pG->vchSqlStmnt, 0, &(pX_DBM->sCursorID) )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }

         /* --------------------- */
         /* Get appropriate SQLDA */
         /* --------------------- */
         sSqlda = X_OAM_Setup_Sqlda(X_OAM_STANDARD_PARMS,&pSqlda,X_SQLDA_SEL_DEL,TRUE);
         if ( sSqlda < 0 ) return;

         /* Open the cursor associated with the prepared SELECT */

         /* Only one column to be processed (RRNO) */
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) 1, 0, pSqlda )

         InsertRRNParms.xdVal  = pG->dLastRRNO[pG->sFileNo];
         InsertRRNParms.pSqlda = pSqlda;
         InsertRRNParms.pX_Fld = pX_Fld;
         X_DBM_OP( lDummyRetcode, X_DBM_INSERT_RRN, pX_NULL, 0, &InsertRRNParms )


#ifdef X_DATABASE_ODBC
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )
#endif

         X_DBM_OP( pG->lReturnCode, X_DBM_OPEN_CURSOR, pX_NULL, pX_DBM->sCursorID, pSqlda )

         /* Always set SQLDANo back to default for fetch */
         X_DBM_OP( lDummyRetcode, X_DBM_SET_SQLDA_NO, (X_PVCHAR) X_RESET_SQLDA_NO, 0, pSqlda )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }

         /* Attempt to fetch a matching row */

         X_DBM_OP( pG->lFetchCode, X_DBM_FETCH_ROW, pX_NULL, pX_DBM->sCursorID, pSqlda )

         if ((pG->lFetchCode < X_DBMS_INFO_OKAY)
             || (pX_Ids->chFatalError == YES))
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lFetchCode;
         }

         /* If the record is no longer present */

         else if (pG->lFetchCode == X_DBMS_INFO_ROW_NOT_FOUND)
         {
            if ( sDBMRequest == X_DBM_UPDATE )
            {
               strcpy(pX_DBM->vchReturnCode,X_DBM_NO_RECORD);
               X_Issue_Message_Vec(pX_Ids,
                                   pX_Pro,
                                   pX_Fun,
                                   pX_Ids->vchStandardMessageFile,
                                   "IOM0016",
                                   pX_Fld,
                                   2,
                                   X_DBM_FilLibVecs);
            }
         }
         /* Close the cursor associated with the prepared SELECT */

         X_DBM_OP( pG->lReturnCode, X_DBM_CLOSE_CURSOR, pX_NULL, pX_DBM->sCursorID, pX_NULL )

         if (pG->lReturnCode != X_DBMS_INFO_OKAY)
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
            pX_Ids->lLastErrorCode = pG->lReturnCode;
            return;
         }

         if ((strcmp(pX_DBM->vchReturnCode,X_DBM_NO_RECORD) == 0)
             || (strcmp(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR) == 0))
            return;

         /* If we get this far, we've had a crossed update */
         {
            strcpy(pX_DBM->vchReturnCode,X_DBM_VALIDATION_ERROR);
            X_Issue_Message_Vec(pX_Ids,
                                pX_Pro,
                                pX_Fun,
                                pX_Ids->vchStandardMessageFile,
                                "IOM0017",
                                pX_Fld,
                                2,
                                X_DBM_FilLibVecs);

            return;
         }
      } /* endif !fHasUPID */
   } /* if no rows updated */

   return;
}
#endif
#endif

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_INIT)))
/*===================================================================*/
/* Function     : X_OAM_Add_Where_for_Current                        */
/* Description  : Populates the buffer with "WHERE @@RRNO = %s" or   */
/*                primary key details.                               */
/*                                                                   */
/* Arguments    : pX_Ids       - standard system def. structure      */
/*                pX_Pro       - standard process defn. structure    */
/*                pX_Fun       - standard function defn. structure   */
/*                pX_Fld       - standard field defn. structure      */
/*                pX_DBM       - standard DBM defn. structure        */
/*                pG           - standard global info. structure     */
/*                pvchBuffer   - Buffer to add where clause to.      */
/*                fLast        - True to use pG->dLastRRNO,          */
/*                               False to use current (X_V_X_RRNO).  */
/*                                                                   */
/* ================================================================= */

O_VOID_FUNCTION X_OAM_Add_Where_for_Current(X_OAM_STANDARD_ARGS,
                                            X_PVCHAR pvchBuffer,
                                            X_BOOL fLast)
{
   X_VCHAR  vchString[(X_MAX_UPID_FIELD_LEN * 2) + 2 + 1];
   X_PVCHAR pvchRRNO = X_OAM_Get_Updated_Stmnt( X_OAM_STANDARD_PARMS, GET_STMNT_RRN );
   
   if ( fHasRRNO )
   {
      if ( fLast )
      {
         X_Set_Vchar_from_Double(pX_Ids,pX_Pro,pX_Fun,pG->dLastRRNO[pG->sFileNo],vchString,
                                 sizeof(vchString),15,0);
      }
      else
      {
         X_SHORT sRetLength;

/* If identity column and Create RRNO unchecked, there is no X_V_X_RRNO */
/* In this case, we need to use the identity column instead.            */

         X_Vec_Get_as_String( pX_Ids,
                              pX_Pro,
                              pX_Fun,
                              pX_Fld,
#ifdef X_V_X_RRNO
                              X_V_X_RRNO,
#else
                              0,
#endif
                              BLANK,
                              pX_NULL,
                              &sRetLength,
                              vchString );
         strcat(pG->vchSqlStmnt, ".0");
      }
      sprintf( pvchBuffer + strlen(pvchBuffer)," WHERE %s = %s", pvchRRNO, vchString );
   }
#ifdef X_OAM_REPLACE_RRN_WITH_PKEY_REQUIRED 
   else
   {
      /* Append where clause of primary key for current record */

      X_OAM_Build_Primary_Key_Where(X_OAM_STANDARD_PARMS,TRUE,TRUE,fLast);
      if (pX_Ids->chFatalError == YES)
      {
         strcpy(pX_DBM->vchReturnCode,X_DBM_FATAL_ERROR);
         return;
      }
   }
#endif

   return;
}
#endif

%pcode_routines

#if ((defined(X_32BIT_COMPILER)) || (defined(X_MODULE_COMPONENT_MAIN)))
#ifdef X_OPERATING_SYSTEM_WIN31
#include <windows.h>

int CALLBACK LibMain(HINSTANCE hInstance,
                     WORD wDataSeg,
                     WORD cbHeapSize,
                     LPSTR pszCommandLine)
{
   return 1;
}

#endif

#endif

#if defined (X_OPERATING_SYSTEM_ISERIES)
/*===================================================================*/
/*                  Exit or Return from DLL                          */
/*===================================================================*/

X_SHORT_FUNCTION X_Zap_DLL(struct X_IDS *pX_Ids)
{
   exit(0);
}
#endif



